//////////////////////////////////////////////////////////////////////////////////////////////
//MAIN SOURCE FILE FOR WORLD WAR ONE MEDIC
//
//Copyright (C) 2004 by Tarn Adams.
//
// Permission to use, copy, modify and distribute this source file for any purpose is hereby
// granted without fee, provided that the above copyright notice and this permission notice
// appear in all copies.  Tarn Adams makes no representations about the suitability of this
// software for any purpose. It is provided "as is" without express or implied warranty.
//////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "keydefs.h"
#include "music_and_sound_g.h"
#include "graphics_g.h"
#include "variables.h"

using namespace std;

long version=10300;
long lowestloadscoreversion=10000;

void initialize(void);
void deinitialize(void);
musicsoundst musicsound;

#define GROUNDFLAG_CHUNKY BIT1
char groundflag[640][480];
char altitude[640][480];
bitmap_class bmp_background[6];
bitmap_class bmp_background2[6];
char first=1;
char backaffected[6];
bitmap_class bmp_unit[10];
bitmap_class bmp_plane;
bitmap_class bmp_explosion;
bitmap_class bmp_smallexp;
bitmap_class bmp_mortar[3];
bitmap_class bmp_gas[7];
bitmap_class bmp_smoke[7];
bitmap_class bmp_strafe;
bitmap_class bmp_title;
bitmap_class bmp_mgstrafe;
bitmap_class bmp_grenade[4];
bitmap_class bmp_mg[8];
bitmap_class bmp_face[2];
bitmap_class bmp_faces[2];
bitmap_class bmp_trench[2];

long timer;
struct yorderst
{
	int u,y;
};
yorderst yorder[200];
int compare(const void *a,const void *b);

enum Action
{
	ACTION_WALK_UP,
	ACTION_WALK_RIGHT,
	ACTION_WALK_DOWN,
	ACTION_WALK_LEFT,
	ACTION_STAND_UP,
	ACTION_STAND_RIGHT,
	ACTION_STAND_DOWN,
	ACTION_STAND_LEFT,
	ACTION_CRAWL_UP,
	ACTION_CRAWL_RIGHT,
	ACTION_CRAWL_DOWN,
	ACTION_CRAWL_LEFT,
	ACTION_LIE_UP,
	ACTION_LIE_RIGHT,
	ACTION_LIE_DOWN,
	ACTION_LIE_LEFT,
	ACTION_SHOVEL_RIGHT1,
	ACTION_SHOVEL_LEFT1,
	ACTION_SHOVEL_RIGHT2,
	ACTION_SHOVEL_LEFT2,
	ACTION_DODGE_RIGHT,
	ACTION_DODGE_LEFT,
	ACTION_BEHEADED,
	ACTION_SHOOT_UP,
	ACTION_SHOOT_DOWN,
	ACTION_MACHINEGUNNER_UP,
	ACTION_MACHINEGUNNER_SHOOT_UP,
	ACTION_MACHINEGUNNER_DOWN,
	ACTION_MACHINEGUNNER_SHOOT_DOWN,
	ACTION_BLOWUP,
	ACTION_BLOWAPART,
	ACTION_CHOKE,
	ACTION_HIT_DEAD_DOWN,
	ACTION_HIT_FACE_DOWN,
	ACTION_HIT_LIVE_DOWN,
	ACTION_HIT_DEAD_UP,
	ACTION_HIT_FACE_UP,
	ACTION_HIT_LIVE_UP,
	ACTION_WOUNDED,
	ACTION_WOUNDED_CHOKE,
	ACTION_BANDAGE,
	ACTION_CLIMB_UP,
	ACTION_CLIMB_DOWN,
	ACTION_CHUCK_UP,
	ACTION_CHUCK_DOWN,
	ACTIONNUM
};

enum UnitType
{
	UNIT_GERMAN,
	UNIT_ALLY,
	UNIT_GERMAN_MEDIC,
	UNIT_ALLY_MEDIC,
	UNITNUM
};

enum Projs
{
	PROJ_CHUNK,
	PROJ_GRENADE,
	PROJ_BULLET,
	PROJ_PLANE,
	PROJ_EXPLOSION,
	PROJ_SMALLEXP,
	PROJ_MORTAR,
	PROJ_MORTAR_GAS,
	PROJ_GAS,
	PROJ_STRAFE,
	PROJ_MGSTRAFE,
	PROJ_SMOKE,
	PROJNUM
};

struct projst
{
	unsigned char color[3];
	int type;
	float x,y,z;
	float ox,oy,oz;
	float vx,vy,vz;
	int duration;
	int owner;
	char strafe;
	char bomb;
	short start;
	char stainer;
	char side;

	projst()
		{
		stainer=0;
		}
};
vector<projst *> proj;

long ucurrentid=0;

struct scorest
{
	long score;
	short death;
	char name[3];
};

#define SCORENUM 20
scorest score[SCORENUM];
scorest curscore;

enum Death
{
	DEATH_SHOT_W,
	DEATH_SHOT_F,
	DEATH_SHOT_D,
	DEATH_MGSHOT_W,
	DEATH_MGSHOT_F,
	DEATH_MGSHOT_D,
	DEATH_SHOVEL_BH,
	DEATH_SHOVEL_F,
	DEATH_SHOVEL_D,
	DEATH_MORTAR_BU,
	DEATH_MORTAR_BA,
	DEATH_MORTAR_W,
	DEATH_MORTAR_F,
	DEATH_MORTAR_D,
	DEATH_GRENADE_BA,
	DEATH_GRENADE_W,
	DEATH_GRENADE_F,
	DEATH_GRENADE_D,
	DEATH_GAS,
	DEATH_BOMB_BU,
	DEATH_BOMB_BA,
	DEATH_BOMB_W,
	DEATH_BOMB_F,
	DEATH_BOMB_D,
	DEATH_STRAFE_BA,
	DEATH_STRAFE_W,
	DEATH_STRAFE_F,
	DEATH_STRAFE_D,
	DEATH_POW,
	DEATH_GRENADE_BA_F,
	DEATH_GRENADE_W_F,
	DEATH_GRENADE_F_F,
	DEATH_GRENADE_D_F,
	DEATH_SHOT_W_F,
	DEATH_SHOT_F_F,
	DEATH_SHOT_D_F,
	DEATH_MGSHOT_W_F,
	DEATH_MGSHOT_F_F,
	DEATH_MGSHOT_D_F,
	DEATHNUM,
};

int lastplane=0;
int chargetimer=100;

struct unitst
{
	short type;
	int x,y;
	int targx,targy;
	int action;
	int phase;
	char dir;
	char bandaged;
	char dead,disappear;
	short timer;
	long id;
	int sweepmod;
	char tired;
	long targid;
	long shotattime;
	int burdened;
	short burden_timer;
	short burdenact;
	char invincible;

	unitst()
		{
		invincible=0;
		burdened=0;
		tired=0;
		if(random(10))dir=1;
		else dir=0;
		bandaged=0;
		dead=0;
		disappear=0;
		id=ucurrentid;ucurrentid++;
		sweepmod=0;
		shotattime=10000;
		}
};
vector<unitst *> unit;
char machinegun[2][3];
int machinegunx[2][3];
int machinegunx2[2][3];
unitst *machinegununit[2][3];
unitst *you=NULL;
long deadtime=0;

short charge;
char won=0;
int wonx=0,wony=0,wonscroll=0;
char wondir=random(2);

enum GuyFrames
{
	GUY_DOWN_AIM_HIDDEN,
	GUY_DOWN_WALK1,
	GUY_DOWN_WALK2,
	GUY_DOWN_WALK3,
	GUY_DOWN_WALK4,
	GUY_DOWN_CLIMB,

	GUY_UP_AIM,
	GUY_UP_WALK1,
	GUY_UP_WALK2,
	GUY_UP_WALK3,
	GUY_UP_WALK4,
	GUY_UP_CLIMB,

	GUY_DOWN_HIT,
	GUY_HIT2,
	GUY_HIT3,
	GUY_HIT4,
	GUY_HIT3_BANDAGED,
	GUY_HIT4_BANDAGED,

	GUY_DOWN_FACED,
	GUY_FACED2,
	GUY_FACED3,
	GUY_UP_FACED,
	GUY_DOWN_CHUCK1,
	GUY_DOWN_CHUCK2,

	GUY_DOWN_AIM,
	GUY_DOWN_SHOOT,
	GUY_DOWN_SHOOT_HIDDEN,
	GUY_UP_SHOOT,
	GUY_UP_CHUCK1,
	GUY_UP_CHUCK2,

	GUY_STRANGLE1,
	GUY_STRANGLE2,
	GUY_STRANGLE3,
	GUY_STRANGLE4,
	GUY_BEHEADED1,
	GUY_BEHEADED2,

	//NEXT FILE
	GUY_DOWN_CLIMB2,
	GUY_RIGHT_STAND,
	GUY_RIGHT_WALK1,
	GUY_RIGHT_WALK2,
	GUY_RIGHT_WALK3,
	GUY_RIGHT_WALK4,

	GUY_UP_CLIMB2,
	GUY_LEFT_STAND,
	GUY_LEFT_WALK1,
	GUY_LEFT_WALK2,
	GUY_LEFT_WALK3,
	GUY_LEFT_WALK4,

	GUY_UP_HIT,
	GUY_SHOVEL1,
	GUY_SHOVEL2,
	GUY_SHOVEL3,
	GUY_SHOVEL4,
	GUY_RIGHT_DODGE,

	GUY_BLOWAPART1,
	GUY_BLOWAPART2,
	GUY_BLOWAPART3,
	GUY_BLOWUP1,
	GUY_BLOWUP2,
	GUY_LEFT_DODGE,

	GUY_UP_CRAWL1,
	GUY_UP_CRAWL2,
	GUY_UP_CRAWL3,
	GUY_RIGHT_CRAWL1,
	GUY_RIGHT_CRAWL2,
	GUY_RIGHT_CRAWL3,

	GUY_DOWN_CRAWL1,
	GUY_DOWN_CRAWL2,
	GUY_DOWN_CRAWL3,
	GUY_LEFT_CRAWL1,
	GUY_LEFT_CRAWL2,
	GUY_LEFT_CRAWL3,

	//NEXT FILE
	GUY_CLIMB1_H,
	GUY_RIGHT_STAND_H,
	GUY_RIGHT_WALK1_H,
	GUY_RIGHT_WALK2_H,
	GUY_RIGHT_WALK3_H,
	GUY_RIGHT_WALK4_H,

	GUY_CLIMB2_H,
	GUY_LEFT_STAND_H,
	GUY_LEFT_WALK1_H,
	GUY_LEFT_WALK2_H,
	GUY_LEFT_WALK3_H,
	GUY_LEFT_WALK4_H,

	GUY_DOWN_STAND_H,
	GUY_DOWN_WALK1_H,
	GUY_DOWN_WALK2_H,
	GUY_DOWN_WALK3_H,
	GUY_DOWN_WALK4_H,
	GUY_BANDAGE1,

	GUY_UP_STAND_H,
	GUY_UP_WALK1_H,
	GUY_UP_WALK2_H,
	GUY_UP_WALK3_H,
	GUY_UP_WALK4_H,
	GUY_BANDAGE2,

	GUY_UP_CRAWL1_H,
	GUY_UP_CRAWL2_H,
	GUY_UP_CRAWL3_H,
	GUY_RIGHT_CRAWL1_H,
	GUY_RIGHT_CRAWL2_H,
	GUY_RIGHT_CRAWL3_H,

	GUY_DOWN_CRAWL1_H,
	GUY_DOWN_CRAWL2_H,
	GUY_DOWN_CRAWL3_H,
	GUY_LEFT_CRAWL1_H,
	GUY_LEFT_CRAWL2_H,
	GUY_LEFT_CRAWL3_H
};

struct tagst
{
	unsigned char color[3];
	char str[80];
	float x,y;
	float vx,vy;
	short duration;
};
vector<tagst *> tag;

void preparescreen_title(void);
void preparescreen_game(void);
void preparescreen_bonus(void);
void preparescreen_highscores(void);
void advancegame(void);
void bonus(void);
void printguy(unitst &u);
void printguyframe(int type,int f,int x,int y,char dir);
void prepbattlefield(void);
void shoot(unitst &u);
void saveguypicture(unitst &u);
void colorground(unsigned char color[3],int x,int y);
char hitunit(projst &p,unitst &u);
void deathswath(int x,int y,char powerful,char side);
void strafe(int x,int y);
void clearmgun(unitst &u);
void commandmedic(WPARAM wParam);
void addscore(int sc,int x,int y);

//TITLE MODE STUFF
int titley=500;

//BONUS MODE STUFF
int ycount=0;
int gcount=0;
int trenches=0;
int trenches_cur=0;
int ycount_cur=0;
int gcount_cur=0;
int ycount_bat=0;
int gcount_bat=0;
long bonusdrip=0;
char bbeep=0;
char havebonus=0;
int ymediccount=0;
int gmediccount=0;

//SCORE FUNCTIONS
short yourscore;
char entering;
short enterslot;
void loadhighscores(void);
void savehighscores(void);

short mode=0;

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	//SET UP RANDOM NUMBERS
	seed=GetTickCount();

	MSG msg;
	BOOL isDone;

	if (SetupWindow("WWI Medic", 640, 480, 32, FALSE))
		isDone = FALSE;
	else
		isDone = TRUE;

	musicsound.on=1;
	initialize();
	loadhighscores();

	// main message loop
	while(!isDone)
		{
		if(PeekMessage(&msg, g_hwnd, NULL, NULL, PM_REMOVE))
			{
			if(msg.message==WM_QUIT)   // do we receive a WM_QUIT message?
				{
				isDone=TRUE;              // if so, time to quit the application
				}
			else
				{
				TranslateMessage(&msg);     // translate and dispatch to event queue
				DispatchMessage(&msg);
				}
			}

		timer=GetTickCount();

		switch(mode)
			{
			case 0:
				while(timer+30>GetTickCount()&&timer<=GetTickCount());
				if(titley>0)titley-=5;
				break;
			case 1:
				advancegame();
				if(curscore.death!=-1&&deadtime>0)deadtime+=3;
				if(deadtime>=100)
					{
					mode=2;
					}
				break;
			case 2:
				bonus();
				break;
			}

		// don't update the scene if the app is minimized
		if(g_isActive)
			{
			switch(mode)
				{
				case 0:
					preparescreen_title();
					break;
				case 1:
					preparescreen_game();
					break;
				case 2:
					preparescreen_bonus();
					break;
				case 3:
					preparescreen_highscores();
					break;
				}
			printscreen();

			if(bbeep==4)Beep(440,100);
			if(bbeep==1||bbeep==3)Beep(300,100);
			if(bbeep==2)Beep(1000,30);
			if(bbeep==3)Beep(100,300);
			bbeep=0;
			}
		}

	deinitialize();

	Cleanup();

	KillWindow();

	return msg.wParam;
}

void initialize(void)
{
	initsound();

	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);

	for(int u=0;u<10;u++)
		{
		switch(u)
			{
			case 0:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//german.bmp", &bmp_unit[u].info);break;
			case 1:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//german2.bmp", &bmp_unit[u].info);break;
			case 2:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//germanmedic.bmp", &bmp_unit[u].info);break;
			case 3:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//germanmedic2.bmp", &bmp_unit[u].info);break;
			case 4:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//germanmedic3.bmp", &bmp_unit[u].info);break;
			case 5:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//ally.bmp", &bmp_unit[u].info);break;
			case 6:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//ally2.bmp", &bmp_unit[u].info);break;
			case 7:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//allymedic.bmp", &bmp_unit[u].info);break;
			case 8:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//allymedic2.bmp", &bmp_unit[u].info);break;
			case 9:bmp_unit[u].data=LoadBitmapFileWithAlpha("art//allymedic3.bmp", &bmp_unit[u].info);break;
			}
		glGenTextures(1,&bmp_unit[u].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_unit[u].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_unit[u].info.biWidth,bmp_unit[u].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_unit[u].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	bmp_plane.data=LoadBitmapFileWithAlpha("art//plane.bmp", &bmp_plane.info);

	for(int d=0;d<128*128*4;d+=4)
		{
		if(bmp_plane.data[d+3])
			{
			bmp_plane.data[d]=0;
			bmp_plane.data[d+1]=0;
			bmp_plane.data[d+2]=0;
			bmp_plane.data[d+3]=100;
			}
		}

	glGenTextures(1,&bmp_plane.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_plane.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
			 bmp_plane.info.biWidth,bmp_plane.info.biHeight,
			 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_plane.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	bmp_explosion.data=LoadBitmapFileWithAlpha("art//explosion.bmp", &bmp_explosion.info);
	glGenTextures(1,&bmp_explosion.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_explosion.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
			 bmp_explosion.info.biWidth,bmp_explosion.info.biHeight,
			 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_explosion.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	bmp_smallexp.data=LoadBitmapFileWithAlpha("art//smallexp.bmp", &bmp_smallexp.info);
	glGenTextures(1,&bmp_smallexp.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_smallexp.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
			 bmp_smallexp.info.biWidth,bmp_smallexp.info.biHeight,
			 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_smallexp.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	bmp_strafe.data=LoadBitmapFileWithAlpha("art//strafe.bmp", &bmp_strafe.info);
	glGenTextures(1,&bmp_strafe.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_strafe.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
			 bmp_strafe.info.biWidth,bmp_strafe.info.biHeight,
			 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_strafe.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	bmp_mgstrafe.data=LoadBitmapFileWithAlpha("art//mgstrafe.bmp", &bmp_mgstrafe.info);
	glGenTextures(1,&bmp_mgstrafe.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_mgstrafe.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
			 bmp_mgstrafe.info.biWidth,bmp_mgstrafe.info.biHeight,
			 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_mgstrafe.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	for(int m=0;m<3;m++)
		{
		switch(m)
			{
			case 0:bmp_mortar[m].data=LoadBitmapFileWithAlpha("art//mortar1.bmp", &bmp_mortar[m].info);break;
			case 1:bmp_mortar[m].data=LoadBitmapFileWithAlpha("art//mortar2.bmp", &bmp_mortar[m].info);break;
			case 2:bmp_mortar[m].data=LoadBitmapFileWithAlpha("art//mortar3.bmp", &bmp_mortar[m].info);break;
			}

		for(int d=0;d<16*16*4;d+=4)
			{
			if(bmp_mortar[m].data[d+3])
				{
				bmp_mortar[m].data[d]=0;
				bmp_mortar[m].data[d+1]=0;
				bmp_mortar[m].data[d+2]=0;
				bmp_mortar[m].data[d+3]=100;
				}
			}

		glGenTextures(1,&bmp_mortar[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_mortar[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_mortar[m].info.biWidth,bmp_mortar[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_mortar[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(m=0;m<8;m++)
		{
		switch(m)
			{
			case 0:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgunup_unocc.bmp", &bmp_mg[m].info);break;
			case 1:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgunup_occ.bmp", &bmp_mg[m].info);break;
			case 2:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgunup_shoot.bmp", &bmp_mg[m].info);break;
			case 3:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgunup_blasted.bmp", &bmp_mg[m].info);break;
			case 4:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgundown_unocc.bmp", &bmp_mg[m].info);break;
			case 5:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgundown_occ.bmp", &bmp_mg[m].info);break;
			case 6:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgundown_shoot.bmp", &bmp_mg[m].info);break;
			case 7:bmp_mg[m].data=LoadBitmapFileWithAlpha("art//mgundown_blasted.bmp", &bmp_mg[m].info);break;
			}

		glGenTextures(1,&bmp_mg[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_mg[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_mg[m].info.biWidth,bmp_mg[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_mg[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(m=0;m<2;m++)
		{
		switch(m)
			{
			case 0:bmp_face[m].data=LoadBitmapFileWithAlpha("art//face1.bmp", &bmp_face[m].info);break;
			case 1:bmp_face[m].data=LoadBitmapFileWithAlpha("art//face2.bmp", &bmp_face[m].info);break;
			}

		glGenTextures(1,&bmp_face[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_face[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_face[m].info.biWidth,bmp_face[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_face[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(m=0;m<2;m++)
		{
		switch(m)
			{
			case 0:bmp_faces[m].data=LoadBitmapFileWithAlpha("art//face1s.bmp", &bmp_faces[m].info);break;
			case 1:bmp_faces[m].data=LoadBitmapFileWithAlpha("art//face2s.bmp", &bmp_faces[m].info);break;
			}

		glGenTextures(1,&bmp_faces[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_faces[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_faces[m].info.biWidth,bmp_faces[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_faces[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(m=0;m<2;m++)
		{
		switch(m)
			{
			case 0:bmp_trench[m].data=LoadBitmapFileWithAlpha("art//trench.bmp", &bmp_trench[m].info);break;
			case 1:bmp_trench[m].data=LoadBitmapFileWithAlpha("art//trenchs.bmp", &bmp_trench[m].info);break;
			}

		glGenTextures(1,&bmp_trench[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_trench[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_trench[m].info.biWidth,bmp_trench[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_trench[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(m=0;m<4;m++)
		{
		switch(m)
			{
			case 0:bmp_grenade[m].data=LoadBitmapFileWithAlpha("art//grenade1.bmp", &bmp_grenade[m].info);break;
			case 1:bmp_grenade[m].data=LoadBitmapFileWithAlpha("art//grenade2.bmp", &bmp_grenade[m].info);break;
			case 2:bmp_grenade[m].data=LoadBitmapFileWithAlpha("art//grenade3.bmp", &bmp_grenade[m].info);break;
			case 3:bmp_grenade[m].data=LoadBitmapFileWithAlpha("art//grenade4.bmp", &bmp_grenade[m].info);break;
			}

		glGenTextures(1,&bmp_grenade[m].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_grenade[m].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_grenade[m].info.biWidth,bmp_grenade[m].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_grenade[m].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(int g=0;g<7;g++)
		{
		switch(g)
			{
			case 0:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas1.bmp", &bmp_gas[g].info);break;
			case 1:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas2.bmp", &bmp_gas[g].info);break;
			case 2:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas3.bmp", &bmp_gas[g].info);break;
			case 3:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas4.bmp", &bmp_gas[g].info);break;
			case 4:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas5.bmp", &bmp_gas[g].info);break;
			case 5:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas6.bmp", &bmp_gas[g].info);break;
			case 6:bmp_gas[g].data=LoadBitmapFileWithAlpha("art//mustardgas7.bmp", &bmp_gas[g].info);break;
			}

		for(int d=0;d<32*32*4;d+=4)
			{
			if(bmp_gas[g].data[d+3])
				{
				bmp_gas[g].data[d+3]=75;
				}
			}

		glGenTextures(1,&bmp_gas[g].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_gas[g].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_gas[g].info.biWidth,bmp_gas[g].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_gas[g].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(g=0;g<7;g++)
		{
		switch(g)
			{
			case 0:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas1.bmp", &bmp_smoke[g].info);break;
			case 1:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas2.bmp", &bmp_smoke[g].info);break;
			case 2:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas3.bmp", &bmp_smoke[g].info);break;
			case 3:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas4.bmp", &bmp_smoke[g].info);break;
			case 4:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas5.bmp", &bmp_smoke[g].info);break;
			case 5:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas6.bmp", &bmp_smoke[g].info);break;
			case 6:bmp_smoke[g].data=LoadBitmapFileWithAlpha("art//mustardgas7.bmp", &bmp_smoke[g].info);break;
			}

		for(int d=0;d<32*32*4;d+=4)
			{
			if(bmp_smoke[g].data[d+3])
				{
				bmp_smoke[g].data[d+1]=bmp_smoke[g].data[d];
				bmp_smoke[g].data[d+2]=bmp_smoke[g].data[d];
				bmp_smoke[g].data[d+3]=75;
				}
			}

		glGenTextures(1,&bmp_smoke[g].gennum);
		glBindTexture(GL_TEXTURE_2D,bmp_smoke[g].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8,
				 bmp_smoke[g].info.biWidth,bmp_smoke[g].info.biHeight,
				 0,GL_RGBA,GL_UNSIGNED_BYTE,bmp_smoke[g].data);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		}

	for(int s=0;s<SCORENUM;s++)
		{
		score[s].death=-1;
		if(s<=4)
			{
			score[s].score=(5-s)*200;
			score[s].name[0]='Z';
			score[s].name[1]='A';
			score[s].name[2]='T';
			}
		else
			{
			score[s].score=0;
			score[s].name[0]='-';
			score[s].name[1]='-';
			score[s].name[2]='-';
			}
		}
	curscore.score=0;
	curscore.death=-1;

	bmp_title.data=LoadBitmapFile("art//title.bmp", &bmp_title.info);
	glGenTextures(1,&bmp_title.gennum);
	glBindTexture(GL_TEXTURE_2D,bmp_title.gennum);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
			 bmp_title.info.biWidth,bmp_title.info.biHeight,
			 0,GL_RGB,GL_UNSIGNED_BYTE,bmp_title.data);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

	prepbattlefield();
}

void deinitialize(void)
{
	deinitsound();

	for(int u=0;u<10;u++)if(bmp_unit[u].data!=NULL)delete bmp_unit[u].data;
	for(int b=0;b<6;b++)if(bmp_background[b].data!=NULL)delete bmp_background[b].data;
	for(b=0;b<6;b++)if(bmp_background2[b].data!=NULL)delete bmp_background2[b].data;
	if(bmp_plane.data!=NULL)delete bmp_plane.data;
	if(bmp_explosion.data!=NULL)delete bmp_explosion.data;
	if(bmp_smallexp.data!=NULL)delete bmp_smallexp.data;
	for(int m=0;m<3;m++)if(bmp_mortar[m].data!=NULL)delete bmp_mortar[m].data;
	for(int g=0;g<7;g++)if(bmp_gas[g].data!=NULL)delete bmp_gas[g].data;
	for(g=0;g<7;g++)if(bmp_smoke[g].data!=NULL)delete bmp_smoke[g].data;
	for(g=0;g<4;g++)if(bmp_grenade[g].data!=NULL)delete bmp_grenade[g].data;
	if(bmp_strafe.data!=NULL)delete bmp_strafe.data;
	if(bmp_mgstrafe.data!=NULL)delete bmp_mgstrafe.data;
	for(b=0;b<8;b++)if(bmp_mg[b].data!=NULL)delete bmp_mg[b].data;
	if(bmp_title.data!=NULL)delete bmp_title.data;
	for(b=0;b<2;b++)if(bmp_face[b].data!=NULL)delete bmp_face[b].data;
	for(b=0;b<2;b++)if(bmp_faces[b].data!=NULL)delete bmp_faces[b].data;
	for(b=0;b<2;b++)if(bmp_trench[b].data!=NULL)delete bmp_trench[b].data;
}

void preparescreen_game()
{
	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);
	glEnable(GL_TEXTURE_2D);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
	else glColor3f(1,1,1);
	glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
	glLoadIdentity();					// reset projection matrix
	if(won==1)glOrtho(0.0f, 640, 479-wonscroll, -1-wonscroll, -1.0, 1.0);
	else glOrtho(0.0f, 640, 479, -1, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);			// set modelview matrix
	glLoadIdentity();					// reset modelview matrix

	//PRINT OTHER TRENCH
	if(wonscroll>0)
		{
		//PRINT FIELD
		for(int b=0;b<6;b++)
			{
			if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
			else glColor3f(1,1,1);
			glBindTexture(GL_TEXTURE_2D,bmp_background2[b].gennum);
			if(b/3==0)
				{
				glBegin(GL_QUADS);
					glTexCoord2f(0,1);
					glVertex2f(256*(b%3),-1-512);
					glTexCoord2f(0,0);
					glVertex2f(256*(b%3),255-512);
					glTexCoord2f(1,0);
					glVertex2f(256*(b%3)+256,255-512);
					glTexCoord2f(1,1);
					glVertex2f(256*(b%3)+256,-1-512);
				glEnd();
				}
			else
				{
				glBegin(GL_QUADS);
					glTexCoord2f(0,1);
					glVertex2f(256*(b%3),256*(b/3)-1-512);
					glTexCoord2f(0,0);
					glVertex2f(256*(b%3),256*(b/3)+255-512);
					glTexCoord2f(1,0);
					glVertex2f(256*(b%3)+256,256*(b/3)+255-512);
					glTexCoord2f(1,1);
					glVertex2f(256*(b%3)+256,256*(b/3)-1-512);
				glEnd();
				}
			}

		//PRINT MACHINE GUNS
		for(int s=0;s<2;s++)
			{
			for(int g=0;g<3;g++)
				{
				glBindTexture(GL_TEXTURE_2D,bmp_mg[s*4].gennum);
				glBegin(GL_QUADS);
					glTexCoord2f(0,1);
					glVertex2f(machinegunx2[s][g]-16,440-s*403-17-512);
					glTexCoord2f(0,0);
					glVertex2f(machinegunx2[s][g]-16,440-s*403+15-512);
					glTexCoord2f(1,0);
					glVertex2f(machinegunx2[s][g]+15,440-s*403+15-512);
					glTexCoord2f(1,1);
					glVertex2f(machinegunx2[s][g]+15,440-s*403-17-512);
				glEnd();
				}
			}

		//PRINT UNITS
		for(int u=0;u<unit.size();u++)
			{
			if(unit[u]->invincible)
				{
				switch(unit[u]->action)
					{
					case ACTION_STAND_UP:
						printguyframe(UNIT_GERMAN,GUY_UP_AIM,unit[u]->x-19,unit[u]->y-512,unit[u]->dir);
						break;
					case ACTION_STAND_RIGHT:
						printguyframe(UNIT_GERMAN,GUY_RIGHT_STAND,unit[u]->x-19,unit[u]->y-512,unit[u]->dir);
						break;
					case ACTION_STAND_DOWN:
						printguyframe(UNIT_GERMAN,GUY_DOWN_AIM,unit[u]->x-19,unit[u]->y-512,unit[u]->dir);
						break;
					case ACTION_STAND_LEFT:
						printguyframe(UNIT_GERMAN,GUY_LEFT_STAND,unit[u]->x-19,unit[u]->y-512,unit[u]->dir);
						break;
					}
				}
			}
		}

	//PRINT BACK OF TOP TRENCH
	for(int b=0;b<3;b++)
		{
		if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
		else glColor3f(1,1,1);
		glBindTexture(GL_TEXTURE_2D,bmp_background[b].gennum);
		glBegin(GL_QUADS);
			glTexCoord2f(0,1);
			glVertex2f(256*(b%3),-1);
			glTexCoord2f(0,.85f);
			glVertex2f(256*(b%3),36);
			glTexCoord2f(1,.85f);
			glVertex2f(256*(b%3)+256,36);
			glTexCoord2f(1,1);
			glVertex2f(256*(b%3)+256,-1);
		glEnd();
		}

	//PRINT BACK GUYS
	for(int u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->y<=21&&
			(unit[u]->action!=ACTION_STAND_DOWN||
			unit[u]->type==UNIT_GERMAN_MEDIC||
			unit[u]->type==UNIT_ALLY_MEDIC))
			{
			printguy(*unit[u]);
			}
		}

	//PRINT FIELD
	for(b=0;b<6;b++)
		{
		if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
		else glColor3f(1,1,1);
		glBindTexture(GL_TEXTURE_2D,bmp_background[b].gennum);
		if(b/3==0)
			{
			glBegin(GL_QUADS);
				glTexCoord2f(0,.85f);
				glVertex2f(256*(b%3),36);
				glTexCoord2f(0,0);
				glVertex2f(256*(b%3),255);
				glTexCoord2f(1,0);
				glVertex2f(256*(b%3)+256,255);
				glTexCoord2f(1,.85f);
				glVertex2f(256*(b%3)+256,36);
			glEnd();
			}
		else
			{
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(256*(b%3),256*(b/3)-1);
				glTexCoord2f(0,0);
				glVertex2f(256*(b%3),256*(b/3)+255);
				glTexCoord2f(1,0);
				glVertex2f(256*(b%3)+256,256*(b/3)+255);
				glTexCoord2f(1,1);
				glVertex2f(256*(b%3)+256,256*(b/3)-1);
			glEnd();
			}
		}

	//PRINT MACHINE GUNS
	for(int s=0;s<2;s++)
		{
		for(int g=0;g<3;g++)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_mg[s*4+machinegun[s][g]].gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(machinegunx[s][g]-16,440-s*403-17);
				glTexCoord2f(0,0);
				glVertex2f(machinegunx[s][g]-16,440-s*403+15);
				glTexCoord2f(1,0);
				glVertex2f(machinegunx[s][g]+15,440-s*403+15);
				glTexCoord2f(1,1);
				glVertex2f(machinegunx[s][g]+15,440-s*403-17);
			glEnd();
			}
		}

	//PRINT OTHERS BASE ON ACTION/Y ORDER
	int slot=0;
	for(u=0;u<200;u++)
		{
		yorder[u].u=-1;
		yorder[u].y=-1;
		}
	for(u=0;u<unit.size()&&u<200;u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->y>21||
			(unit[u]->action==ACTION_STAND_DOWN&&
			unit[u]->type!=UNIT_GERMAN_MEDIC&&
			unit[u]->type!=UNIT_ALLY_MEDIC))
			{
			if(slot<200)
				{
				if(unit[u]->action==ACTION_WOUNDED||
					unit[u]->action==ACTION_WOUNDED_CHOKE||
					unit[u]->action==ACTION_CHOKE)
					{
					yorder[slot].u=u;
					yorder[slot].y=0;
					slot++;
					}
				else if(unit[u]->action==ACTION_CRAWL_DOWN||
						unit[u]->action==ACTION_CRAWL_UP||
						unit[u]->action==ACTION_CRAWL_LEFT||
						unit[u]->action==ACTION_CRAWL_RIGHT||
						unit[u]->action==ACTION_LIE_DOWN||
						unit[u]->action==ACTION_LIE_UP||
						unit[u]->action==ACTION_LIE_LEFT||
						unit[u]->action==ACTION_LIE_RIGHT)
					{
					yorder[slot].u=u;
					yorder[slot].y=1;
					slot++;
					}
				else
					{
					yorder[slot].u=u;
					yorder[slot].y=unit[u]->y;
					slot++;
					}
				}
			}
		}
	qsort(yorder,200,sizeof(yorderst),compare);
	for(u=0;u<200;u++)
		{
		if(yorder[u].u!=-1)
			{
			printguy(*unit[yorder[u].u]);
			}
		}

	//PROJS
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);

	glBegin(GL_LINES);
	for(int p=0;p<proj.size();p++)
		{
		if(proj[p]->type==PROJ_BULLET)
			{
			glColor3ubv(proj[p]->color);
			glVertex2f(proj[p]->x,proj[p]->y-proj[p]->z);
			glVertex2f((proj[p]->ox+proj[p]->x)*.5f,
				(proj[p]->oy+proj[p]->y-proj[p]->z-proj[p]->oz)*.5f);
			}
		}
	glEnd();

	glBegin(GL_POINTS);
	for(p=0;p<proj.size();p++)
		{
		if(proj[p]->type==PROJ_CHUNK)
			{
			glColor3ubv(proj[p]->color);
			glVertex2f(proj[p]->x,proj[p]->y-proj[p]->z);
			}
		}
	glEnd();

	//GRENADES
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);
	if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
	else glColor3f(1,1,1);

	for(p=0;p<proj.size();p++)
		{
		if(proj[p]->type==PROJ_GRENADE)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_grenade[proj[p]->duration%4].gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-4,proj[p]->y-5-proj[p]->z);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-4,proj[p]->y+3-proj[p]->z);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+3,proj[p]->y+3-proj[p]->z);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+3,proj[p]->y-5-proj[p]->z);
			glEnd();
			}
		}

	//CLOUDS AND EXPLOSIONS
	int frame;
	for(p=0;p<proj.size();p++)
		{
		if(proj[p]->type==PROJ_GAS)
			{
			if(proj[p]->duration<=15)frame=6;
			else if(proj[p]->duration<=30)frame=5;
			else if(proj[p]->duration<=45)frame=4;
			else if(proj[p]->duration<=50)frame=3;
			else if(proj[p]->duration<=65)frame=2;
			else if(proj[p]->duration<=80)frame=1;
			else if(proj[p]->duration<=105)frame=0;
			else if(proj[p]->duration<=120)frame=2;
			else if(proj[p]->duration<=135)frame=1;
			else frame=0;

			int span=proj[p]->start;
			if(span>15)span=15;

			float billow=0;
			if(proj[p]->y>429)billow=(proj[p]->y-429)*.5f;

			glBindTexture(GL_TEXTURE_2D,bmp_gas[frame].gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-1-span,proj[p]->y-2-span+billow);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-1-span,proj[p]->y+span+billow-1);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+span,proj[p]->y+span+billow-1);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+span,proj[p]->y-2-span+billow);
			glEnd();
			}

		if(proj[p]->type==PROJ_SMOKE)
			{
			if(proj[p]->duration<=15)frame=6;
			else if(proj[p]->duration<=30)frame=5;
			else if(proj[p]->duration<=45)frame=4;
			else if(proj[p]->duration<=50)frame=3;
			else if(proj[p]->duration<=65)frame=2;
			else if(proj[p]->duration<=80)frame=1;
			else if(proj[p]->duration<=105)frame=0;
			else if(proj[p]->duration<=120)frame=2;
			else if(proj[p]->duration<=135)frame=1;
			else frame=0;

			float billow=0;
			if(proj[p]->y>429)billow=(proj[p]->y-429)*.5f;

			glBindTexture(GL_TEXTURE_2D,bmp_smoke[frame].gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-15,proj[p]->y-17+billow);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-15,proj[p]->y+15+billow);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+16,proj[p]->y+15+billow);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+16,proj[p]->y-17+billow);
			glEnd();
			}

		if(proj[p]->type==PROJ_EXPLOSION)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_explosion.gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-32,proj[p]->y-33);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-32,proj[p]->y+31);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+31,proj[p]->y+31);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+31,proj[p]->y-33);
			glEnd();
			}

		if(proj[p]->type==PROJ_SMALLEXP)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_smallexp.gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-16,proj[p]->y-17);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-16,proj[p]->y+15);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+15,proj[p]->y+15);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+15,proj[p]->y-17);
			glEnd();
			}
		
		if(proj[p]->type==PROJ_STRAFE)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_strafe.gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-8,proj[p]->y-9);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-8,proj[p]->y+7);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+7,proj[p]->y+7);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+7,proj[p]->y-9);
			glEnd();
			}
		
		if(proj[p]->type==PROJ_MGSTRAFE)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_mgstrafe.gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-8,proj[p]->y-9);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-8,proj[p]->y+7);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+7,proj[p]->y+7);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+7,proj[p]->y-9);
			glEnd();
			}
		}

	//SHADOWS
	for(p=0;p<proj.size();p++)
		{
		if(proj[p]->type==PROJ_MORTAR||proj[p]->type==PROJ_MORTAR_GAS)
			{
			if(proj[p]->duration<0)continue;
			else if(proj[p]->duration<=15)frame=0;
			else if(proj[p]->duration<=30)frame=1;
			else frame=2;
			glBindTexture(GL_TEXTURE_2D,bmp_mortar[frame].gennum);
			glBegin(GL_QUADS);
				glTexCoord2f(0,1);
				glVertex2f(proj[p]->x-8,proj[p]->y-9);
				glTexCoord2f(0,0);
				glVertex2f(proj[p]->x-8,proj[p]->y+6);
				glTexCoord2f(1,0);
				glVertex2f(proj[p]->x+7,proj[p]->y+6);
				glTexCoord2f(1,1);
				glVertex2f(proj[p]->x+7,proj[p]->y-9);
			glEnd();
			}
		if(proj[p]->type==PROJ_PLANE)
			{
			glBindTexture(GL_TEXTURE_2D,bmp_plane.gennum);
			glBegin(GL_QUADS);
				if(proj[p]->vx<0)
					{
					glTexCoord2f(1,1);
					glVertex2f(proj[p]->x-64,proj[p]->y-65);
					glTexCoord2f(1,0);
					glVertex2f(proj[p]->x-64,proj[p]->y+63);
					glTexCoord2f(0,0);
					glVertex2f(proj[p]->x+63,proj[p]->y+63);
					glTexCoord2f(0,1);
					glVertex2f(proj[p]->x+63,proj[p]->y-65);
					}
				else
					{
					glTexCoord2f(0,1);
					glVertex2f(proj[p]->x-64,proj[p]->y-65);
					glTexCoord2f(0,0);
					glVertex2f(proj[p]->x-64,proj[p]->y+63);
					glTexCoord2f(1,0);
					glVertex2f(proj[p]->x+63,proj[p]->y+63);
					glTexCoord2f(1,1);
					glVertex2f(proj[p]->x+63,proj[p]->y-65);
					}
			glEnd();
			}
		}

	//WIN STUFF
	if(won==1)
		{
		if(wonscroll==0)
			{
			printguyframe(UNIT_ALLY_MEDIC,GUY_UP_WALK1,wonx-19,wony,wondir);
			}
		else
			{
			if(wonscroll%4==0)printguyframe(UNIT_ALLY_MEDIC,GUY_UP_WALK1,wonx-19,wony-wonscroll,wondir);
			else if(wonscroll%4==1)printguyframe(UNIT_ALLY_MEDIC,GUY_UP_WALK2,wonx-19,wony-wonscroll,wondir);
			else if(wonscroll%4==2)printguyframe(UNIT_ALLY_MEDIC,GUY_UP_WALK3,wonx-19,wony-wonscroll,wondir);
			else if(wonscroll%4==3)printguyframe(UNIT_ALLY_MEDIC,GUY_UP_WALK4,wonx-19,wony-wonscroll,wondir);
			}
		}

	//TAGS
	glDisable(GL_TEXTURE_2D);
	for(int t=tag.size()-1;t>=0;t--)
		{
		tag[t]->x+=tag[t]->vx;
		tag[t]->y+=tag[t]->vy;
		tag[t]->duration+=3;
		if(tag[t]->duration>100)tag[t]->duration=100;
		unsigned char alpha=(unsigned char)((int)((100-(int)tag[t]->duration)*255)/100);
		glColor4ub(tag[t]->color[0],tag[t]->color[1],tag[t]->color[2],alpha);
		glRasterPos2i(tag[t]->x,tag[t]->y);
		PrintString(fontlist,tag[t]->str);

		if(tag[t]->duration>=100)
			{
			delete tag[t];
			tag.erase(t);
			}
		}

	//INFO
	if(curscore.score>score[0].score)
		{
		glColor3ub(random(256),random(256),random(256));
		}
	else glColor3f(1,1,1);

	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);
	char str[80],num[20];
	strcpy(str,"SCORE:");
	glRasterPos2i(520,20-wonscroll);
	PrintString(fontlist3,str);
	itoa(curscore.score,num,10);
	glRasterPos2i(570,20-wonscroll);
	PrintString(fontlist3,num);

	strcpy(str,"HIGH:");
	glRasterPos2i(520,10-wonscroll);
	PrintString(fontlist3,str);
	if(curscore.score>score[0].score)itoa(curscore.score,num,10);
	else itoa(score[0].score,num,10);
	glRasterPos2i(570,10-wonscroll);
	PrintString(fontlist3,num);

	if(curscore.death!=-1&&deadtime==0)
		{
		glColor3ub(255,random(256),0);
		strcpy(str,"It's over.  Press T to continue.");
		glRasterPos2i(260,10);
		PrintString(fontlist3,str);
		}
}

long FAR PASCAL WindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch(message)
		{
		case WM_KEYDOWN:
			{
			switch(mode)
				{
				//TITLE
				case 0:
					if(titley>0)titley=0;
					else mode=1;
					break;
				//GAME
				case 1:
					if(won!=1)commandmedic(wParam);
					break;
				//BONUS SCREEN
				case 2:
					if(ycount_cur==ycount&&gcount_cur==gcount&&
						trenches_cur==trenches&&
						bonusdrip==0)
						{
						savehighscores();
						mode=3;
						}
					break;
				//HIGH SCORES
				case 3:
					if(entering)
						{
						if(wParam>='A'&&wParam<='Z')
							{
							score[yourscore].name[enterslot]=wParam;
							enterslot++;
							if(enterslot==3)enterslot=2;
							}
						if(wParam==VK_SPACE)
							{
							score[yourscore].name[enterslot]=' ';
							enterslot++;
							if(enterslot==3)enterslot=2;
							}
						if(wParam==VK_RETURN)
							{
							DWORD numbytes;
							HANDLE h=CreateFile("score.dat",GENERIC_READ|GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);

							if(h!=INVALID_HANDLE_VALUE)
								{
								WriteFile(h,&version,sizeof(unsigned long),&numbytes,NULL);

								WriteFile(h,score,sizeof(scorest)*SCORENUM,&numbytes,NULL);

								CloseHandle(h);
								}
							entering=0;
							}
						if(wParam==KEY_BACKSPACE)
							{
							score[yourscore].name[enterslot]='-';
							if(enterslot>0)enterslot--;
							}
						}
					else
						{
						deinitialize();
						Cleanup();
						KillWindow();
						exit(0);
						}
					break;
				}
			break;
			}

		case WM_ACTIVATE:  // watch for the window being minimized and restored
			{
			if (!HIWORD(wParam))
				{
				// program was restored or maximized
				g_isActive = TRUE;
				}
			else
				{
				// program was minimized
				g_isActive=FALSE;
				}

			return 0;
			}

		case WM_SYSKEYDOWN:
			return 0;

		case WM_SYSCOMMAND:  // look for screensavers and powersave mode
			{
			switch (wParam)
				{
				case SC_KEYMENU:
				case SC_SCREENSAVE:     // screensaver trying to start
				case SC_MONITORPOWER:   // monitor going to powersave mode
					{
					// returning 0 prevents either from happening
					return 0;
					}
				}
			}break;

		case WM_CLOSE:    // window is being closed
		case WM_QUIT:    // trying to quit
			{
			deinitialize();

			Cleanup();

			KillWindow();
			
			exit(0);

			return 0;
			}

		case WM_SIZE:
			{
			// update perspective with new width and height
			ResizeScene(LOWORD(lParam), HIWORD(lParam));
			return 0;
			}
		}

	return (DefWindowProc(hWnd, message, wParam, lParam));
}

void advancegame(void)
{
	while(timer+100>GetTickCount()&&timer<=GetTickCount());

	for(int i=0;i<6;i++)backaffected[i]=0;

	//WIN MOVING
	if(won==1)
		{
		if(wony<429)
			{
			wony+=5;
			if(wony>429)wony=429;
			}
		else if(wony>429)
			{
			wony-=5;
			if(wony<429)wony=429;
			}
		else if(wonx<320)
			{
			wonx+=5;
			if(wonx>320)wonx=320;
			}
		else if(wonx>320)
			{
			wonx-=5;
			if(wonx<320)wonx=320;
			}
		else
			{
			wonscroll+=3;
			if(wonscroll>=512)
				{
				prepbattlefield();
				}
			}
		}

	//REINFORCEMENTS
	int germanmax=40,allymax=40;
	if(gcount_bat>ycount_bat)allymax-=gcount_bat-ycount_bat;
	if(ycount_bat>gcount_bat)germanmax-=ycount_bat-gcount_bat;
	int count[2]={0,0};
	char emedic=0;
	char ymedic=0;
	char canreinforce[2]={1,1};
	for(int u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->type==UNIT_ALLY&&unit[u]->y<=21)canreinforce[0]=0;
		if(unit[u]->type==UNIT_GERMAN&&unit[u]->y>=429)canreinforce[1]=0;
		if(unit[u]->type==UNIT_GERMAN)count[0]++;
		if(unit[u]->type==UNIT_ALLY)count[1]++;
		if(unit[u]->type==UNIT_GERMAN_MEDIC)emedic=1;
		if(unit[u]->type==UNIT_ALLY_MEDIC&&
			unit[u]->action!=ACTION_WOUNDED&&
			unit[u]->action!=ACTION_WOUNDED_CHOKE&&
			unit[u]->action!=ACTION_CHOKE)ymedic=1;
		}
		//GERMAN MEDIC
	if(canreinforce[0]&&!emedic&&won!=1)
		{
		if(gmediccount<500)gmediccount++;
		else
			{
			unitst *newu=new unitst;
			newu->type=UNIT_GERMAN_MEDIC;
			newu->x=320;
			newu->y=-50;
			newu->action=ACTION_WALK_DOWN;
			newu->phase=0;
			unit.push_back(newu);

			gmediccount=0;
			}
		}
		//GERMAN
	if(canreinforce[0]&&count[0]<germanmax&&!random(20)&&won!=1)
		{
		//FIRST LOOK FOR GOOD X
		char xbarred[640];
		memset(xbarred,0,sizeof(char)*640);
		int bcount=20;
		for(int u=0;u<unit.size();u++)
			{
			if(unit[u]->invincible)continue;
			if(unit[u]->type==UNIT_GERMAN&&unit[u]->y==21)
				{
				for(int x=unit[u]->x-10;x<=unit[u]->x+10;x++)
					{
					if(x<10)continue;
					if(x>=630)break;
					if(!xbarred[x]){xbarred[x]=1;bcount++;}
					}
				}
			}

		if(bcount<640)
			{
			unitst *newu=new unitst;
			newu->type=UNIT_GERMAN;
			do
				{
				newu->x=random(620)+10;
				}while(xbarred[newu->x]);
				newu->y=-50;
				newu->action=ACTION_WALK_DOWN;
				newu->phase=0;
			unit.push_back(newu);
			}
		}
		//ALLY MEDIC
	if(canreinforce[0]&&!ymedic&&won!=-1)
		{
		if(ymediccount<500)ymediccount++;
		else
			{
			unitst *newu=new unitst;
			newu->type=UNIT_ALLY_MEDIC;
			newu->x=320;
			newu->y=500;
			newu->action=ACTION_WALK_UP;
			newu->phase=0;
			unit.push_back(newu);

			ymediccount=0;
			}
		}
		//ALLY
	if(canreinforce[1]&&count[1]<allymax&&!random(20)&&won!=-1)
		{
		//FIRST LOOK FOR GOOD X
		char xbarred[640];
		memset(xbarred,0,sizeof(char)*640);
		int bcount=20;
		for(int u=0;u<unit.size();u++)
			{
			if(unit[u]->invincible)continue;
			if(unit[u]->type==UNIT_ALLY&&unit[u]->y==429)
				{
				for(int x=unit[u]->x-10;x<=unit[u]->x+10;x++)
					{
					if(x<10)continue;
					if(x>=630)break;
					if(!xbarred[x]){xbarred[x]=1;bcount++;}
					}
				}
			}

		if(bcount<640)
			{
			unitst *newu=new unitst;
				newu->type=UNIT_ALLY;
			do
				{
				newu->x=random(620)+10;
				}while(xbarred[newu->x]);
				newu->y=500;
				newu->action=ACTION_WALK_UP;
				newu->phase=0;
			unit.push_back(newu);
			}
		}

	//SET UP CHARGES
	char etrench[2]={0,0};
	char ttrench[2]={0,0};
	int healthy[2]={0,0};
	for(u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->type==UNIT_ALLY||
			unit[u]->type==UNIT_ALLY_MEDIC)
			{
			if(unit[u]->y==21)
				{
				etrench[0]=1;
				if(unit[u]->type==UNIT_ALLY)ttrench[0]=1;
				}
			}
		if(unit[u]->type==UNIT_GERMAN||
			unit[u]->type==UNIT_GERMAN_MEDIC)
			{
			if(unit[u]->y==429)
				{
				etrench[1]=1;
				if(unit[u]->type==UNIT_GERMAN)ttrench[1]=1;
				}
			}
		if(unit[u]->type==UNIT_ALLY)
			{
			switch(unit[u]->action)
				{
				case ACTION_BLOWUP:
				case ACTION_BLOWAPART:
				case ACTION_BEHEADED:
				case ACTION_HIT_DEAD_UP:
				case ACTION_HIT_DEAD_DOWN:
				case ACTION_HIT_FACE_UP:
				case ACTION_HIT_FACE_DOWN:
				case ACTION_HIT_LIVE_UP:
				case ACTION_HIT_LIVE_DOWN:
				case ACTION_CHOKE:
				case ACTION_WOUNDED:
				case ACTION_WOUNDED_CHOKE:
					break;
				default:
					healthy[1]++;
					break;
				}
			}
		if(unit[u]->type==UNIT_GERMAN)
			{
			switch(unit[u]->action)
				{
				case ACTION_BLOWUP:
				case ACTION_BLOWAPART:
				case ACTION_BEHEADED:
				case ACTION_HIT_DEAD_UP:
				case ACTION_HIT_DEAD_DOWN:
				case ACTION_HIT_FACE_UP:
				case ACTION_HIT_FACE_DOWN:
				case ACTION_HIT_LIVE_UP:
				case ACTION_HIT_LIVE_DOWN:
				case ACTION_CHOKE:
				case ACTION_WOUNDED:
				case ACTION_WOUNDED_CHOKE:
					break;
				default:
					healthy[0]++;
					break;
				}
			}
		}

	if(ttrench[0]&&healthy[0]==0&&curscore.death==-1&&!won)
		{
		won=1;
		wonx=320;
		wony=429;
		wonscroll=0;
		for(int u=0;u<unit.size();u++)
			{
			if(unit[u]->invincible)continue;
			if(unit[u]==you)
				{
				wonx=you->x;
				wony=you->y;

				delete unit[u];
				unit.erase(u);
				you=NULL;
				break;
				}
			}
		for(u=0;u<40;u++)
			{
			unitst *newu=new unitst;
				newu->type=UNIT_GERMAN;
				newu->x=31+u*15+random(3);
				newu->y=-30+random(20);
				switch(random(4))
					{
					case 0:newu->action=ACTION_STAND_UP;break;
					case 1:newu->action=ACTION_STAND_RIGHT;break;
					case 2:newu->action=ACTION_STAND_DOWN;break;
					case 3:newu->action=ACTION_STAND_LEFT;break;
					}
				newu->phase=0;
				newu->invincible=1;
			unit.push_back(newu);
			}
		}
	if(ttrench[1]&&healthy[1]==0&&won!=1)
		{
		won=-1;
		if(you->y<429&&curscore.death==-1)
			{
			curscore.death=DEATH_POW;
			}
		}

	if(!charge)chargetimer++;
	if(!charge&&!random(30)&&chargetimer>300)
		{
		if(healthy[0]>=15&&healthy[0]>healthy[1]*2)
			{
			charge=-1;
			playsound(SOUND_TRUMPET);
			}
		else if(healthy[1]>=15&&healthy[1]>healthy[0]*2)
			{
			charge=1;
			playsound(SOUND_TRUMPET);
			}
		else
			{
			switch(random(2))
				{
				case 0:
					if(healthy[0]>=30)
						{
						charge=-1;
						playsound(SOUND_TRUMPET);
						}
					break;
				case 1:
					if(healthy[1]>=30)
						{
						charge=1;
						playsound(SOUND_TRUMPET);
						}
					break;
				}
			}
		}
	//ADVANCE CHARGES
	else
		{
		if(charge)chargetimer=0;
		if(charge==-1&&healthy[0]<10&&!etrench[1])charge=0;
		if(charge==1&&healthy[1]<10&&!etrench[0])charge=0;
		}

	//ADVANCE ACTIONS
	for(u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		switch(unit[u]->action)
			{
			case ACTION_CRAWL_UP:
				if(unit[u]->y==429)
					{
					unit[u]->action=ACTION_CLIMB_UP;
					unit[u]->phase=0;
					}
				else if(unit[u]->y-1>21&&unit[u]->y-1<429)
					{
					unit[u]->y--;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else if(unit[u]->y-1<=21)
					{
					if(unit[u]->type==UNIT_GERMAN_MEDIC)
						{
						if(unit[u]->burdened>0)
							{
							if(curscore.death==-1)gcount++;
							gcount_bat++;
							}
						unit[u]->burdened=0;
						}

					unit[u]->action=ACTION_CLIMB_DOWN;
					unit[u]->phase=1;
					unit[u]->y=22;
					}
				break;
			case ACTION_CRAWL_LEFT:
				if(unit[u]->x-1>10)
					{
					unit[u]->x-=1;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else
					{
					unit[u]->action=ACTION_LIE_LEFT;
					unit[u]->phase=0;
					unit[u]->x=10;
					}
				break;
			case ACTION_CRAWL_RIGHT:
				if(unit[u]->x+1<630)
					{
					unit[u]->x+=1;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else
					{
					unit[u]->action=ACTION_LIE_RIGHT;
					unit[u]->phase=0;
					unit[u]->x=630;
					}
				break;
			case ACTION_CRAWL_DOWN:
				if(unit[u]->y==21)
					{
					unit[u]->action=ACTION_CLIMB_DOWN;
					unit[u]->phase=0;
					}
				else if(unit[u]->y+1>21&&unit[u]->y+1<429)
					{
					unit[u]->y+=1;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else if(unit[u]->y+1>=429)
					{
					if(unit[u]->type==UNIT_ALLY_MEDIC)
						{
						addscore(unit[u]->burdened,unit[u]->x,unit[u]->y);
						if(unit[u]->burdened>0)
							{
							if(curscore.death==-1)ycount++;
							ycount_bat++;
							}
						unit[u]->burdened=0;
						}

					unit[u]->action=ACTION_CLIMB_UP;
					unit[u]->phase=1;
					unit[u]->y=428;
					}
				break;
			case ACTION_WALK_UP:
				if(unit[u]->y>429&&unit[u]->y-3<=429)
					{
					unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					unit[u]->y=429;
					}
				else if(unit[u]->y==429)
					{
					unit[u]->action=ACTION_CLIMB_UP;
					unit[u]->phase=0;
					}
				else if((unit[u]->y-3>21&&unit[u]->y-3<429)||
					unit[u]->y-3>429)
					{
					unit[u]->y-=3;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else if(unit[u]->y-3<=21)
					{
					if(unit[u]->type==UNIT_GERMAN_MEDIC)
						{
						if(unit[u]->burdened>0)
							{
							if(curscore.death==-1)gcount++;
							gcount_bat++;
							}
						unit[u]->burdened=0;
						}

					unit[u]->action=ACTION_CLIMB_DOWN;
					unit[u]->phase=1;
					unit[u]->y=22;
					}
				break;
			case ACTION_WALK_RIGHT:
				if(unit[u]->x+6<630)
					{
					unit[u]->x+=6;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					unit[u]->x=630;
					}
				break;
			case ACTION_WALK_DOWN:
				if(unit[u]->y<21&&unit[u]->y+3>=21)
					{
					unit[u]->action=ACTION_STAND_DOWN;
					unit[u]->phase=0;
					unit[u]->y=21;
					}
				else if(unit[u]->y==21)
					{
					unit[u]->action=ACTION_CLIMB_DOWN;
					unit[u]->phase=0;
					}
				else if((unit[u]->y+3>21&&unit[u]->y+3<429)||
					unit[u]->y+3<21)
					{
					unit[u]->y+=3;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else if(unit[u]->y+3>=429)
					{
					if(unit[u]->type==UNIT_ALLY_MEDIC)
						{
						addscore(unit[u]->burdened,unit[u]->x,unit[u]->y);
						if(unit[u]->burdened>0)
							{
							if(curscore.death==-1)ycount++;
							ycount_bat++;
							}
						unit[u]->burdened=0;
						}

					unit[u]->action=ACTION_CLIMB_UP;
					unit[u]->phase=1;
					unit[u]->y=428;
					}
				break;
			case ACTION_WALK_LEFT:
				if(unit[u]->x+6>10)
					{
					unit[u]->x-=6;
					unit[u]->phase=(unit[u]->phase+1)%4;
					}
				else
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					unit[u]->x=10;
					}
				break;
			case ACTION_DODGE_RIGHT:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}
				break;
			case ACTION_DODGE_LEFT:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				break;
			case ACTION_BEHEADED:
				unit[u]->phase++;
				unit[u]->dead=1;
				break;
			case ACTION_BLOWUP:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->dead=1;
					}
				break;
			case ACTION_BLOWAPART:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->dead=1;
					}
				break;
			case ACTION_CHOKE:
				if(unit[u]->phase<2)unit[u]->phase++;
				if(unit[u]->phase>=2)
					{
					if(!random(3))unit[u]->phase=5-unit[u]->phase;
					if(!random(25))unit[u]->dead=1;
					}
				break;
			case ACTION_HIT_LIVE_DOWN:
			case ACTION_HIT_LIVE_UP:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_WOUNDED;
					unit[u]->phase=0;
					unit[u]->timer=500;
					}
				if(unit[u]->phase==1)unit[u]->dir=random(2);
				break;
			case ACTION_HIT_DEAD_UP:
			case ACTION_HIT_DEAD_DOWN:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->dead=1;
					unit[u]->phase=random(2)+2;
					}
				if(unit[u]->phase==1)unit[u]->dir=random(2);
				break;
			case ACTION_HIT_FACE_DOWN:
			case ACTION_HIT_FACE_UP:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->dead=1;
					unit[u]->dir=random(2);
					}
				break;
			case ACTION_WOUNDED_CHOKE:
			case ACTION_WOUNDED:
				if(!random(10))unit[u]->phase=1-unit[u]->phase;
				if(!unit[u]->bandaged||!random(4))
					{
					unit[u]->timer--;
					if(unit[u]->timer==0||!random(120))
						{
						switch(random(4))
							{
							case 0:playsound(SOUND_WOUNDED1);break;
							case 1:playsound(SOUND_WOUNDED2);break;
							case 2:playsound(SOUND_WOUNDED3);break;
							case 3:playsound(SOUND_WOUNDED4);break;
							}
						}
					}
				if(unit[u]->timer==0)
					{
					unit[u]->dead=1;
					if(unit[u]->type==UNIT_ALLY&&unit[u]->y>21&&unit[u]->y<=444)
						{
						addscore(-50,unit[u]->x,unit[u]->y);
						}
					}
				break;
			case ACTION_BANDAGE:
				unit[u]->phase++;
				if(unit[u]->phase==20)
					{
					unit[u]->action=ACTION_LIE_RIGHT;
					unit[u]->phase=0;
					for(int u2=0;u2<unit.size();u2++)
						{
						if(unit[u2]->invincible)continue;
						if(unit[u2]->id==unit[u]->targid)
							{
							if((unit[u2]->y>=429&&(unit[u2]->type==UNIT_ALLY||
								unit[u2]->type==UNIT_ALLY_MEDIC))||
								(unit[u2]->y<=21&&(unit[u2]->type==UNIT_GERMAN||
								unit[u2]->type==UNIT_GERMAN_MEDIC)))
								{
								if(unit[u]->type==UNIT_ALLY_MEDIC&&
									unit[u2]->y>=429)
									{
									addscore(100,unit[u]->x,unit[u]->y);
									if(curscore.death==-1)ycount++;
									ycount_bat++;
									}
								else if(unit[u]->type==UNIT_GERMAN_MEDIC&&
									unit[u2]->y<=21)
									{
									if(curscore.death==-1)gcount++;
									gcount_bat++;
									}
								unit[u2]->action=ACTION_BLOWUP;
								unit[u2]->disappear=1;
								}
							unit[u2]->bandaged=1;
							if(unit[u2]->type==UNIT_GERMAN_MEDIC&&
								unit[u]->type==UNIT_ALLY_MEDIC)
								{
								addscore(200,unit[u]->x,unit[u]->y);
								}
							if(unit[u2]->type==UNIT_GERMAN&&
								unit[u]->type==UNIT_ALLY_MEDIC)
								{
								addscore(50,unit[u]->x,unit[u]->y);
								}
							break;
							}
						}
					}
				break;
			case ACTION_CLIMB_UP:
				if(unit[u]->y==429)
					{
					unit[u]->phase++;
					if(unit[u]->phase==2)
						{
						unit[u]->action=ACTION_STAND_UP;
						unit[u]->phase=0;
						unit[u]->y=428;
						}
					}
				else
					{
					unit[u]->phase--;
					if(unit[u]->phase==-1)
						{
						unit[u]->action=ACTION_STAND_UP;
						unit[u]->phase=0;
						unit[u]->y=429;
						}
					}
				break;
			case ACTION_CLIMB_DOWN:
				if(unit[u]->y==21)
					{
					unit[u]->phase++;
					if(unit[u]->phase==2)
						{
						unit[u]->action=ACTION_STAND_DOWN;
						unit[u]->phase=0;
						unit[u]->y=22;
						}
					}
				else
					{
					unit[u]->phase--;
					if(unit[u]->phase==-1)
						{
						unit[u]->action=ACTION_STAND_DOWN;
						unit[u]->phase=0;
						unit[u]->y=21;
						}
					}
				break;
			}
		}

	//ADVANCE BULLETS
	for(int p=proj.size()-1;p>=0;p--)
		{
		if(proj[p]->type==PROJ_EXPLOSION)
			{
			delete proj[p];
			proj.erase(p);
			continue;
			}

		if(proj[p]->type==PROJ_SMALLEXP)
			{
			delete proj[p];
			proj.erase(p);
			continue;
			}

		if(proj[p]->type==PROJ_STRAFE)
			{
			delete proj[p];
			proj.erase(p);
			continue;
			}

		if(proj[p]->type==PROJ_MGSTRAFE)
			{
			delete proj[p];
			proj.erase(p);
			continue;
			}

		if(proj[p]->type==PROJ_GAS)
			{
			proj[p]->x+=proj[p]->vx;
			proj[p]->y+=proj[p]->vy;

			//KILL PEOPLE
			if(proj[p]->start>7)
				{
				for(int u=0;u<unit.size();u++)
					{
					if(unit[u]->invincible)continue;
					if(abs(unit[u]->x-proj[p]->x)<10&&
						abs(unit[u]->y-proj[p]->y)<10)
						{
						char conf=1;
						switch(unit[u]->action)
							{
							case ACTION_BLOWUP:
							case ACTION_BLOWAPART:
							case ACTION_BEHEADED:
							case ACTION_HIT_DEAD_UP:
							case ACTION_HIT_DEAD_DOWN:
							case ACTION_HIT_FACE_UP:
							case ACTION_HIT_FACE_DOWN:
							case ACTION_HIT_LIVE_UP:
							case ACTION_HIT_LIVE_DOWN:
							case ACTION_CHOKE:
								conf=0;
								break;
							}
						if(unit[u]->action==ACTION_WOUNDED_CHOKE&&
							proj[p]->duration<=45)conf=0;
						if(conf)
							{
							if(proj[p]->duration<=45)unit[u]->action=ACTION_WOUNDED_CHOKE;
							else unit[u]->action=ACTION_CHOKE;
							unit[u]->dir=random(2);
							unit[u]->phase=0;

							if(unit[u]==you&&curscore.death==-1)
								{
								curscore.death=DEATH_GAS;
								}

							if(unit[u]->burdened>0&&
								(unit[u]->type==UNIT_ALLY_MEDIC||
								unit[u]->type==UNIT_GERMAN_MEDIC))
								{
								unitst *newu=new unitst;
									if(unit[u]->type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
									else newu->type=UNIT_ALLY;
									newu->x=unit[u]->x+random(2)*10-5;
									newu->y=unit[u]->y;
									if(proj[p]->duration<=45)newu->action=ACTION_WOUNDED_CHOKE;
									else newu->action=ACTION_CHOKE;
									newu->phase=0;
								unit.push_back(newu);

								unit[u]->burdened=0;
								}

							switch(random(3))
								{
								case 0:playsound(SOUND_CHOKE1);break;
								case 1:playsound(SOUND_CHOKE2);break;
								case 2:playsound(SOUND_CHOKE3);break;
								}

							clearmgun(*unit[u]);
							}
						}
					}
				}

			proj[p]->start++;
			proj[p]->duration--;
			if(proj[p]->duration<=0)
				{
				delete proj[p];
				proj.erase(p);
				continue;
				}
			}

		if(proj[p]->type==PROJ_SMOKE)
			{
			proj[p]->x+=proj[p]->vx;
			proj[p]->y+=proj[p]->vy;

			proj[p]->duration--;
			if(proj[p]->duration<=0)
				{
				delete proj[p];
				proj.erase(p);
				continue;
				}
			}

		if(proj[p]->type==PROJ_MORTAR)
			{
			proj[p]->duration++;
			if(proj[p]->duration==45)playsound(SOUND_INCOMING);
			if(proj[p]->duration>=50)
				{
				switch(random(3))
					{
					case 0:playsound(SOUND_NEARMORTAR1);break;
					case 1:playsound(SOUND_NEARMORTAR2);break;
					case 2:playsound(SOUND_NEARMORTAR3);break;
					}

				//EXPLOSION
				projst *newp=new projst;
					newp->type=PROJ_EXPLOSION;
					newp->x=proj[p]->x+2;
					newp->y=proj[p]->y-20;
					newp->duration=0;
				proj.push_back(newp);

				//SMOKE
				for(int p2=0;p2<10;p2++)
					{
					projst *newp=new projst;
						newp->type=PROJ_SMOKE;
						newp->x=proj[p]->x+random(21)-10;
						newp->y=proj[p]->y+random(21)-10;
						newp->vx=(float)(random(50)-25)/50.0f;
						newp->vy=(float)(random(50)-25)/50.0f;
						newp->duration=100+random(51);
					proj.push_back(newp);
					}

				//DISCOLOR CRATER
				vector<int> chunkx;
				vector<int> chunky;

				unsigned char color[3];
				int level;
				int x2;
				int dadd;
				int bx=proj[p]->x-40,by;
				for(int x=-40;x<=40;x++,bx++)
					{
					if(bx<0)continue;
					if(bx>=640)break;
					x2=x*x;
					by=proj[p]->y-40;
					for(int y=-40;y<=40;y++,by++)
						{
						if(by<39)continue;
						if(by>=480)break;
						level=x2+y*y*2;
						if(level<1000)
							{
							if(level<333)dadd=((level-333)>>2);
							else if(level<667)dadd=((level-333)>>4);
							else dadd=((1000-level)>>4);
							dadd+=random(10);

							if(dadd+(int)altitude[bx][by]<30)altitude[bx][by]=30;
							else if(dadd+(int)altitude[bx][by]>120)altitude[bx][by]=(char)120;
							else altitude[bx][by]+=dadd;

							if(groundflag[bx][by] & GROUNDFLAG_CHUNKY)
								{
								if(!random(5))
									{
									chunkx.push_back(bx);
									chunky.push_back(by);
									}
								}

							color[0]=(unsigned char)altitude[bx][by]+random(10);
							color[1]=(unsigned char)(altitude[bx][by]>>1)+random(4);
							color[2]=(unsigned char)(altitude[bx][by]>>3)+random(2);
							colorground(color,bx,by);
							}
						}
					}

				//CHUNKS
				for(int r=0;r<chunkx.size();r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						if(!random(20))
							{
							newp->color[0]=180;
							newp->color[1]=120;
							newp->color[2]=120;
							newp->stainer=1;
							if(!random(5))newp->stainer=2;
							}
						else
							{
							newp->color[0]=100+random(100);
							newp->color[1]=0;
							newp->color[2]=0;
							}
						newp->x=chunkx[r];
						newp->y=chunky[r];
						newp->z=0;
						newp->vx=(float)(random(50)-25)/10.0f;
						newp->vy=(float)(random(50)-25)/10.0f;
						newp->vz=(float)(random(101))/10.0f;
					proj.push_back(newp);
					}

				//DIRT
				int pnum=random(50)+150;
				for(r=0;r<pnum;r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						newp->color[0]=20+random(10);
						newp->color[1]=10+random(5);
						newp->color[2]=5+random(2);
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->z=0;
						newp->vx=(float)(random(50)-25)/10.0f;
						newp->vy=(float)(random(50)-25)/10.0f;
						newp->vz=(float)(random(101))/10.0f;
					proj.push_back(newp);
					}

				//DEATH SWATH
				if(proj[p]->bomb)deathswath(proj[p]->x,proj[p]->y,2,-1);
				else deathswath(proj[p]->x,proj[p]->y,1,-1);

				delete proj[p];
				proj.erase(p);
				continue;
				}
			}

		if(proj[p]->type==PROJ_MORTAR_GAS)
			{
			proj[p]->duration++;
			if(proj[p]->duration==45)playsound(SOUND_INCOMING);
			if(proj[p]->duration>=50)
				{
				playsound(SOUND_GAS);

				//GAS
				for(int p2=0;p2<10;p2++)
					{
					projst *newp=new projst;
						newp->type=PROJ_GAS;
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->vx=(float)(random(50)-25)/100.0f;
						newp->vy=(float)(random(50)-25)/100.0f;
						newp->duration=100+random(51);
						newp->start=0;
					proj.push_back(newp);
					}

				//DIRT
				projst *newp;
				int pnum=random(5)+5;
				for(int r=0;r<pnum;r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						newp->color[0]=20+random(10);
						newp->color[1]=10+random(5);
						newp->color[2]=5+random(2);
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->z=0;
						newp->vx=(float)(random(50)-25)/50.0f;
						newp->vy=(float)(random(50)-25)/50.0f;
						newp->vz=(float)(random(101))/50.0f;
					proj.push_back(newp);
					}

				delete proj[p];
				proj.erase(p);
				continue;
				}
			}

		if(proj[p]->type==PROJ_PLANE)
			{
			proj[p]->x+=proj[p]->vx;

			if(proj[p]->strafe)
				{
				int sx=-1;
				if(proj[p]->x>=-500&&proj[p]->x<=1500&&proj[p]->vx<0)
					{
					int sx=640-(int)((1501-proj[p]->x)*(1501-proj[p]->x)*.0006f);
					if(sx>=0&&sx<640)
						{
						strafe(sx,proj[p]->y);
						}
					}
				if(proj[p]->x<=1140&&proj[p]->x>=-860&&proj[p]->vx>0)
					{
					int sx=(int)((proj[p]->x+860)*(proj[p]->x+860)*.0006f);
					if(sx>=0&&sx<640)
						{
						strafe(sx,proj[p]->y);
						}
					}
				}

			if(proj[p]->bomb)
				{
				if((proj[p]->x<0&&proj[p]->vx<0)||
					(proj[p]->x>=640&&proj[p]->vx>0))
					{
					proj[p]->bomb=0;

					projst *newp=new projst;
						newp->type=PROJ_MORTAR;
						newp->x=random(600)+20;
						newp->y=proj[p]->y;
						newp->duration=0;
						newp->bomb=1;
					proj.push_back(newp);
					}
				}

			proj[p]->duration++;
			if(proj[p]->duration>=200)
				{
				delete proj[p];
				proj.erase(p);
				continue;
				}
			}
		if(proj[p]->type==PROJ_BULLET)
			{
			proj[p]->ox=proj[p]->x;
			proj[p]->oy=proj[p]->y;
			proj[p]->oz=proj[p]->z;
			proj[p]->x+=proj[p]->vx;
			proj[p]->y+=proj[p]->vy;
			proj[p]->z+=proj[p]->vz;
			proj[p]->vz-=.1f;

			//CHECK FOR GROUND
			if(proj[p]->z<=0)
				{
				//MAKE NEW PROJECTILES AND COLOR GROUND
				int pnum=random(3)+3;
				if(proj[p]->strafe)pnum+=5;
				projst *newp;
				for(int r=0;r<pnum;r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						char conf=0;
						if((int)proj[p]->x>=0&&(int)proj[p]->x<640&&
							(int)proj[p]->y>=0&&(int)proj[p]->y<480)
							{
							if(groundflag[(int)proj[p]->x][(int)proj[p]->y] & GROUNDFLAG_CHUNKY)conf=1;
							}
						if(conf)
							{
							if(!random(20))
								{
								newp->color[0]=180;
								newp->color[1]=120;
								newp->color[2]=120;
								newp->stainer=1;
								if(!random(5))newp->stainer=2;
								}
							else
								{
								newp->color[0]=100+random(100);
								newp->color[1]=0;
								newp->color[2]=0;
								}
							}
						else
							{
							newp->color[0]=20+random(10);
							newp->color[1]=10+random(5);
							newp->color[2]=5+random(2);
							}
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->z=0;
						newp->vx=(float)(proj[p]->vx+random(7)-3)/10.0f;
						newp->vy=(float)(proj[p]->vy+random(7)-3)/10.0f;
						newp->vz=(float)(random(101))/100.0f;
					proj.push_back(newp);
					}

				//MG STRAFE
				if(proj[p]->strafe)
					{
					newp=new projst;
						newp->type=PROJ_MGSTRAFE;
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->duration=0;
					proj.push_back(newp);
					}

				unsigned char color[3]={0,0,0};
				colorground(color,proj[p]->x,proj[p]->y);

				delete proj[p];
				proj.erase(p);
				continue;
				}

			//CHECK FOR TARGET
			char del=0;
			for(int u=0;u<unit.size();u++)
				{
				if(unit[u]->invincible)continue;
				if(unit[u]->id!=proj[p]->owner)
					{
					if(hitunit(*proj[p],*unit[u]))
						{
						delete proj[p];
						proj.erase(p);
						del=1;
						break;
						}
					}
				}
			if(del)continue;
			}
		if(proj[p]->type==PROJ_GRENADE)
			{
			proj[p]->x+=proj[p]->vx;
			proj[p]->y+=proj[p]->vy;
			proj[p]->z+=proj[p]->vz;
			proj[p]->vz-=.7f;

			if(proj[p]->z<=0)
				{
				//BOUNCE
				if(proj[p]->vz<-3.0f)
					{
					proj[p]->z=0;
					proj[p]->vz=-.35f*proj[p]->vz;
					proj[p]->vx=.8f*proj[p]->vx;
					proj[p]->vy=.8f*proj[p]->vy;
					}
				else
					{
					//LOOKS BETTER EVEN IF NOT ACCURATE
					proj[p]->x-=proj[p]->vx;
					proj[p]->y-=proj[p]->vy;
					proj[p]->vx=0;
					proj[p]->vy=0;
					}
				}

			proj[p]->duration++;
			if(proj[p]->duration>=random(20)+10)
				{
				switch(random(3))
					{
					case 0:playsound(SOUND_GRENADE1);break;
					case 1:playsound(SOUND_GRENADE2);break;
					case 2:playsound(SOUND_GRENADE3);break;
					}

				//EXPLOSION
				projst *newp=new projst;
					newp->type=PROJ_SMALLEXP;
					newp->x=proj[p]->x+2;
					newp->y=proj[p]->y-10;
					newp->duration=0;
				proj.push_back(newp);

				//SMOKE
				for(int p2=0;p2<3;p2++)
					{
					projst *newp=new projst;
						newp->type=PROJ_SMOKE;
						newp->x=proj[p]->x+random(11)-5;
						newp->y=proj[p]->y+random(11)-5;
						newp->vx=(float)(random(50)-25)/75.0f;
						newp->vy=(float)(random(50)-25)/75.0f;
						newp->duration=100+random(51);
					proj.push_back(newp);
					}

				//DISCOLOR CRATER
				vector<int> chunkx;
				vector<int> chunky;

				unsigned char color[3];
				int level;
				int x2;
				int dadd;
				int bx=proj[p]->x-10,by;
				for(int x=-10;x<=10;x++,bx++)
					{
					if(bx<0)continue;
					if(bx>=640)break;
					x2=x*x;
					by=proj[p]->y-10;
					for(int y=-10;y<=10;y++,by++)
						{
						if(by<39)continue;
						if(by>=480)break;
						level=x2+y*y*2;
						if(level<100)
							{
							if(level<33)dadd=((level-33)>>2);
							else if(level<67)dadd=((level-33)>>4);
							else dadd=((100-level)>>4);
							dadd+=random(10);

							if(dadd+(int)altitude[bx][by]<10)altitude[bx][by]=10;
							else if(dadd+(int)altitude[bx][by]>120)altitude[bx][by]=(char)120;
							else altitude[bx][by]+=dadd;

							if(groundflag[bx][by] & GROUNDFLAG_CHUNKY)
								{
								if(!random(5))
									{
									chunkx.push_back(bx);
									chunky.push_back(by);
									}
								}

							color[0]=(unsigned char)altitude[bx][by]+random(10);
							color[1]=(unsigned char)(altitude[bx][by]>>1)+random(4);
							color[2]=(unsigned char)(altitude[bx][by]>>3)+random(2);
							colorground(color,bx,by);
							}
						}
					}

				//CHUNKS
				for(int r=0;r<chunkx.size();r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						if(!random(20))
							{
							newp->color[0]=180;
							newp->color[1]=120;
							newp->color[2]=120;
							newp->stainer=1;
							if(!random(5))newp->stainer=2;
							}
						else
							{
							newp->color[0]=100+random(100);
							newp->color[1]=0;
							newp->color[2]=0;
							}
						newp->x=chunkx[r];
						newp->y=chunky[r];
						newp->z=0;
						newp->vx=(float)(random(50)-25)/10.0f;
						newp->vy=(float)(random(50)-25)/10.0f;
						newp->vz=(float)(random(101))/10.0f;
					proj.push_back(newp);
					}

				//DIRT
				int pnum=random(5)+15;
				for(r=0;r<pnum;r++)
					{
					newp=new projst;
						newp->type=PROJ_CHUNK;
						newp->color[0]=20+random(10);
						newp->color[1]=10+random(5);
						newp->color[2]=5+random(2);
						newp->x=proj[p]->x;
						newp->y=proj[p]->y;
						newp->z=0;
						newp->vx=(float)(random(50)-25)/10.0f;
						newp->vy=(float)(random(50)-25)/10.0f;
						newp->vz=(float)(random(101))/10.0f;
					proj.push_back(newp);
					}

				//DEATH SWATH
				deathswath(proj[p]->x,proj[p]->y,0,proj[p]->side);

				delete proj[p];
				proj.erase(p);
				continue;
				}

			continue;
			}
		if(proj[p]->type==PROJ_CHUNK)
			{
			proj[p]->x+=proj[p]->vx;
			proj[p]->y+=proj[p]->vy;
			proj[p]->z+=proj[p]->vz;
			proj[p]->vz-=.7f;
			proj[p]->duration++;

			if(proj[p]->stainer==2)
				{
				projst *newp=new projst;
					newp->type=PROJ_CHUNK;
					newp->color[0]=200+random(100);
					newp->color[1]=0;
					newp->color[2]=0;
					newp->x=proj[p]->x;
					newp->y=proj[p]->y;
					newp->z=proj[p]->z;
					float modulate=(float)(random(201)-100)/500.0f;
					newp->vx=modulate*proj[p]->vx;
					newp->vy=modulate*proj[p]->vy;
					newp->vz=(float)(random(51)-25)/10.0f;
				proj.push_back(newp);
				}

			if(proj[p]->z<=0)
				{
				//BOUNCE
				if(proj[p]->vz<-3.0f&&
					(proj[p]->color[1]!=0||
					proj[p]->color[2]!=0||
					proj[p]->color[0]==0))
					{
					proj[p]->z=0;
					proj[p]->vz=-.35f*proj[p]->vz;
					proj[p]->vx=.8f*proj[p]->vx;
					proj[p]->vy=.8f*proj[p]->vy;

					if(proj[p]->stainer)
						{
						unsigned char color[3]={100+random(101),0,0};
						colorground(color,proj[p]->x,proj[p]->y);
						}
					}
				else
					{
					//LOOKS BETTER EVEN IF NOT ACCURATE
					proj[p]->x-=proj[p]->vx;
					proj[p]->y-=proj[p]->vy;
					//COLOR GROUND
					colorground(proj[p]->color,proj[p]->x,proj[p]->y);

					delete proj[p];
					proj.erase(p);
					continue;
					}
				}

			continue;
			}
		}

	//MUST SHOOT AND THROW LATER TO AVOID FRAME/PROJ PROBLEMS
	for(u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		switch(unit[u]->action)
			{
			case ACTION_MACHINEGUNNER_SHOOT_UP:
				{
				shoot(*unit[u]);
				unit[u]->action=ACTION_MACHINEGUNNER_UP;
				unit[u]->phase=0;
				unit[u]->tired=1;

				projst *newp=new projst;
					newp->type=PROJ_CHUNK;
					newp->color[0]=150;
					newp->color[1]=130;
					newp->color[2]=0;
					newp->x=unit[u]->x;
					newp->y=unit[u]->y+10;
					newp->z=0;
					newp->vx=(float)(random(50)+50)/75.0f;
					newp->vy=(float)(random(100)+50)/100.0f;
					newp->vz=(float)(random(50)+50)/50.0f;
				proj.push_back(newp);

				for(int s=0;s<2;s++)
					{
					for(int g=0;g<3;g++)
						{
						if(machinegun[s][g]==2&&machinegununit[s][g]==unit[u])
							{
							machinegun[s][g]=1;
							}
						}
					}
				break;
				}
			case ACTION_MACHINEGUNNER_SHOOT_DOWN:
				{
				shoot(*unit[u]);
				unit[u]->action=ACTION_MACHINEGUNNER_DOWN;
				unit[u]->phase=0;
				unit[u]->tired=1;

				projst *newp=new projst;
					newp->type=PROJ_CHUNK;
					newp->color[0]=150;
					newp->color[1]=130;
					newp->color[2]=0;
					newp->x=unit[u]->x-5;
					newp->y=unit[u]->y+12;
					newp->z=0;
					newp->vx=(float)(-random(50)-50)/75.0f;
					newp->vy=(float)(-random(100)+50)/130.0f;
					newp->vz=(float)(random(50)+50)/50.0f;
				proj.push_back(newp);

				for(int s=0;s<2;s++)
					{
					for(int g=0;g<3;g++)
						{
						if(machinegun[s][g]==2&&machinegununit[s][g]==unit[u])
							{
							machinegun[s][g]=1;
							}
						}
					}
				break;
				}
			case ACTION_SHOOT_DOWN:
				shoot(*unit[u]);
				unit[u]->action=ACTION_STAND_DOWN;
				break;
			case ACTION_SHOOT_UP:
				shoot(*unit[u]);
				unit[u]->action=ACTION_STAND_UP;
				break;
			case ACTION_CHUCK_UP:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;

					projst *newp=new projst;
						newp->type=PROJ_GRENADE;
						newp->side=1;
						newp->duration=random(4);
						newp->x=unit[u]->x;
						newp->y=unit[u]->y;
						if(unit[u]->y<=21||unit[u]->y>=429)newp->z=1;
						else newp->z=13;
						newp->vz=3;
						long dx=unit[u]->targx-unit[u]->x;
						long dy=unit[u]->targy-unit[u]->y;
						if(dx==0&&dy==0)
							{
							newp->vx=0;
							newp->vy=0;
							}
						else
							{
							float dist=sqrt(dx*dx+dy*dy);
							newp->vx=(float)(dx*5)/dist;
							newp->vy=(float)(dy*5)/dist;
							}
					proj.push_back(newp);
					}
				break;
			case ACTION_CHUCK_DOWN:
				unit[u]->phase++;
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_DOWN;
					unit[u]->phase=0;

					projst *newp=new projst;
						newp->type=PROJ_GRENADE;
						newp->side=0;
						newp->duration=random(4);
						newp->x=unit[u]->x;
						newp->y=unit[u]->y;
						if(unit[u]->y<=21||unit[u]->y>=429)newp->z=1;
						else newp->z=13;
						newp->vz=3;
						long dx=unit[u]->targx-unit[u]->x;
						long dy=unit[u]->targy-unit[u]->y;
						if(dx==0&&dy==0)
							{
							newp->vx=0;
							newp->vy=0;
							}
						else
							{
							float dist=sqrt(dx*dx+dy*dy);
							newp->vx=(float)(dx*5)/dist;
							newp->vy=(float)(dy*5)/dist;
							}
					proj.push_back(newp);
					}
				break;
			case ACTION_SHOVEL_RIGHT1:
			case ACTION_SHOVEL_RIGHT2:
				unit[u]->phase++;
				if(unit[u]->phase==1)
					{
					long t=-1;
					for(int u2=0;u2<unit.size();u2++)
						{
						if(unit[u2]->invincible)continue;
						if(unit[u2]->id==unit[u]->targid&&
							unit[u2]->y==unit[u]->y&&
							abs(unit[u2]->x-unit[u]->x)<15)
							{
							switch(unit[u2]->action)
								{
								case ACTION_BLOWUP:
								case ACTION_BLOWAPART:
								case ACTION_BEHEADED:
								case ACTION_HIT_DEAD_UP:
								case ACTION_HIT_DEAD_DOWN:
								case ACTION_HIT_FACE_UP:
								case ACTION_HIT_FACE_DOWN:
								case ACTION_HIT_LIVE_UP:
								case ACTION_HIT_LIVE_DOWN:
								case ACTION_CHOKE:
									break;
								default:
									t=u2;
									break;
								}
							break;
							}
						}

					if(t!=-1)
						{
						//DODGE
						if(random(3)&&unit[t]->action!=ACTION_WOUNDED
							&&unit[t]->action!=ACTION_WOUNDED_CHOKE)
							{
							unit[t]->action=ACTION_DODGE_LEFT;
							unit[t]->phase=0;
							}
						//NO DODGE
						else
							{
							switch(random(4))
								{
								case 0:playsound(SOUND_SCREAM1);break;
								case 1:playsound(SOUND_SCREAM2);break;
								case 2:playsound(SOUND_SCREAM3);break;
								case 3:playsound(SOUND_SCREAM4);break;
								}

							if(!random(5)||
								unit[t]->action==ACTION_WOUNDED||
								unit[t]->action==ACTION_WOUNDED_CHOKE)
								{
								if(unit[t]->action==ACTION_WOUNDED||
									unit[t]->action==ACTION_WOUNDED_CHOKE)
									{
									unit[t]->dead=1;
									}
								unit[t]->phase=0;
								unit[t]->action=ACTION_BEHEADED;
								unit[t]->dir=0;
								}
							else if(!random(3))
								{
								unit[t]->action=ACTION_HIT_FACE_DOWN;
								unit[t]->phase=0;
								unit[t]->dir=1;
								}
							else
								{
								unit[t]->action=ACTION_HIT_DEAD_DOWN;
								unit[t]->phase=0;
								unit[t]->dir=1;
								}

							if(unit[t]==you&&curscore.death==-1)
								{
								if(unit[t]->action==ACTION_BEHEADED)
									{
									curscore.death=DEATH_SHOVEL_BH;
									}
								if(unit[t]->action==ACTION_HIT_FACE_DOWN)
									{
									curscore.death=DEATH_SHOVEL_F;
									}
								if(unit[t]->action==ACTION_HIT_DEAD_DOWN)
									{
									curscore.death=DEATH_SHOVEL_D;
									}
								}

							if(unit[t]->burdened>0&&
								(unit[t]->type==UNIT_ALLY_MEDIC||
								unit[t]->type==UNIT_GERMAN_MEDIC))
								{
								unitst *newu=new unitst;
									if(unit[t]->type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
									else newu->type=UNIT_ALLY;
									newu->x=unit[t]->x+random(2)*10-5;
									newu->y=unit[t]->y;
									newu->action=ACTION_WOUNDED;
									newu->timer=unit[t]->burden_timer;
									newu->burdened=unit[t]->burdened;
									newu->bandaged=1;
									newu->phase=0;
								unit.push_back(newu);

								unit[t]->burdened=0;
								}

							int pnum=random(23)+3;
							projst *newp;
							for(int r=0;r<pnum;r++)
								{
								newp=new projst;
									newp->type=PROJ_CHUNK;
									if(!random(60))
										{
										newp->color[0]=180;
										newp->color[1]=120;
										newp->color[2]=120;
										newp->stainer=1;
										if(!random(5))newp->stainer=2;
										newp->z=17;
										newp->vx=(float)(random(101)-50)/10.0f;
										newp->vy=(float)(random(101)-50)/10.0f;
										newp->vz=(float)(random(101)-50)/10.0f;
										}
									else
										{
										newp->color[0]=random(100)+100;
										newp->color[1]=0;
										newp->color[2]=0;
										newp->z=17;
										newp->vx=(float)(random(101)-50)/50.0f;
										newp->vy=(float)(random(101)-50)/50.0f;
										newp->vz=(float)(random(101)-50)/50.0f;
										}
									newp->x=unit[t]->x;
									newp->y=unit[t]->y+15;
								proj.push_back(newp);
								}
							}
						}
					}
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}
				break;
			case ACTION_SHOVEL_LEFT1:
			case ACTION_SHOVEL_LEFT2:
				unit[u]->phase++;
				if(unit[u]->phase==1)
					{
					long t=-1;
					for(int u2=0;u2<unit.size();u2++)
						{
						if(unit[u2]->invincible)continue;
						if(unit[u2]->id==unit[u]->targid&&
							unit[u2]->y==unit[u]->y&&
							abs(unit[u2]->x-unit[u]->x)<15)
							{
							switch(unit[u2]->action)
								{
								case ACTION_BLOWUP:
								case ACTION_BLOWAPART:
								case ACTION_BEHEADED:
								case ACTION_HIT_DEAD_UP:
								case ACTION_HIT_DEAD_DOWN:
								case ACTION_HIT_FACE_UP:
								case ACTION_HIT_FACE_DOWN:
								case ACTION_HIT_LIVE_UP:
								case ACTION_HIT_LIVE_DOWN:
								case ACTION_CHOKE:
									break;
								default:
									t=u2;
									break;
								}
							break;
							}
						}

					if(t!=-1)
						{
						//DODGE
						if(random(3)&&unit[t]->action!=ACTION_WOUNDED&&
							unit[t]->action!=ACTION_WOUNDED_CHOKE)
							{
							unit[t]->action=ACTION_DODGE_RIGHT;
							unit[t]->phase=0;
							}
						//NO DODGE
						else
							{
							switch(random(4))
								{
								case 0:playsound(SOUND_SCREAM1);break;
								case 1:playsound(SOUND_SCREAM2);break;
								case 2:playsound(SOUND_SCREAM3);break;
								case 3:playsound(SOUND_SCREAM4);break;
								}

							if(!random(5)||
								unit[t]->action==ACTION_WOUNDED||
								unit[t]->action==ACTION_WOUNDED_CHOKE)
								{
								if(unit[t]->action==ACTION_WOUNDED||
									unit[t]->action==ACTION_WOUNDED_CHOKE)
									{
									unit[t]->dead=1;
									}
								unit[t]->phase=0;
								unit[t]->action=ACTION_BEHEADED;
								unit[t]->dir=1;
								}
							else if(!random(3))
								{
								unit[t]->action=ACTION_HIT_FACE_DOWN;
								unit[t]->phase=0;
								unit[t]->dir=0;
								}
							else
								{
								unit[t]->action=ACTION_HIT_DEAD_DOWN;
								unit[t]->phase=0;
								unit[t]->dir=0;
								}

							if(unit[t]==you&&curscore.death==-1)
								{
								if(unit[t]->action==ACTION_BEHEADED)
									{
									curscore.death=DEATH_SHOVEL_BH;
									}
								if(unit[t]->action==ACTION_HIT_FACE_DOWN)
									{
									curscore.death=DEATH_SHOVEL_F;
									}
								if(unit[t]->action==ACTION_HIT_DEAD_DOWN)
									{
									curscore.death=DEATH_SHOVEL_D;
									}
								}

							if(unit[t]->burdened>0&&
								(unit[t]->type==UNIT_ALLY_MEDIC||
								unit[t]->type==UNIT_GERMAN_MEDIC))
								{
								unitst *newu=new unitst;
									if(unit[t]->type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
									else newu->type=UNIT_ALLY;
									newu->x=unit[t]->x+random(2)*10-5;
									newu->y=unit[t]->y;
									newu->action=ACTION_WOUNDED;
									newu->timer=unit[t]->burden_timer;
									newu->burdened=unit[t]->burdened;
									newu->bandaged=1;
									newu->phase=0;
								unit.push_back(newu);

								unit[t]->burdened=0;
								}

							int pnum=random(23)+3;
							projst *newp;
							for(int r=0;r<pnum;r++)
								{
								newp=new projst;
									newp->type=PROJ_CHUNK;
									if(!random(60))
										{
										newp->color[0]=180;
										newp->color[1]=120;
										newp->color[2]=120;
										newp->stainer=1;
										if(!random(5))newp->stainer=2;
										newp->z=17;
										newp->vx=(float)(random(101)-50)/10.0f;
										newp->vy=(float)(random(101)-50)/10.0f;
										newp->vz=(float)(random(101)-50)/10.0f;
										}
									else
										{
										newp->color[0]=random(100)+100;
										newp->color[1]=0;
										newp->color[2]=0;
										newp->z=17;
										newp->vx=(float)(random(101)-50)/50.0f;
										newp->vy=(float)(random(101)-50)/50.0f;
										newp->vz=(float)(random(101)-50)/50.0f;
										}
									newp->x=unit[t]->x;
									newp->y=unit[t]->y+15;
								proj.push_back(newp);
								}
							}
						}
					}
				if(unit[u]->phase==2)
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				break;
			}
		}

	//AI
	for(u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->type==UNIT_GERMAN_MEDIC)
			{
			char conf=1;
			switch(unit[u]->action)
				{
				case ACTION_BLOWUP:
				case ACTION_BLOWAPART:
				case ACTION_BEHEADED:
				case ACTION_HIT_DEAD_UP:
				case ACTION_HIT_DEAD_DOWN:
				case ACTION_HIT_FACE_UP:
				case ACTION_HIT_FACE_DOWN:
				case ACTION_HIT_LIVE_UP:
				case ACTION_HIT_LIVE_DOWN:
				case ACTION_CHOKE:
				case ACTION_WOUNDED:
				case ACTION_WOUNDED_CHOKE:
				case ACTION_CLIMB_UP:
				case ACTION_CLIMB_DOWN:
				case ACTION_DODGE_RIGHT:
				case ACTION_DODGE_LEFT:
				case ACTION_BANDAGE:
					conf=0;
					break;
				}
			if(unit[u]->y<21||unit[u]->y>429)conf=0;
			if(!conf)continue;

			if(unit[u]->burdened>0)
				{
				if(unit[u]->shotattime>=120)
					{
					if(unit[u]->action!=ACTION_WALK_UP)
						{
						unit[u]->action=ACTION_WALK_UP;
						unit[u]->phase=0;
						}
					}
				else
					{
					if(unit[u]->action!=ACTION_CRAWL_UP)
						{
						unit[u]->action=ACTION_CRAWL_UP;
						unit[u]->phase=0;
						}
					}
				}
			else
				{
				int targ=-1;
				int dist=10000,tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_GERMAN&&
						(unit[u2]->action==ACTION_WOUNDED||
						unit[u2]->action==ACTION_WOUNDED_CHOKE))
						{
						tdist=abs(unit[u2]->x-unit[u]->x)+
							abs(unit[u2]->y-unit[u]->y);
						if(tdist<dist&&unit[u2]->y<=444&&unit[u2]->y>=6)
							{
							dist=tdist;
							targ=u2;
							}
						}
					}

				if(targ!=-1)
					{
					if((unit[u]->x-unit[targ]->x)*(unit[u]->x-unit[targ]->x)+
						(unit[u]->y-unit[targ]->y)*(unit[u]->y-unit[targ]->y)<=300&&
						(
						(unit[u]->y<429&&unit[targ]->y<429&&
						unit[u]->y>21&&unit[targ]->y>21)||
						(unit[u]->y>=429&&unit[targ]->y>=429)||
						(unit[u]->y<=21&&unit[targ]->y<=21)
						))
						{
						if(!unit[targ]->bandaged)
							{
							unit[u]->action=ACTION_BANDAGE;
							unit[u]->phase=0;
							unit[u]->targid=unit[targ]->id;
							}
						else
							{
							unit[u]->burdened=unit[targ]->burdened;
							if(unit[u]->burdened==0)unit[u]->burdened=unit[targ]->y*3+100;
							unit[u]->burden_timer=unit[targ]->timer;
							unit[u]->burdenact=unit[targ]->action;

							unit[targ]->action=ACTION_BLOWUP;
							unit[targ]->disappear=1;
							}
						}
					else
						{
						if(unit[u]->shotattime>=120)
							{
							if(unit[targ]->x+10<unit[u]->x)
								{
								if(unit[u]->action!=ACTION_WALK_LEFT)
									{
									unit[u]->action=ACTION_WALK_LEFT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->x-10>unit[u]->x)
								{
								if(unit[u]->action!=ACTION_WALK_RIGHT)
									{
									unit[u]->action=ACTION_WALK_RIGHT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y-10>unit[u]->y||
								(unit[targ]->y>21&&unit[u]->y<=21)||
								(unit[targ]->y>=429&&unit[u]->y<429))
								{
								if(unit[u]->action!=ACTION_WALK_DOWN)
									{
									unit[u]->action=ACTION_WALK_DOWN;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y+10<unit[u]->y||
								(unit[targ]->y<=21&&unit[u]->y>21)||
								(unit[targ]->y<429&&unit[u]->y>=429))
								{
								if(unit[u]->action!=ACTION_WALK_UP)
									{
									unit[u]->action=ACTION_WALK_UP;
									unit[u]->phase=0;
									}
								}
							}
						else
							{
							if(unit[targ]->x+10<unit[u]->x)
								{
								if(unit[u]->action!=ACTION_CRAWL_LEFT)
									{
									unit[u]->action=ACTION_CRAWL_LEFT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->x-10>unit[u]->x)
								{
								if(unit[u]->action!=ACTION_CRAWL_RIGHT)
									{
									unit[u]->action=ACTION_CRAWL_RIGHT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y-10>unit[u]->y||
								(unit[targ]->y>21&&unit[u]->y<=21)||
								(unit[targ]->y>=429&&unit[u]->y<429))
								{
								if(unit[u]->action!=ACTION_CRAWL_DOWN)
									{
									unit[u]->action=ACTION_CRAWL_DOWN;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y+10<unit[u]->y||
								(unit[targ]->y<=21&&unit[u]->y>21)||
								(unit[targ]->y<429&&unit[u]->y>=429))
								{
								if(unit[u]->action!=ACTION_CRAWL_UP)
									{
									unit[u]->action=ACTION_CRAWL_UP;
									unit[u]->phase=0;
									}
								}
							}
						}
					}
				else if(unit[u]->y>21)
					{
					if(unit[u]->shotattime>=120)
						{
						if(unit[u]->action!=ACTION_WALK_UP)
							{
							unit[u]->action=ACTION_WALK_UP;
							unit[u]->phase=0;
							}
						}
					else
						{
						if(unit[u]->action!=ACTION_CRAWL_UP)
							{
							unit[u]->action=ACTION_CRAWL_UP;
							unit[u]->phase=0;
							}
						}
					}
				else
					{
					unit[u]->action=ACTION_LIE_DOWN;
					unit[u]->phase=0;
					}
				}
			}
		if(unit[u]->type==UNIT_ALLY_MEDIC&&curscore.death!=-1)
			{
			char conf=1;
			switch(unit[u]->action)
				{
				case ACTION_BLOWUP:
				case ACTION_BLOWAPART:
				case ACTION_BEHEADED:
				case ACTION_HIT_DEAD_UP:
				case ACTION_HIT_DEAD_DOWN:
				case ACTION_HIT_FACE_UP:
				case ACTION_HIT_FACE_DOWN:
				case ACTION_HIT_LIVE_UP:
				case ACTION_HIT_LIVE_DOWN:
				case ACTION_CHOKE:
				case ACTION_WOUNDED:
				case ACTION_WOUNDED_CHOKE:
				case ACTION_CLIMB_UP:
				case ACTION_CLIMB_DOWN:
				case ACTION_DODGE_RIGHT:
				case ACTION_DODGE_LEFT:
				case ACTION_BANDAGE:
					conf=0;
					break;
				}
			if(unit[u]->y<21||unit[u]->y>429)conf=0;
			if(!conf)continue;

			if(unit[u]->burdened>0)
				{
				if(unit[u]->shotattime>=120)
					{
					if(unit[u]->action!=ACTION_WALK_DOWN)
						{
						unit[u]->action=ACTION_WALK_DOWN;
						unit[u]->phase=0;
						}
					}
				else
					{
					if(unit[u]->action!=ACTION_CRAWL_DOWN)
						{
						unit[u]->action=ACTION_CRAWL_DOWN;
						unit[u]->phase=0;
						}
					}
				}
			else
				{
				int targ=-1;
				int dist=10000,tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_ALLY&&
						(unit[u2]->action==ACTION_WOUNDED||
						unit[u2]->action==ACTION_WOUNDED_CHOKE))
						{
						tdist=abs(unit[u2]->x-unit[u]->x)+
							abs(unit[u2]->y-unit[u]->y);
						if(tdist<dist&&unit[u2]->y<=444&&unit[u2]->y>=6)
							{
							dist=tdist;
							targ=u2;
							}
						}
					}

				if(targ!=-1)
					{
					if((unit[u]->x-unit[targ]->x)*(unit[u]->x-unit[targ]->x)+
						(unit[u]->y-unit[targ]->y)*(unit[u]->y-unit[targ]->y)<=300&&
						(
						(unit[u]->y<429&&unit[targ]->y<429&&
						unit[u]->y>21&&unit[targ]->y>21)||
						(unit[u]->y>=429&&unit[targ]->y>=429)||
						(unit[u]->y<=21&&unit[targ]->y<=21)
						))
						{
						if(!unit[targ]->bandaged)
							{
							unit[u]->action=ACTION_BANDAGE;
							unit[u]->phase=0;
							unit[u]->targid=unit[targ]->id;
							}
						else
							{
							unit[u]->burdened=unit[targ]->burdened;
							if(unit[u]->burdened==0)unit[u]->burdened=unit[targ]->y*3+100;
							unit[u]->burden_timer=unit[targ]->timer;
							unit[u]->burdenact=unit[targ]->action;

							unit[targ]->action=ACTION_BLOWUP;
							unit[targ]->disappear=1;
							}
						}
					else
						{
						if(unit[u]->shotattime>=120)
							{
							if(unit[targ]->x+10<unit[u]->x)
								{
								if(unit[u]->action!=ACTION_WALK_LEFT)
									{
									unit[u]->action=ACTION_WALK_LEFT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->x-10>unit[u]->x)
								{
								if(unit[u]->action!=ACTION_WALK_RIGHT)
									{
									unit[u]->action=ACTION_WALK_RIGHT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y-10>unit[u]->y||
								(unit[targ]->y>21&&unit[u]->y<=21)||
								(unit[targ]->y>=429&&unit[u]->y<429))
								{
								if(unit[u]->action!=ACTION_WALK_DOWN)
									{
									unit[u]->action=ACTION_WALK_DOWN;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y+10<unit[u]->y||
								(unit[targ]->y<=21&&unit[u]->y>21)||
								(unit[targ]->y<429&&unit[u]->y>=429))
								{
								if(unit[u]->action!=ACTION_WALK_UP)
									{
									unit[u]->action=ACTION_WALK_UP;
									unit[u]->phase=0;
									}
								}
							}
						else
							{
							if(unit[targ]->x+10<unit[u]->x)
								{
								if(unit[u]->action!=ACTION_CRAWL_LEFT)
									{
									unit[u]->action=ACTION_CRAWL_LEFT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->x-10>unit[u]->x)
								{
								if(unit[u]->action!=ACTION_CRAWL_RIGHT)
									{
									unit[u]->action=ACTION_CRAWL_RIGHT;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y-10>unit[u]->y||
								(unit[targ]->y>21&&unit[u]->y<=21)||
								(unit[targ]->y>=429&&unit[u]->y<429))
								{
								if(unit[u]->action!=ACTION_CRAWL_DOWN)
									{
									unit[u]->action=ACTION_CRAWL_DOWN;
									unit[u]->phase=0;
									}
								}
							else if(unit[targ]->y+10<unit[u]->y||
								(unit[targ]->y<=21&&unit[u]->y>21)||
								(unit[targ]->y<429&&unit[u]->y>=429))
								{
								if(unit[u]->action!=ACTION_CRAWL_UP)
									{
									unit[u]->action=ACTION_CRAWL_UP;
									unit[u]->phase=0;
									}
								}
							}
						}
					}
				else if(unit[u]->y<429)
					{
					if(unit[u]->shotattime>=120)
						{
						if(unit[u]->action!=ACTION_WALK_DOWN)
							{
							unit[u]->action=ACTION_WALK_DOWN;
							unit[u]->phase=0;
							}
						}
					else
						{
						if(unit[u]->action!=ACTION_CRAWL_DOWN)
							{
							unit[u]->action=ACTION_CRAWL_DOWN;
							unit[u]->phase=0;
							}
						}
					}
				else
					{
					unit[u]->action=ACTION_LIE_UP;
					unit[u]->phase=0;
					}
				}
			}
		if(unit[u]->type==UNIT_GERMAN)
			{
			//ATTACK/DEFEND TRENCH
			if((unit[u]->y==21&&etrench[0])||
				(unit[u]->y==429))
				{
				int tolerance=100;
				if(unit[u]->y==429)tolerance=800;

				//FIND LEFT/RIGHT NEAREST NEIGHBORS
				int leftdist=800;
				int rightdist=800;
				int lu=-1,ru=-1;
				int tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if((unit[u2]->type==UNIT_ALLY||
						unit[u2]->type==UNIT_ALLY_MEDIC)&&
						unit[u2]->y==unit[u]->y)
						{
						tdist=unit[u2]->x-unit[u]->x;
						if(tdist>=0&&tdist<rightdist)
							{
							rightdist=tdist;
							ru=u2;
							}
						tdist=unit[u]->x-unit[u2]->x;
						if(tdist>=0&&tdist<leftdist)
							{
							leftdist=tdist;
							lu=u2;
							}
						}
					}

				//ATTACK WITH SHOVEL
				if(leftdist<15&&unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					if(random(2))unit[u]->action=ACTION_SHOVEL_LEFT1;
					else unit[u]->action=ACTION_SHOVEL_LEFT2;
					unit[u]->phase=0;
					unit[u]->targid=unit[lu]->id;
					switch(random(3))
						{
						case 0:playsound(SOUND_SWING1);break;
						case 1:playsound(SOUND_SWING2);break;
						case 2:playsound(SOUND_SWING3);break;
						}
					}
				if(rightdist<15&&unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					if(random(2))unit[u]->action=ACTION_SHOVEL_RIGHT1;
					else unit[u]->action=ACTION_SHOVEL_RIGHT2;
					unit[u]->phase=0;
					unit[u]->targid=unit[ru]->id;
					switch(random(3))
						{
						case 0:playsound(SOUND_SWING1);break;
						case 1:playsound(SOUND_SWING2);break;
						case 2:playsound(SOUND_SWING3);break;
						}
					}

				//WALKING
				if(leftdist<15&&unit[u]->action==ACTION_WALK_LEFT)
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<15&&unit[u]->action==ACTION_WALK_RIGHT)
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}
				if(leftdist<tolerance&&leftdist>=15&&unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					unit[u]->action=ACTION_WALK_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<tolerance&&rightdist>=15&&unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					unit[u]->action=ACTION_WALK_RIGHT;
					unit[u]->phase=0;
					}

				//FACE SHOVEL GUYS IF NECESSARY (UNMAN MACHINE GUN)
				if(leftdist<tolerance&&
					(unit[u]->action==ACTION_STAND_UP||
					unit[u]->action==ACTION_STAND_DOWN||
					unit[u]->action==ACTION_MACHINEGUNNER_UP||
					unit[u]->action==ACTION_MACHINEGUNNER_DOWN)&&!random(5))
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					clearmgun(*unit[u]);
					}
				if(rightdist<tolerance&&
					(unit[u]->action==ACTION_STAND_UP||
					unit[u]->action==ACTION_STAND_DOWN||
					unit[u]->action==ACTION_MACHINEGUNNER_UP||
					unit[u]->action==ACTION_MACHINEGUNNER_DOWN)&&!random(5))
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					clearmgun(*unit[u]);
					}
				if(leftdist<rightdist&&
					unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<leftdist&&
					unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}

				if(leftdist>=tolerance&&
					(unit[u]->action==ACTION_WALK_LEFT||
					unit[u]->action==ACTION_STAND_LEFT)&&!random(5))
					{
					if(unit[u]->y==21)unit[u]->action=ACTION_STAND_DOWN;
					else unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					}
				if(rightdist>=tolerance&&
					(unit[u]->action==ACTION_WALK_RIGHT||
					unit[u]->action==ACTION_STAND_RIGHT)&&!random(5))
					{
					if(unit[u]->y==21)unit[u]->action=ACTION_STAND_DOWN;
					else unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					}
				}
			else
				{
				if(unit[u]->action==ACTION_WALK_LEFT||
					unit[u]->action==ACTION_WALK_RIGHT||
					unit[u]->action==ACTION_STAND_RIGHT||
					unit[u]->action==ACTION_STAND_LEFT)
					{
					if(unit[u]->y==21)unit[u]->action=ACTION_STAND_DOWN;
					else unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					}
				}

			//OPERATE MACHINE GUN
			if(charge==1||unit[u]->tired||!random(50))
				{
				if(unit[u]->action==ACTION_MACHINEGUNNER_DOWN)
					{
					if(unit[u]->tired)unit[u]->tired=0;
					else
						{
						unit[u]->action=ACTION_MACHINEGUNNER_SHOOT_DOWN;

						//PICK A TARGET IF POSSIBLE
						unit[u]->targid=-1;
						int xdist=800;

						for(int u2=0;u2<unit.size();u2++)
							{
							if(unit[u2]->invincible)continue;
							if(unit[u2]->type==UNIT_ALLY&&
								unit[u2]->action!=ACTION_MACHINEGUNNER_UP&&
								unit[u2]->action!=ACTION_MACHINEGUNNER_SHOOT_UP&&
								unit[u2]->action!=ACTION_WOUNDED&&
								unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
								unit[u2]->y>30)
								{
								if(abs(unit[u2]->x-unit[u]->x)+
									abs(unit[u2]->y-unit[u]->y)<xdist)
									{
									xdist=abs(unit[u2]->x-unit[u]->x)+
										abs(unit[u2]->y-unit[u]->y);
									unit[u]->targid=unit[u2]->id;
									}
								}
							}

						unit[u]->sweepmod+=random(3)-1;
						if(unit[u]->sweepmod>10)unit[u]->sweepmod=10;
						if(unit[u]->sweepmod<-10)unit[u]->sweepmod=-10;
						unit[u]->phase=0;

						for(int s=0;s<2;s++)
							{
							for(int g=0;g<3;g++)
								{
								if(machinegun[s][g]==1&&machinegununit[s][g]==unit[u])
									{
									machinegun[s][g]=2;
									}
								}
							}
						}
					}
				}

			//LOOK FOR A MACHINE GUN TO MAN
			if(unit[u]->y==21 && unit[u]->action==ACTION_STAND_DOWN)
				{
				for(int g=0;g<3;g++)
					{
					if(machinegun[1][g]==0&&
						abs(unit[u]->x-machinegunx[1][g])<10)
						{
						machinegun[1][g]=1;
						unit[u]->action=ACTION_MACHINEGUNNER_DOWN;
						unit[u]->x=machinegunx[1][g];
						machinegununit[1][g]=unit[u];
						break;
						}
					}
				if(unit[u]->action!=ACTION_STAND_DOWN)continue;
				}

			//LOOK FOR NEAR CHARGING ALLIES TO GRENADE
			if(charge==1 && unit[u]->y==21 &&
				unit[u]->action==ACTION_STAND_DOWN)
				{
				vector<int> goodu;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_ALLY&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y>50&&
						unit[u2]->y<100)
						{
						if(abs(unit[u2]->x-unit[u]->x)<50)
							{
							goodu.push_back(u2);
							}
						}
					}
				if(goodu.size()>0&&!random(120))
					{
					u2=goodu[random(goodu.size())];

					unit[u]->action=ACTION_CHUCK_DOWN;
					unit[u]->phase=0;
					unit[u]->targx=unit[u2]->x;
					unit[u]->targy=unit[u2]->y-20;
					}
				}

			//CHARGE GRENADE
			if(charge==-1 && unit[u]->y>350 && unit[u]->y<400 &&
				(unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_DOWN))
				{
				vector<int> goodu;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_ALLY&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y==429)
						{
						if(abs(unit[u2]->x-unit[u]->x)<50)
							{
							goodu.push_back(u2);
							}
						}
					}
				if(goodu.size()>0&&!random(40))
					{
					u2=goodu[random(goodu.size())];

					unit[u]->action=ACTION_CHUCK_DOWN;
					unit[u]->phase=0;
					unit[u]->targx=unit[u2]->x;
					unit[u]->targy=429;
					}
				}

			unit[u]->shotattime++;
			if(charge==-1&&unit[u]->y>350)unit[u]->shotattime=300;

			//SHOOT
			if((unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_DOWN)&&
				(!random(300)||charge==1&&!random(20))&&
				unit[u]->y>=21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_SHOOT_DOWN;

				//PICK A TARGET IF POSSIBLE
				unit[u]->targid=-1;
				int xdist=800;

				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_ALLY&&
						unit[u2]->action!=ACTION_MACHINEGUNNER_UP&&
						unit[u2]->action!=ACTION_MACHINEGUNNER_SHOOT_UP&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y>30)
						{
						if(abs(unit[u2]->x-unit[u]->x)+
							abs(unit[u2]->y-unit[u]->y)<xdist)
							{
							xdist=abs(unit[u2]->x-unit[u]->x)+
								abs(unit[u2]->y-unit[u]->y);
							unit[u]->targid=unit[u2]->id;
							}
						}
					}

				unit[u]->phase=0;
				}
			//CLIMB OUT
			else if(unit[u]->action==ACTION_STAND_DOWN&&charge==-1&&!random(5)&&unit[u]->y==21)
				{
				unit[u]->action=ACTION_CLIMB_DOWN;
				unit[u]->phase=0;
				}
			//DUCK IF SHOT AT
			else if((unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_UP)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime<120)
				{
				unit[u]->action=ACTION_LIE_UP;
				unit[u]->phase=0;
				}
			else if((unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_DOWN)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime<120)
				{
				unit[u]->action=ACTION_LIE_DOWN;
				unit[u]->phase=0;
				}
			//STAND UP IF SAFE
			else if((unit[u]->action==ACTION_LIE_UP||
				unit[u]->action==ACTION_CRAWL_UP)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime>=120)
				{
				unit[u]->action=ACTION_STAND_UP;
				unit[u]->phase=0;
				}
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_CRAWL_DOWN)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime>=120)
				{
				unit[u]->action=ACTION_STAND_DOWN;
				unit[u]->phase=0;
				}
			//CRAWL CHARGE
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_LIE_UP||
				unit[u]->action==ACTION_CRAWL_UP)&&
				charge==-1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_CRAWL_DOWN;
				unit[u]->phase=0;
				}
			//CRAWL RETREAT
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_LIE_UP||
				unit[u]->action==ACTION_CRAWL_DOWN)&&
				charge!=-1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_CRAWL_UP;
				unit[u]->phase=0;
				}
			//CHARGING ON FIELD
			else if((unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_UP)&&
				charge==-1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_WALK_DOWN;
				unit[u]->phase=0;
				}
			//RETREATING
			else if((unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_DOWN)&&
				charge!=-1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_WALK_UP;
				unit[u]->phase=0;
				}
			//MAKE SPACE
			else if(unit[u]->y==21&&unit[u]->action==ACTION_STAND_DOWN&&
				!random(5))
				{
				//FIND LEFT/RIGHT NEAREST NEIGHBORS
				int leftdist=800;
				int rightdist=800;
				int lu=-1,ru=-1;
				int tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(u==u2)continue;
					if(unit[u2]->type==UNIT_GERMAN&&
						unit[u2]->y==unit[u]->y)
						{
						tdist=unit[u2]->x-unit[u]->x;
						if(tdist>=0&&tdist<rightdist)
							{
							rightdist=tdist;
							ru=u2;
							}
						tdist=unit[u]->x-unit[u2]->x;
						if(tdist>=0&&tdist<leftdist)
							{
							leftdist=tdist;
							lu=u2;
							}
						}
					}

				if(leftdist<30||rightdist<30)
					{
					if(leftdist==0||rightdist==0)
						{
						if(unit[u]->x>10&&unit[u]->x<630)unit[u]->x+=random(2)*2-1;
						else if(unit[u]->x>10)unit[u]->x--;
						else if(unit[u]->x<630)unit[u]->x++;
						}
					else if(leftdist+1<rightdist&&unit[u]->x<630)
						{
						unit[u]->x++;
						}
					else if(leftdist>rightdist+1&&unit[u]->x>10)
						{
						unit[u]->x--;
						}
					}
				}
			}
		if(unit[u]->type==UNIT_ALLY)
			{
			//ATTACK/DEFEND TRENCH
			if((unit[u]->y==21)||
				(unit[u]->y==429&&etrench[1]))
				{
				int tolerance=800;
				if(unit[u]->y==429)tolerance=100;

				//FIND LEFT/RIGHT NEAREST NEIGHBORS
				int leftdist=800;
				int rightdist=800;
				int lu=-1,ru=-1;
				int tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if((unit[u2]->type==UNIT_GERMAN||
						unit[u2]->type==UNIT_GERMAN_MEDIC)&&
						unit[u2]->y==unit[u]->y)
						{
						tdist=unit[u2]->x-unit[u]->x;
						if(tdist>=0&&tdist<rightdist)
							{
							rightdist=tdist;
							ru=u2;
							}
						tdist=unit[u]->x-unit[u2]->x;
						if(tdist>=0&&tdist<leftdist)
							{
							leftdist=tdist;
							lu=u2;
							}
						}
					}

				//ATTACK WITH SHOVEL
				if(leftdist<15&&unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					if(random(2))unit[u]->action=ACTION_SHOVEL_LEFT1;
					else unit[u]->action=ACTION_SHOVEL_LEFT2;
					unit[u]->phase=0;
					unit[u]->targid=unit[lu]->id;
					switch(random(3))
						{
						case 0:playsound(SOUND_SWING1);break;
						case 1:playsound(SOUND_SWING2);break;
						case 2:playsound(SOUND_SWING3);break;
						}
					}
				if(rightdist<15&&unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					if(random(2))unit[u]->action=ACTION_SHOVEL_RIGHT1;
					else unit[u]->action=ACTION_SHOVEL_RIGHT2;
					unit[u]->phase=0;
					unit[u]->targid=unit[ru]->id;
					switch(random(3))
						{
						case 0:playsound(SOUND_SWING1);break;
						case 1:playsound(SOUND_SWING2);break;
						case 2:playsound(SOUND_SWING3);break;
						}
					}

				//WALKING
				if(leftdist<15&&unit[u]->action==ACTION_WALK_LEFT)
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<15&&unit[u]->action==ACTION_WALK_RIGHT)
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}
				if(leftdist<tolerance&&leftdist>=15&&unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					unit[u]->action=ACTION_WALK_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<tolerance&&rightdist>=15&&unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					unit[u]->action=ACTION_WALK_RIGHT;
					unit[u]->phase=0;
					}

				//FACE SHOVEL GUYS IF NECESSARY (UNMAN MACHINE GUN)
				if(leftdist<tolerance&&
					(unit[u]->action==ACTION_STAND_UP||
					unit[u]->action==ACTION_STAND_DOWN||
					unit[u]->action==ACTION_MACHINEGUNNER_UP||
					unit[u]->action==ACTION_MACHINEGUNNER_DOWN)&&!random(5))
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					clearmgun(*unit[u]);
					}
				if(rightdist<tolerance&&
					(unit[u]->action==ACTION_STAND_UP||
					unit[u]->action==ACTION_STAND_DOWN||
					unit[u]->action==ACTION_MACHINEGUNNER_UP||
					unit[u]->action==ACTION_MACHINEGUNNER_DOWN)&&!random(5))
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					clearmgun(*unit[u]);
					}
				if(leftdist<rightdist&&
					unit[u]->action==ACTION_STAND_RIGHT&&!random(5))
					{
					unit[u]->action=ACTION_STAND_LEFT;
					unit[u]->phase=0;
					}
				if(rightdist<leftdist&&
					unit[u]->action==ACTION_STAND_LEFT&&!random(5))
					{
					unit[u]->action=ACTION_STAND_RIGHT;
					unit[u]->phase=0;
					}

				if(leftdist>=tolerance&&rightdist>=tolerance&&
					(unit[u]->action==ACTION_WALK_LEFT||
					unit[u]->action==ACTION_WALK_RIGHT||
					unit[u]->action==ACTION_STAND_RIGHT||
					unit[u]->action==ACTION_STAND_LEFT)&&!random(5))
					{
					if(unit[u]->y==21)unit[u]->action=ACTION_STAND_DOWN;
					else unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					}
				}
			else
				{
				if(unit[u]->action==ACTION_WALK_LEFT||
					unit[u]->action==ACTION_WALK_RIGHT||
					unit[u]->action==ACTION_STAND_RIGHT||
					unit[u]->action==ACTION_STAND_LEFT)
					{
					if(unit[u]->y==21)unit[u]->action=ACTION_STAND_DOWN;
					else unit[u]->action=ACTION_STAND_UP;
					unit[u]->phase=0;
					}
				}

			//OPERATE MACHINE GUN
			if(charge==-1||unit[u]->tired||!random(50))
				{
				if(unit[u]->action==ACTION_MACHINEGUNNER_UP)
					{
					if(unit[u]->tired)unit[u]->tired=0;
					else
						{
						unit[u]->action=ACTION_MACHINEGUNNER_SHOOT_UP;

						//PICK A TARGET IF POSSIBLE
						unit[u]->targid=-1;
						int xdist=800;

						for(int u2=0;u2<unit.size();u2++)
							{
							if(unit[u2]->invincible)continue;
							if(unit[u2]->type==UNIT_GERMAN&&
								unit[u2]->action!=ACTION_MACHINEGUNNER_DOWN&&
								unit[u2]->action!=ACTION_MACHINEGUNNER_SHOOT_DOWN&&
								unit[u2]->action!=ACTION_WOUNDED&&
								unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
								unit[u2]->y<420)
								{
								if(abs(unit[u2]->x-unit[u]->x)+
									abs(unit[u2]->y-unit[u]->y)<xdist)
									{
									xdist=abs(unit[u2]->x-unit[u]->x)+
										abs(unit[u2]->y-unit[u]->y);
									unit[u]->targid=unit[u2]->id;
									}
								}
							}

						unit[u]->sweepmod+=random(3)-1;
						if(unit[u]->sweepmod>10)unit[u]->sweepmod=10;
						if(unit[u]->sweepmod<-10)unit[u]->sweepmod=-10;
						unit[u]->phase=0;

						for(int s=0;s<2;s++)
							{
							for(int g=0;g<3;g++)
								{
								if(machinegun[s][g]==1&&machinegununit[s][g]==unit[u])
									{
									machinegun[s][g]=2;
									}
								}
							}
						}
					}
				}

			//LOOK FOR A MACHINE GUN TO MAN
			if(unit[u]->y==429 && unit[u]->action==ACTION_STAND_UP)
				{
				for(int g=0;g<3;g++)
					{
					if(machinegun[0][g]==0&&
						abs(unit[u]->x-machinegunx[0][g])<10)
						{
						machinegun[0][g]=1;
						unit[u]->action=ACTION_MACHINEGUNNER_UP;
						unit[u]->x=machinegunx[0][g];
						machinegununit[0][g]=unit[u];
						break;
						}
					}
				if(unit[u]->action!=ACTION_STAND_UP)continue;
				}

			//LOOK FOR NEAR CHARGING GERMANS TO GRENADE
			if(charge==-1 && unit[u]->y==429 &&
				unit[u]->action==ACTION_STAND_UP)
				{
				vector<int> goodu;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_GERMAN&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y>350&&
						unit[u2]->y<400)
						{
						if(abs(unit[u2]->x-unit[u]->x)<50)
							{
							goodu.push_back(u2);
							}
						}
					}
				if(goodu.size()>0&&!random(120))
					{
					u2=goodu[random(goodu.size())];

					unit[u]->action=ACTION_CHUCK_UP;
					unit[u]->phase=0;
					unit[u]->targx=unit[u2]->x;
					unit[u]->targy=unit[u2]->y+20;
					continue;
					}
				}

			//CHARGE GRENADE
			if(charge==1 && unit[u]->y<100 && unit[u]->y>50 &&
				(unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_UP))
				{
				vector<int> goodu;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_GERMAN&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y==21)
						{
						if(abs(unit[u2]->x-unit[u]->x)<50)
							{
							goodu.push_back(u2);
							}
						}
					}
				if(goodu.size()>0&&!random(40))
					{
					u2=goodu[random(goodu.size())];

					unit[u]->action=ACTION_CHUCK_UP;
					unit[u]->phase=0;
					unit[u]->targx=unit[u2]->x;
					unit[u]->targy=21;
					continue;
					}
				}

			unit[u]->shotattime++;
			if(charge==1&&unit[u]->y<100)unit[u]->shotattime=300;

			//SHOOT
			if((unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_UP)&&
				(!random(300)||charge==-1&&!random(20))&&
				unit[u]->y>21&&unit[u]->y<=429)
				{
				unit[u]->action=ACTION_SHOOT_UP;

				//PICK A TARGET IF POSSIBLE
				unit[u]->targid=-1;
				int xdist=800;

				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->type==UNIT_GERMAN&&
						unit[u2]->action!=ACTION_MACHINEGUNNER_DOWN&&
						unit[u2]->action!=ACTION_MACHINEGUNNER_SHOOT_DOWN&&
						unit[u2]->action!=ACTION_WOUNDED&&
						unit[u2]->action!=ACTION_WOUNDED_CHOKE&&
						unit[u2]->y<420)
						{
						if(abs(unit[u2]->x-unit[u]->x)+
							abs(unit[u2]->y-unit[u]->y)<xdist)
							{
							xdist=abs(unit[u2]->x-unit[u]->x)+
								abs(unit[u2]->y-unit[u]->y);
							unit[u]->targid=unit[u2]->id;
							}
						}
					}

				unit[u]->phase=0;
				}
			//CLIMB OUT
			else if(unit[u]->action==ACTION_STAND_UP&&charge==1&&!random(5)&&unit[u]->y==429)
				{
				unit[u]->action=ACTION_CLIMB_UP;
				unit[u]->phase=0;
				}
			//DUCK IF SHOT AT
			else if((unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_WALK_UP)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime<120)
				{
				unit[u]->action=ACTION_LIE_UP;
				unit[u]->phase=0;
				}
			else if((unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_DOWN)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime<120)
				{
				unit[u]->action=ACTION_LIE_DOWN;
				unit[u]->phase=0;
				}
			//STAND UP IF SAFE
			else if((unit[u]->action==ACTION_LIE_UP||
				unit[u]->action==ACTION_CRAWL_UP)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime>=120)
				{
				unit[u]->action=ACTION_STAND_UP;
				unit[u]->phase=0;
				}
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_CRAWL_DOWN)&&
				unit[u]->y>21&&unit[u]->y<429&&
				unit[u]->shotattime>=120)
				{
				unit[u]->action=ACTION_STAND_DOWN;
				unit[u]->phase=0;
				}
			//CRAWL CHARGE
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_CRAWL_DOWN||
				unit[u]->action==ACTION_LIE_UP)&&
				charge==1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_CRAWL_UP;
				unit[u]->phase=0;
				}
			//CRAWL RETREAT
			else if((unit[u]->action==ACTION_LIE_DOWN||
				unit[u]->action==ACTION_LIE_UP||
				unit[u]->action==ACTION_CRAWL_UP)&&
				charge!=1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_CRAWL_DOWN;
				unit[u]->phase=0;
				}
			//CHARGING ON FIELD
			else if((unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_DOWN)&&
				charge==1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_WALK_UP;
				unit[u]->phase=0;
				}
			//RETREATING
			else if((unit[u]->action==ACTION_STAND_UP||
				unit[u]->action==ACTION_STAND_DOWN||
				unit[u]->action==ACTION_WALK_UP)&&
				charge!=1&&unit[u]->y>21&&unit[u]->y<429)
				{
				unit[u]->action=ACTION_WALK_DOWN;
				unit[u]->phase=0;
				}
			//MAKE SPACE
			else if(unit[u]->y==429&&unit[u]->action==ACTION_STAND_UP&&
				!random(5))
				{
				//FIND LEFT/RIGHT NEAREST NEIGHBORS
				int leftdist=800;
				int rightdist=800;
				int lu=-1,ru=-1;
				int tdist;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(u==u2)continue;
					if(unit[u2]->type==UNIT_ALLY&&
						unit[u2]->y==unit[u]->y)
						{
						tdist=unit[u2]->x-unit[u]->x;
						if(tdist>=0&&tdist<rightdist)
							{
							rightdist=tdist;
							ru=u2;
							}
						tdist=unit[u]->x-unit[u2]->x;
						if(tdist>=0&&tdist<leftdist)
							{
							leftdist=tdist;
							lu=u2;
							}
						}
					}

				if(leftdist<30||rightdist<30)
					{
					if(leftdist==0||rightdist==0)
						{
						if(unit[u]->x>10&&unit[u]->x<630)unit[u]->x+=random(2)*2-1;
						else if(unit[u]->x>10)unit[u]->x--;
						else if(unit[u]->x<630)unit[u]->x++;
						}
					else if(leftdist+1<rightdist&&unit[u]->x<630)
						{
						unit[u]->x++;
						}
					else if(leftdist>rightdist+1&&unit[u]->x>10)
						{
						unit[u]->x--;
						}
					}
				}
			}
		}

	//SAVE THE DEAD TO BACKGROUND
	for(u=unit.size()-1;u>=0;u--)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->dead)
			{
			saveguypicture(*unit[u]);
			delete unit[u];
			unit.erase(u);
			continue;
			}
		if(unit[u]->disappear)
			{
			delete unit[u];
			unit.erase(u);
			continue;
			}
		}

	//AERIAL PROBLEM INITIALIZATION
	lastplane++;
	if(!random(100)&&lastplane>100)
		{
		playsound(SOUND_PLANE);

		lastplane=2;
		projst *newp=new projst;
			newp->type=PROJ_PLANE;
			newp->vx=(random(2)*2-1)*50;
			if(newp->vx==-50)newp->x=2400;
			if(newp->vx==50)newp->x=-1760;
			newp->y=random(460)+10;

			newp->duration=0;
			newp->strafe=0;
			newp->bomb=0;
			if(random(2))newp->strafe=1;
			else newp->bomb=1;
			if(!random(5))newp->strafe=1;
			if(!random(5))newp->bomb=1;

		proj.push_back(newp);

		//WAVE
		if(!random(5))
			{
			int wx=newp->x;
			int wvx=newp->vx;
			newp->y=random(100)+40;
			int adj=random(50);
			newp->y=random(100)+10+adj;
			char str=newp->strafe;
			char b=newp->bomb;

			newp=new projst;
				newp->type=PROJ_PLANE;
				newp->vx=wvx;
				newp->x=wx+random(50);
				newp->y=random(100)+175+adj;
				newp->duration=0;
				newp->strafe=str;
				newp->bomb=b;
			proj.push_back(newp);

			newp=new projst;
				newp->type=PROJ_PLANE;
				newp->vx=wvx;
				newp->x=wx+random(50);
				newp->y=random(100)+325+adj;
				newp->duration=0;
				newp->strafe=str;
				newp->bomb=b;
			proj.push_back(newp);
			}
		}

	if(!random(25))
		{
		switch(random(3))
			{
			case 0:playsound(SOUND_FARMORTAR1);break;
			case 1:playsound(SOUND_FARMORTAR2);break;
			case 2:playsound(SOUND_FARMORTAR3);break;
			}
		}

	if(!random(50))
		{
		projst *newp=new projst;
			newp->type=PROJ_MORTAR;
			newp->x=random(600)+20;
			newp->y=random(400)+40;
			newp->duration=0;
			newp->bomb=0;
		proj.push_back(newp);

		if(!random(3))
			{
			float px=newp->x;
			float py=newp->y;

			newp=new projst;
				newp->type=PROJ_MORTAR;
				newp->x=px+random(31)-15;
				newp->y=py+random(31)-15;
				newp->duration=-random(7);
				newp->bomb=0;
			proj.push_back(newp);

			newp=new projst;
				newp->type=PROJ_MORTAR;
				newp->x=px+random(31)-15;
				newp->y=py+random(31)-15;
				newp->duration=-random(7);
				newp->bomb=0;
			proj.push_back(newp);

			if(!random(2))
				{
				newp=new projst;
					newp->type=PROJ_MORTAR;
					newp->x=px+random(41)-20;
					newp->y=py+random(41)-20;
					newp->duration=-random(15);
					newp->bomb=0;
				proj.push_back(newp);

				newp=new projst;
					newp->type=PROJ_MORTAR;
					newp->x=px+random(41)-20;
					newp->y=py+random(41)-20;
					newp->duration=-random(15);
					newp->bomb=0;
				proj.push_back(newp);

				if(!random(2))
					{
					newp=new projst;
						newp->type=PROJ_MORTAR;
						newp->x=px+random(51)-25;
						newp->y=py+random(51)-25;
						newp->duration=-random(15);
						newp->bomb=0;
					proj.push_back(newp);

					newp=new projst;
						newp->type=PROJ_MORTAR;
						newp->x=px+random(51)-25;
						newp->y=py+random(51)-25;
						newp->duration=-random(15);
						newp->bomb=0;
					proj.push_back(newp);

					if(!random(5))
						{
						int num=random(6)+5;
						for(int p=0;p<num;p++)
							{
							newp=new projst;
								newp->type=PROJ_MORTAR;
								newp->x=px+random(151)-75;
								newp->y=py+random(151)-75;
								newp->duration=-random(30);
								newp->bomb=0;
							proj.push_back(newp);
							}
						}
					}
				}
			}
		}

	if(!random(100))
		{
		projst *newp=new projst;
			newp->type=PROJ_MORTAR_GAS;
			newp->x=random(600)+20;
			newp->y=random(400)+40;
			newp->duration=0;
		proj.push_back(newp);
		}

	//UPDATE BACKGROUND
	for(int b=0;b<6;b++)
		{
		if(backaffected[b])
			{
			glBindTexture(GL_TEXTURE_2D,bmp_background[b].gennum);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
					 bmp_background[0].info.biWidth,bmp_background[b].info.biHeight,
					 0,GL_RGB,GL_UNSIGNED_BYTE,bmp_background[b].data);
			}
		}
}

void printguy(unitst &u)
{
	int apx=u.x-19;
	int apy=u.y;
	if(u.y>21&&u.y<429)
		{
		if((u.action!=ACTION_CLIMB_DOWN||u.y!=22)&&
			(u.action!=ACTION_CLIMB_UP||u.y!=428))
			{
			if(altitude[u.x][u.y+20]<=20)apy-=17;
			else if(altitude[u.x][u.y+20]<=40)apy-=18;
			else if(altitude[u.x][u.y+20]<=60)apy-=19;
			else if(altitude[u.x][u.y+20]<=80)apy-=20;
			else if(altitude[u.x][u.y+20]<=100)apy-=21;
			else if(altitude[u.x][u.y+20]<=120)apy-=22;
			else apy-=23;
			}
		}

	if(u.burdened>0&&(u.type==UNIT_GERMAN_MEDIC||u.type==UNIT_ALLY_MEDIC))
		{
		switch(u.action)
			{
			case ACTION_WALK_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_WALK1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_WALK2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_UP_WALK3_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_UP_WALK4_H,apx,apy,u.dir);
				break;
			case ACTION_WALK_RIGHT:
				if(u.phase==0)printguyframe(u.type,GUY_RIGHT_WALK1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_RIGHT_WALK2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_RIGHT_WALK3_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_RIGHT_WALK4_H,apx,apy,u.dir);
				break;
			case ACTION_WALK_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_WALK1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_WALK2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_DOWN_WALK3_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_DOWN_WALK4_H,apx,apy,u.dir);
				break;
			case ACTION_WALK_LEFT:
				if(u.phase==0)printguyframe(u.type,GUY_LEFT_WALK1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_LEFT_WALK2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_LEFT_WALK3_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_LEFT_WALK4_H,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_CRAWL2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_UP_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_UP_CRAWL3_H,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_RIGHT:
				if(u.phase==0)printguyframe(u.type,GUY_RIGHT_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_RIGHT_CRAWL2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_RIGHT_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_RIGHT_CRAWL3_H,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_CRAWL2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_DOWN_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_DOWN_CRAWL3_H,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_LEFT:
				if(u.phase==0)printguyframe(u.type,GUY_LEFT_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_LEFT_CRAWL2_H,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_LEFT_CRAWL1_H,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_LEFT_CRAWL3_H,apx,apy,u.dir);
				break;
			case ACTION_LIE_UP:
				printguyframe(u.type,GUY_UP_CRAWL1_H,apx,apy,u.dir);
				break;
			case ACTION_LIE_RIGHT:
				printguyframe(u.type,GUY_RIGHT_CRAWL1_H,apx,apy,u.dir);
				break;
			case ACTION_LIE_DOWN:
				printguyframe(u.type,GUY_DOWN_CRAWL1_H,apx,apy,u.dir);
				break;
			case ACTION_LIE_LEFT:
				printguyframe(u.type,GUY_LEFT_CRAWL1_H,apx,apy,u.dir);
				break;
			case ACTION_STAND_UP:
				printguyframe(u.type,GUY_UP_STAND_H,apx,apy,u.dir);
				break;
			case ACTION_STAND_RIGHT:
				printguyframe(u.type,GUY_RIGHT_STAND_H,apx,apy,u.dir);
				break;
			case ACTION_STAND_DOWN:
				printguyframe(u.type,GUY_DOWN_STAND_H,apx,apy,u.dir);
				break;
			case ACTION_STAND_LEFT:
				printguyframe(u.type,GUY_LEFT_STAND_H,apx,apy,u.dir);
				break;
			case ACTION_CLIMB_UP:
				if(u.phase==0)printguyframe(u.type,GUY_CLIMB1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_CLIMB2_H,apx,apy,u.dir);
				break;
			case ACTION_CLIMB_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_CLIMB1_H,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_CLIMB2_H,apx,apy,u.dir);
				break;
			}
		}
	else
		{
		switch(u.action)
			{
			case ACTION_WALK_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_WALK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_WALK2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_UP_WALK3,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_UP_WALK4,apx,apy,u.dir);
				break;
			case ACTION_WALK_RIGHT:
				if(u.phase==0)printguyframe(u.type,GUY_RIGHT_WALK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_RIGHT_WALK2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_RIGHT_WALK3,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_RIGHT_WALK4,apx,apy,u.dir);
				break;
			case ACTION_WALK_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_WALK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_WALK2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_DOWN_WALK3,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_DOWN_WALK4,apx,apy,u.dir);
				break;
			case ACTION_WALK_LEFT:
				if(u.phase==0)printguyframe(u.type,GUY_LEFT_WALK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_LEFT_WALK2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_LEFT_WALK3,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_LEFT_WALK4,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_CRAWL1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_CRAWL2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_UP_CRAWL1,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_UP_CRAWL3,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_RIGHT:
				if(u.phase==0)printguyframe(u.type,GUY_RIGHT_CRAWL1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_RIGHT_CRAWL2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_RIGHT_CRAWL1,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_RIGHT_CRAWL3,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_CRAWL1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_CRAWL2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_DOWN_CRAWL1,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_DOWN_CRAWL3,apx,apy,u.dir);
				break;
			case ACTION_CRAWL_LEFT:
				if(u.phase==0)printguyframe(u.type,GUY_LEFT_CRAWL1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_LEFT_CRAWL2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_LEFT_CRAWL1,apx,apy,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_LEFT_CRAWL3,apx,apy,u.dir);
				break;
			case ACTION_LIE_UP:
				printguyframe(u.type,GUY_UP_CRAWL1,apx,apy,u.dir);
				break;
			case ACTION_LIE_RIGHT:
				printguyframe(u.type,GUY_RIGHT_CRAWL1,apx,apy,u.dir);
				break;
			case ACTION_LIE_DOWN:
				printguyframe(u.type,GUY_DOWN_CRAWL1,apx,apy,u.dir);
				break;
			case ACTION_LIE_LEFT:
				printguyframe(u.type,GUY_LEFT_CRAWL1,apx,apy,u.dir);
				break;
			case ACTION_STAND_UP:
				printguyframe(u.type,GUY_UP_AIM,apx,apy,u.dir);
				break;
			case ACTION_STAND_RIGHT:
				printguyframe(u.type,GUY_RIGHT_STAND,apx,apy,u.dir);
				break;
			case ACTION_STAND_DOWN:
				if(apy==21)printguyframe(u.type,GUY_DOWN_AIM_HIDDEN,apx,apy,u.dir);
				else printguyframe(u.type,GUY_DOWN_AIM,apx,apy,u.dir);
				break;
			case ACTION_STAND_LEFT:
				printguyframe(u.type,GUY_LEFT_STAND,apx,apy,u.dir);
				break;
			case ACTION_SHOVEL_RIGHT1:
				if(u.phase==0)printguyframe(u.type,GUY_SHOVEL1,apx,apy,1);
				else if(u.phase==1)printguyframe(u.type,GUY_SHOVEL2,apx,apy,1);
				break;
			case ACTION_SHOVEL_RIGHT2:
				if(u.phase==0)printguyframe(u.type,GUY_SHOVEL3,apx,apy,1);
				else if(u.phase==1)printguyframe(u.type,GUY_SHOVEL4,apx,apy,1);
				break;
			case ACTION_SHOVEL_LEFT1:
				if(u.phase==0)printguyframe(u.type,GUY_SHOVEL1,apx,apy,0);
				else if(u.phase==1)printguyframe(u.type,GUY_SHOVEL2,apx,apy,0);
			case ACTION_SHOVEL_LEFT2:
				if(u.phase==0)printguyframe(u.type,GUY_SHOVEL3,apx,apy,0);
				else if(u.phase==1)printguyframe(u.type,GUY_SHOVEL4,apx,apy,0);
				break;
			case ACTION_DODGE_RIGHT:
				printguyframe(u.type,GUY_RIGHT_DODGE,apx,apy,u.dir);
				break;
			case ACTION_DODGE_LEFT:
				printguyframe(u.type,GUY_LEFT_DODGE,apx,apy,u.dir);
				break;
			case ACTION_BEHEADED:
				printguyframe(u.type,GUY_BEHEADED1,apx,apy,u.dir);
				break;
			case ACTION_SHOOT_UP:
				printguyframe(u.type,GUY_UP_SHOOT,apx,apy,u.dir);
				break;
			case ACTION_SHOOT_DOWN:
				if(apy==21)printguyframe(u.type,GUY_DOWN_SHOOT_HIDDEN,apx,apy,u.dir);
				else printguyframe(u.type,GUY_DOWN_SHOOT,apx,apy,u.dir);
				break;
			case ACTION_BLOWUP:
				if(u.phase==0)printguyframe(u.type,GUY_BLOWUP1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_BLOWUP2,apx,apy,u.dir);
				break;
			case ACTION_BLOWAPART:
				if(u.phase==0)printguyframe(u.type,GUY_BLOWAPART1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_BLOWAPART2,apx,apy,u.dir);
				break;
			case ACTION_CHOKE:
				if(u.phase==0)printguyframe(u.type,GUY_STRANGLE1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_STRANGLE2,apx,apy,u.dir);
				else if(u.phase==2)printguyframe(u.type,GUY_STRANGLE3,apx,apy+4,u.dir);
				else if(u.phase==3)printguyframe(u.type,GUY_STRANGLE4,apx,apy+4,u.dir);
				break;
			case ACTION_HIT_DEAD_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_HIT,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_HIT2,apx,apy,u.dir);
				break;
			case ACTION_HIT_FACE_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_FACED,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_FACED2,apx,apy,u.dir);
				break;
			case ACTION_HIT_LIVE_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_HIT,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_HIT2,apx,apy,u.dir);
				break;
			case ACTION_HIT_DEAD_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_HIT,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_HIT2,apx,apy,u.dir);
				break;
			case ACTION_HIT_FACE_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_FACED,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_FACED2,apx,apy,u.dir);
				break;
			case ACTION_HIT_LIVE_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_HIT,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_HIT2,apx,apy,u.dir);
				break;
			case ACTION_BANDAGE:
				if((u.phase/5)%2==0)printguyframe(u.type,GUY_BANDAGE1,apx,apy+4,u.dir);
				else if((u.phase/5)%2==1)printguyframe(u.type,GUY_BANDAGE2,apx,apy+4,u.dir);
				break;
			case ACTION_WOUNDED_CHOKE:
				if(u.bandaged)
					{
					if(u.phase==0)printguyframe(u.type,GUY_HIT3_BANDAGED,apx,apy+4,u.dir);
					else if(u.phase==1)printguyframe(u.type,GUY_HIT4_BANDAGED,apx,apy+4,u.dir);
					}
				else
					{
					if(u.phase==0)printguyframe(u.type,GUY_STRANGLE3,apx,apy+4,u.dir);
					else if(u.phase==1)printguyframe(u.type,GUY_STRANGLE4,apx,apy+4,u.dir);
					}
				break;
			case ACTION_WOUNDED:
				if(u.bandaged)
					{
					if(u.phase==0)printguyframe(u.type,GUY_HIT3_BANDAGED,apx,apy+4,u.dir);
					else if(u.phase==1)printguyframe(u.type,GUY_HIT4_BANDAGED,apx,apy+4,u.dir);
					}
				else
					{
					if(u.phase==0)printguyframe(u.type,GUY_HIT3,apx,apy+4,u.dir);
					else if(u.phase==1)printguyframe(u.type,GUY_HIT4,apx,apy+4,u.dir);
					}
				break;
			case ACTION_CLIMB_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_CLIMB,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_CLIMB2,apx,apy,u.dir);
				break;
			case ACTION_CLIMB_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_CLIMB,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_CLIMB2,apx,apy,u.dir);
				break;
			case ACTION_CHUCK_UP:
				if(u.phase==0)printguyframe(u.type,GUY_UP_CHUCK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_UP_CHUCK2,apx,apy,u.dir);
				break;
			case ACTION_CHUCK_DOWN:
				if(u.phase==0)printguyframe(u.type,GUY_DOWN_CHUCK1,apx,apy,u.dir);
				else if(u.phase==1)printguyframe(u.type,GUY_DOWN_CHUCK2,apx,apy,u.dir);
				break;
			}
		}
}

void printguyframe(int type,int f,int x,int y,char dir)
{
	if(deadtime>0)glColor3f(1,(float)(100-deadtime)/100.0f,(float)(100-deadtime)/100.0f);
	else glColor3f(1,1,1);

	float stx,sty,etx,ety;
	float seventh=40.0f/256.0f;
	int part;

	if((type==UNIT_GERMAN_MEDIC||
		type==UNIT_ALLY_MEDIC)&&f==GUY_DOWN_AIM)
		{
		f=GUY_DOWN_AIM_HIDDEN;
		}

	switch(f)
		{
		case GUY_DOWN_AIM_HIDDEN:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_DOWN_WALK1:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_DOWN_WALK2:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_DOWN_WALK3:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_DOWN_WALK4:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_DOWN_CLIMB:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_UP_AIM:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_UP_WALK1:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_UP_WALK2:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_UP_WALK3:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_UP_WALK4:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_UP_CLIMB:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_DOWN_HIT:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_HIT2:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_HIT3:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_HIT4:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_HIT3_BANDAGED:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_HIT4_BANDAGED:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_DOWN_FACED:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_FACED2:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_FACED3:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_FACED:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_DOWN_CHUCK1:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_DOWN_CHUCK2:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_DOWN_AIM:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_DOWN_SHOOT:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_DOWN_SHOOT_HIDDEN:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_SHOOT:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CHUCK1:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CHUCK2:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_STRANGLE1:
			part=0;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_STRANGLE2:
			part=0;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_STRANGLE3:
			part=0;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_STRANGLE4:
			part=0;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_BEHEADED1:
			part=0;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_BEHEADED2:
			part=0;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		//NEXT FILE
		case GUY_DOWN_CLIMB2:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_RIGHT_STAND:
			if(dir==1)
				{
				part=1;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=1;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK1:
			if(dir)
				{
				part=1;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=1;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK2:
			if(dir)
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK3:
			if(dir)
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK4:
			if(dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_UP_CLIMB2:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_LEFT_STAND:
			if(dir==1)
				{
				part=1;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK1:
			if(dir)
				{
				part=1;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK2:
			if(dir)
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK3:
			if(dir)
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK4:
			if(dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			break;
		case GUY_UP_HIT:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_SHOVEL1:
			part=1;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_SHOVEL2:
			part=1;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_SHOVEL3:
			part=1;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_SHOVEL4:
			part=1;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_RIGHT_DODGE:
			if(dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
				}
			break;
		case GUY_BLOWAPART1:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_BLOWAPART2:
			part=1;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_BLOWAPART3:
			part=1;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_BLOWUP1:
			part=1;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_BLOWUP2:
			part=1;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_LEFT_DODGE:
			if(dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
				}
			break;
		case GUY_UP_CRAWL1:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CRAWL2:
			part=1;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CRAWL3:
			part=1;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_RIGHT_CRAWL1:
			if(dir)
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_CRAWL2:
			if(dir)
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_CRAWL3:
			if(dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_DOWN_CRAWL1:
			part=1;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_DOWN_CRAWL2:
			part=1;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_DOWN_CRAWL3:
			part=1;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_LEFT_CRAWL1:
			if(dir)
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_CRAWL2:
			if(dir)
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_CRAWL3:
			if(!dir)
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=1;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		//NEXT FILE
		case GUY_CLIMB1_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
			break;
		case GUY_RIGHT_STAND_H:
			if(dir)
				{
				part=2;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK1_H:
			if(dir)
				{
				part=2;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK2_H:
			if(dir)
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK3_H:
			if(dir)
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_WALK4_H:
			if(dir)
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_CLIMB2_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
			break;
		case GUY_LEFT_STAND_H:
			if(!dir)
				{
				part=2;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK1_H:
			if(!dir)
				{
				part=2;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK2_H:
			if(!dir)
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK3_H:
			if(!dir)
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_WALK4_H:
			if(!dir)
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f;ety=.9999f-(seventh-.010f);
				}
			else
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(seventh+.010f);ety=.9999f-(2.0*seventh-.010f);
				}
			break;
		case GUY_DOWN_STAND_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_DOWN_WALK1_H:
			part=2;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_DOWN_WALK2_H:
			part=2;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_DOWN_WALK3_H:
			part=2;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_DOWN_WALK4_H:
			part=2;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_BANDAGE1:
			part=2;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(2.0f*seventh+.010f);ety=.9999f-(3.0*seventh-.010f);
			break;
		case GUY_UP_STAND_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_WALK1_H:
			part=2;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_WALK2_H:
			part=2;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_WALK3_H:
			part=2;
			stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_WALK4_H:
			part=2;
			stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_BANDAGE2:
			part=2;
			stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(3.0f*seventh+.010f);ety=.9999f-(4.0*seventh-.010f);
			break;
		case GUY_UP_CRAWL1_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CRAWL2_H:
			part=2;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_UP_CRAWL3_H:
			part=2;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
			break;
		case GUY_RIGHT_CRAWL1_H:
			if(dir)
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_CRAWL2_H:
			if(dir)
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_RIGHT_CRAWL3_H:
			if(dir)
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_DOWN_CRAWL1_H:
			part=2;
			stx=.0001f;etx=seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_DOWN_CRAWL2_H:
			part=2;
			stx=seventh+.010f;etx=2.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_DOWN_CRAWL3_H:
			part=2;
			stx=2.0*seventh+.010f;etx=3.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
			break;
		case GUY_LEFT_CRAWL1_H:
			if(!dir)
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=3.0*seventh+.010f;etx=4.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_CRAWL2_H:
			if(!dir)
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=4.0*seventh+.010f;etx=5.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		case GUY_LEFT_CRAWL3_H:
			if(!dir)
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(4.0f*seventh+.010f);ety=.9999f-(5.0*seventh-.010f);
				}
			else
				{
				part=2;
				stx=5.0*seventh+.010f;etx=6.0*seventh-.010f;sty=.9999f-(5.0f*seventh+.010f);ety=.9999f-(6.0*seventh-.010f);
				}
			break;
		}

	switch(type)
		{
		case UNIT_GERMAN:
			if(part==0)glBindTexture(GL_TEXTURE_2D,bmp_unit[0].gennum);
			else glBindTexture(GL_TEXTURE_2D,bmp_unit[1].gennum);
			break;
		case UNIT_GERMAN_MEDIC:
			if(part==0)glBindTexture(GL_TEXTURE_2D,bmp_unit[2].gennum);
			else if(part==1)glBindTexture(GL_TEXTURE_2D,bmp_unit[3].gennum);
			else glBindTexture(GL_TEXTURE_2D,bmp_unit[4].gennum);
			break;
		case UNIT_ALLY:
			if(part==0)glBindTexture(GL_TEXTURE_2D,bmp_unit[5].gennum);
			else glBindTexture(GL_TEXTURE_2D,bmp_unit[6].gennum);
			break;
		case UNIT_ALLY_MEDIC:
			if(part==0)glBindTexture(GL_TEXTURE_2D,bmp_unit[7].gennum);
			else if(part==1)glBindTexture(GL_TEXTURE_2D,bmp_unit[8].gennum);
			else glBindTexture(GL_TEXTURE_2D,bmp_unit[9].gennum);
			break;
		}

	if(dir)
		{
		glBegin(GL_QUADS);
			glTexCoord2f(stx,sty);
			glVertex2f(x,y);
			glTexCoord2f(stx,ety);
			glVertex2f(x,y+38);
			glTexCoord2f(etx,ety);
			glVertex2f(x+38,y+38);
			glTexCoord2f(etx,sty);
			glVertex2f(x+38,y);
		glEnd();
		}
	else
		{
		glBegin(GL_QUADS);
			glTexCoord2f(etx,sty);
			glVertex2f(x,y);
			glTexCoord2f(etx,ety);
			glVertex2f(x,y+38);
			glTexCoord2f(stx,ety);
			glVertex2f(x+38,y+38);
			glTexCoord2f(stx,sty);
			glVertex2f(x+38,y);
		glEnd();
		}
}

void prepbattlefield(void)
{
	for(int x=0;x<640;x++)
		{
		for(int y=0;y<480;y++)
			{
			altitude[x][y]=70;
			}
		}
	memset(groundflag,0,sizeof(char)*640*480);

	//BACKGROUND
	for(int b=0;b<6;b++)
		{
		if(first)
			{
			bmp_background[b].data=new unsigned char[256*256*3];
			bmp_background2[b].data=new unsigned char[256*256*3];

			long d=0;
			long ymod=b/3*256+256;
			for(int y=0;y<256;y++)
				{
				for(int x=0;x<256;x++)
					{
					if(ymod-y>465||ymod-y<40)
						{
						bmp_background[b].data[d]=30+random(5);
						bmp_background[b].data[d+1]=15+random(2);
						bmp_background[b].data[d+2]=5+random(2);
						}
					else if(ymod-y>447)
						{
						bmp_background[b].data[d]=50+random(7);
						bmp_background[b].data[d+1]=30+random(3);
						bmp_background[b].data[d+2]=10+random(2);
						}
					else if(ymod-y>440)
						{
						bmp_background[b].data[d]=60+random(8);
						bmp_background[b].data[d+1]=40+random(4);
						bmp_background[b].data[d+2]=20+random(2);
						}
					else
						{
						bmp_background[b].data[d]=70+random(10);
						bmp_background[b].data[d+1]=35+random(4);
						bmp_background[b].data[d+2]=8+random(2);
						}
					d+=3;
					}
				}
			bmp_background[b].info.biWidth=256;
			bmp_background[b].info.biHeight=256;
			glGenTextures(1,&bmp_background[b].gennum);
			glBindTexture(GL_TEXTURE_2D,bmp_background[b].gennum);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
					 bmp_background[b].info.biWidth,bmp_background[b].info.biHeight,
					 0,GL_RGB,GL_UNSIGNED_BYTE,bmp_background[b].data);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			}
		else
			{
			memmove(bmp_background[b].data,bmp_background2[b].data,sizeof(unsigned char)*256*256*3);

			glBindTexture(GL_TEXTURE_2D,bmp_background[b].gennum);
			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
					 bmp_background[b].info.biWidth,bmp_background[b].info.biHeight,
					 0,GL_RGB,GL_UNSIGNED_BYTE,bmp_background[b].data);
			}

		long d=0;
		long ymod=b/3*256+256;
		for(int y=0;y<256;y++)
			{
			for(int x=0;x<256;x++)
				{
				if(ymod-y>465||ymod-y<40)
					{
					bmp_background2[b].data[d]=30+random(5);
					bmp_background2[b].data[d+1]=15+random(2);
					bmp_background2[b].data[d+2]=5+random(2);
					}
				else if(ymod-y>447)
					{
					bmp_background2[b].data[d]=50+random(7);
					bmp_background2[b].data[d+1]=30+random(3);
					bmp_background2[b].data[d+2]=10+random(2);
					}
				else if(ymod-y>440)
					{
					bmp_background2[b].data[d]=60+random(8);
					bmp_background2[b].data[d+1]=40+random(4);
					bmp_background2[b].data[d+2]=20+random(2);
					}
				else
					{
					bmp_background2[b].data[d]=70+random(10);
					bmp_background2[b].data[d+1]=35+random(4);
					bmp_background2[b].data[d+2]=8+random(2);
					}
				d+=3;
				}
			}
		if(first)
			{
			bmp_background2[b].info.biWidth=256;
			bmp_background2[b].info.biHeight=256;
			glGenTextures(1,&bmp_background2[b].gennum);
			}
		glBindTexture(GL_TEXTURE_2D,bmp_background2[b].gennum);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB,
				 bmp_background2[b].info.biWidth,bmp_background2[b].info.biHeight,
				 0,GL_RGB,GL_UNSIGNED_BYTE,bmp_background2[b].data);
		if(first)
			{
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			}
		}

	//CLEAR OLD CRAP
	if(!first)
		{
		for(int p=0;p<proj.size();p++)delete proj[p];
		proj.clear();
		for(p=unit.size()-1;p>=0;p--)
			{
			if(unit[p]->invincible)continue;
			delete unit[p];
			unit.erase(p);
			}

		won=0;
		wonscroll=0;
		charge=0;
		lastplane=0;
		chargetimer=100;
		gcount_bat=0;
		ycount_bat=0;
		gmediccount=0;
		ymediccount=0;
		trenches++;
		}

	//HANDLE NEW GERMANS
	for(int u=0;u<unit.size();u++)
		{
		unit[u]->invincible=0;
		unit[u]->action=ACTION_WALK_DOWN;
		unit[u]->phase=3;
		}

	//SET UP UNIT LINE
	unitst *newu;
	if(first)
		{
		for(int u=0;u<40;u++)
			{
			newu=new unitst;
				newu->type=UNIT_GERMAN;
				newu->x=31+u*15+random(3);
				newu->y=21;
				newu->action=ACTION_STAND_DOWN;
				newu->phase=0;
			unit.push_back(newu);
			}
		}

	for(u=0;u<40;u++)
		{
		newu=new unitst;
			newu->type=UNIT_ALLY;
			newu->x=31+u*15+random(3);
			if(!first)
				{
				newu->y=530;
				newu->action=ACTION_WALK_UP;
				newu->phase=0;
				}
			else
				{
				newu->y=429;
				newu->action=ACTION_STAND_UP;
				newu->phase=0;
				}
		unit.push_back(newu);
		}

	newu=new unitst;
		newu->type=UNIT_GERMAN_MEDIC;
		newu->x=320;
		newu->y=-50;
		newu->action=ACTION_WALK_DOWN;
		newu->phase=0;
	unit.push_back(newu);

	newu=new unitst;
		newu->type=UNIT_ALLY_MEDIC;
		newu->x=320;
		if(first)
			{
			newu->y=500;
			newu->action=ACTION_WALK_UP;
			newu->phase=0;
			}
		else
			{
			newu->y=429;
			newu->action=ACTION_STAND_UP;
			newu->phase=0;
			}
		newu->dir=wondir;
	unit.push_back(newu);
	you=newu;

	machinegun[0][0]=0;
	machinegun[0][1]=0;
	machinegun[0][2]=0;
	machinegun[1][0]=0;
	machinegun[1][1]=0;
	machinegun[1][2]=0;
	if(first)
		{
		machinegunx[0][0]=120+random(51)-25;
		machinegunx[0][1]=320+random(51)-25;
		machinegunx[0][2]=520+random(51)-25;
		machinegunx[1][0]=120+random(51)-25;
		machinegunx[1][1]=320+random(51)-25;
		machinegunx[1][2]=520+random(51)-25;
		}
	else
		{
		for(int s=0;s<2;s++)
			{
			for(int g=0;g<3;g++)
				{
				machinegunx[s][g]=machinegunx2[s][g];
				}
			}
		}
	machinegunx2[0][0]=120+random(51)-25;
	machinegunx2[0][1]=320+random(51)-25;
	machinegunx2[0][2]=520+random(51)-25;
	machinegunx2[1][0]=120+random(51)-25;
	machinegunx2[1][1]=320+random(51)-25;
	machinegunx2[1][2]=520+random(51)-25;
	machinegununit[0][0]=NULL;
	machinegununit[0][1]=NULL;
	machinegununit[0][2]=NULL;
	machinegununit[1][0]=NULL;
	machinegununit[1][1]=NULL;
	machinegununit[1][2]=NULL;

	first=0;
}

void shoot(unitst &u)
{
	if(u.action==ACTION_MACHINEGUNNER_SHOOT_DOWN||
		u.action==ACTION_MACHINEGUNNER_SHOOT_UP)
		{
		switch(random(4))
			{
			case 0:playsound(SOUND_MGSHOT1);break;
			case 1:playsound(SOUND_MGSHOT2);break;
			case 2:playsound(SOUND_MGSHOT3);break;
			case 3:playsound(SOUND_MGSHOT4);break;
			}
		}
	else
		{
		switch(random(4))
			{
			case 0:playsound(SOUND_SHOT1);break;
			case 1:playsound(SOUND_SHOT2);break;
			case 2:playsound(SOUND_SHOT3);break;
			case 3:playsound(SOUND_SHOT4);break;
			}
		}

	projst *newp=new projst;
		newp->type=PROJ_BULLET;
		if(u.type==UNIT_ALLY)newp->side=1;
		else newp->side=0;
		newp->x=u.x;
		newp->y=u.y;
		newp->ox=u.x;
		newp->oy=u.y;
		newp->z=4;
		newp->oz=4;
		newp->strafe=0;
		if(u.action==ACTION_MACHINEGUNNER_SHOOT_UP)
			{
			newp->vx=((float)((long)random(601)-300))/100.0f+u.sweepmod;
			newp->vy=-35-((float)((long)random(101)-50))/10.0f;
			newp->strafe=1;

			if(u.targid!=-1)
				{
				int t=-1;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->id==u.targid)
						{
						t=u2;
						break;
						}
					}

				if(t!=-1)
					{
					long dx=unit[t]->x-u.x;
					long dy=unit[t]->y-u.y;
					if(dx>0||dy>0)
						{
						float dist=sqrt(dx*dx+dy*dy);
						newp->vx=(float)(dx*35)/dist+((float)((long)random(601)-300))/300.0f;
						newp->vy=(float)(dy*35)/dist+((float)((long)random(601)-300))/300.0f;
						}
					}
				}

			newp->vx+=(float)((random(301)-150))/50.0f;
			newp->vy+=(float)((random(301)-150))/50.0f;
			}
		if(u.action==ACTION_MACHINEGUNNER_SHOOT_DOWN)
			{
			newp->vx=((float)((long)random(601)-300))/100.0f+u.sweepmod;
			newp->vy=35+((float)((long)random(101)-50))/10.0f;

			if(u.targid!=-1)
				{
				int t=-1;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->id==u.targid)
						{
						t=u2;
						break;
						}
					}

				if(t!=-1)
					{
					long dx=unit[t]->x-u.x;
					long dy=unit[t]->y-u.y;
					if(dx>0||dy>0)
						{
						float dist=sqrt(dx*dx+dy*dy);
						newp->vx=(float)(dx*35)/dist+((float)((long)random(601)-300))/300.0f;
						newp->vy=(float)(dy*35)/dist+((float)((long)random(601)-300))/300.0f;
						}
					}
				}

			newp->strafe=1;
			newp->oy+=10;
			newp->y+=10;

			newp->vx+=(float)((random(301)-150))/50.0f;
			newp->vy+=(float)((random(301)-150))/50.0f;
			}
		if(u.action==ACTION_SHOOT_UP)
			{
			newp->vx=((float)((long)random(101)-50))/100.0f;
			newp->vy=-30-((float)((long)random(101)-50))/10.0f;

			if(u.targid!=-1)
				{
				int t=-1;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->id==u.targid)
						{
						t=u2;
						break;
						}
					}

				if(t!=-1)
					{
					long dx=unit[t]->x-u.x;
					long dy=unit[t]->y-u.y;
					if(dx>0||dy>0)
						{
						float dist=sqrt(dx*dx+dy*dy);
						newp->vx=(float)(dx*30)/dist+((float)((long)random(601)-300))/800.0f;
						newp->vy=(float)(dy*30)/dist+((float)((long)random(601)-300))/800.0f;
						}
					}
				}

			newp->vx+=(float)((random(301)-150))/50.0f;
			newp->vy+=(float)((random(301)-150))/50.0f;
			}
		if(u.action==ACTION_SHOOT_DOWN)
			{
			newp->vx=((float)((long)random(101)-50))/100.0f;
			newp->vy=30+((float)((long)random(101)-50))/10.0f;

			if(u.targid!=-1)
				{
				int t=-1;
				for(int u2=0;u2<unit.size();u2++)
					{
					if(unit[u2]->invincible)continue;
					if(unit[u2]->id==u.targid)
						{
						t=u2;
						break;
						}
					}

				if(t!=-1)
					{
					long dx=unit[t]->x-u.x;
					long dy=unit[t]->y-u.y;
					if(dx>0||dy>0)
						{
						float dist=sqrt(dx*dx+dy*dy);
						newp->vx=(float)(dx*30)/dist+((float)((long)random(601)-300))/800.0f;
						newp->vy=(float)(dy*30)/dist+((float)((long)random(601)-300))/800.0f;
						}
					}
				}

			newp->oy+=10;
			newp->y+=10;

			newp->vx+=(float)((random(301)-150))/50.0f;
			newp->vy+=(float)((random(301)-150))/50.0f;
			}
		newp->vz=(float)((long)random(101)-50)/100.0f;
		newp->color[0]=10;
		newp->color[1]=10;
		newp->color[2]=10;
		newp->owner=u.id;
		newp->x+=newp->vx;
		newp->y+=newp->vy;
	proj.push_back(newp);
}

void saveguypicture(unitst &u)
{
	int f=-1;

	switch(u.action)
		{
		case ACTION_BEHEADED:
			f=GUY_BEHEADED2;
			break;
		case ACTION_BLOWAPART:
			f=GUY_BLOWAPART3;
			break;
		case ACTION_CHOKE:
			if(u.phase==2)f=GUY_STRANGLE3;
			else f=GUY_STRANGLE4;
			break;
		case ACTION_WOUNDED:
		case ACTION_HIT_DEAD_UP:
		case ACTION_HIT_DEAD_DOWN:
			if(u.bandaged)
				{
				if(u.phase==2)f=GUY_HIT3_BANDAGED;
				else f=GUY_HIT4_BANDAGED;
				}
			else
				{
				if(u.phase==2)f=GUY_HIT3;
				else f=GUY_HIT4;
				}
			break;
		case ACTION_WOUNDED_CHOKE:
			if(u.bandaged)
				{
				if(u.phase==2)f=GUY_HIT3_BANDAGED;
				else f=GUY_HIT4_BANDAGED;
				}
			else
				{
				if(u.phase==2)f=GUY_STRANGLE3;
				else f=GUY_STRANGLE4;
				}
			break;
		case ACTION_HIT_FACE_UP:
		case ACTION_HIT_FACE_DOWN:
			f=GUY_FACED3;
			break;
		}

	if(f!=-1)
		{
		int part;
		int sx,sy,ex,ey;

		switch(f)
			{
			case GUY_BEHEADED2:
				part=0;
				sx=200;ex=238;sy=201;ey=239;
				break;
			case GUY_BLOWAPART3:
				part=1;
				sx=80;ex=118;sy=121;ey=159;
				break;
			case GUY_STRANGLE3:
				part=0;
				sx=80;ex=118;sy=201;ey=239;
				break;
			case GUY_STRANGLE4:
				part=0;
				sx=120;ex=158;sy=201;ey=239;
				break;
			case GUY_HIT3:
				part=0;
				sx=80;ex=118;sy=81;ey=119;
				break;
			case GUY_HIT4:
				part=0;
				sx=120;ex=158;sy=81;ey=119;
				break;
			case GUY_FACED3:
				part=0;
				sx=80;ex=118;sy=121;ey=159;
				break;
			case GUY_HIT3_BANDAGED:
				part=0;
				sx=160;ex=198;sy=81;ey=119;
				break;
			case GUY_HIT4_BANDAGED:
				part=0;
				sx=200;ex=238;sy=81;ey=119;
				break;
			}

		int swap=ey;
		ey=256-sy;
		sy=256-swap;

		unsigned char *data=NULL;

		switch(u.type)
			{
			case UNIT_GERMAN:
				if(part==0)data=bmp_unit[0].data;
				else data=bmp_unit[1].data;
				break;
			case UNIT_GERMAN_MEDIC:
				if(part==0)data=bmp_unit[2].data;
				else if(part==1)data=bmp_unit[3].data;
				else data=bmp_unit[4].data;
				break;
			case UNIT_ALLY:
				if(part==0)data=bmp_unit[5].data;
				else data=bmp_unit[6].data;
				break;
			case UNIT_ALLY_MEDIC:
				if(part==0)data=bmp_unit[7].data;
				else if(part==1)data=bmp_unit[8].data;
				else data=bmp_unit[9].data;
				break;
			}

		if(data!=NULL)
			{
			int i,i2;
			int bx,by,b;
			for(int y=sy;y<=ey;y++)
				{
				for(int x=sx;x<=ex;x++)
					{
					i=(x+y*256)*4;
					if(data[i+3]!=0)
						{
						if(u.dir)bx=x-sx+u.x-19;
						else bx=ex-x+u.x-19;
						by=ey-y+u.y+5;
						if(u.y>21&&u.y<429)
							{
							if(altitude[u.x][u.y+20]<=20)by-=17;
							else if(altitude[u.x][u.y+20]<=40)by-=18;
							else if(altitude[u.x][u.y+20]<=60)by-=19;
							else if(altitude[u.x][u.y+20]<=80)by-=20;
							else if(altitude[u.x][u.y+20]<=100)by-=21;
							else if(altitude[u.x][u.y+20]<=120)by-=22;
							else by-=23;
							}
						else if(u.y<=21&&by>21)continue;
						if(bx>=0&&bx<640&&by>=0&&by<480)
							{
							groundflag[bx][by]|=GROUNDFLAG_CHUNKY;

							b=0;
							while(bx>=256)
								{
								bx-=256;
								b++;
								}
							while(by>=256)
								{
								by-=256;
								b+=3;
								}
							backaffected[b]=1;

							i2=(bx+(255-by)*256)*3;
							bmp_background[b].data[i2]=data[i];
							bmp_background[b].data[i2+1]=data[i+1];
							bmp_background[b].data[i2+2]=data[i+2];
							}
						}
					}
				}
			}
		}
}


void colorground(unsigned char color[3],int x,int y)
{
	if(x>=0&&x<640&&y>=0&&y<480)
		{
		groundflag[x][y]&=~GROUNDFLAG_CHUNKY;

		int b=0;
		while(x>=256)
			{
			x-=256;
			b++;
			}
		while(y>=256)
			{
			y-=256;
			b+=3;
			}
		backaffected[b]=1;

		int i2=(x+(255-y)*256)*3;
		bmp_background[b].data[i2]=color[0];
		bmp_background[b].data[i2+1]=color[1];
		bmp_background[b].data[i2+2]=color[2];
		}
}

char hitunit(projst &p,unitst &u)
{
	if(u.dead)return 0;
	switch(u.action)
		{
		case ACTION_BLOWUP:
		case ACTION_BLOWAPART:
		case ACTION_BEHEADED:
		case ACTION_CHOKE:
		case ACTION_WOUNDED:
		case ACTION_WOUNDED_CHOKE:
		case ACTION_MACHINEGUNNER_UP:
		case ACTION_MACHINEGUNNER_SHOOT_UP:
		case ACTION_MACHINEGUNNER_DOWN:
		case ACTION_MACHINEGUNNER_SHOOT_DOWN:
			return 0;
		case ACTION_HIT_DEAD_DOWN:
		case ACTION_HIT_FACE_DOWN:
		case ACTION_HIT_LIVE_DOWN:
		case ACTION_HIT_DEAD_UP:
		case ACTION_HIT_FACE_UP:
		case ACTION_HIT_LIVE_UP:
			if(u.phase>=2)return 0;
			break;
		}
	if(abs((int)p.x-u.x)>10||abs((int)p.y-u.y)>10)return 0;

	int shootchance=2;
	if(u.action==ACTION_CRAWL_UP||
		u.action==ACTION_CRAWL_LEFT||
		u.action==ACTION_CRAWL_RIGHT||
		u.action==ACTION_CRAWL_DOWN||
		u.action==ACTION_BANDAGE)shootchance=10;
	if(u.action==ACTION_LIE_UP||
		u.action==ACTION_LIE_RIGHT||
		u.action==ACTION_LIE_DOWN||
		u.action==ACTION_LIE_LEFT)shootchance=20;
	if((u.action==ACTION_LIE_UP||
		u.action==ACTION_LIE_RIGHT||
		u.action==ACTION_LIE_DOWN||
		u.action==ACTION_LIE_LEFT)&&(u.y<=21||u.y>=429))return 0;
	if((u.action==ACTION_CRAWL_UP||
		u.action==ACTION_CRAWL_RIGHT||
		u.action==ACTION_CRAWL_DOWN||
		u.action==ACTION_CRAWL_LEFT||
		u.action==ACTION_BANDAGE)&&(u.y<=21||u.y>=429))return 0;
	if(u.y<21||u.y>429)return 0;
	if((u.y<=21||u.y>=429)&&u.action!=ACTION_CLIMB_UP&&u.action!=ACTION_CLIMB_DOWN)shootchance=20;

	if(!random(shootchance))
		{
		switch(random(4))
			{
			case 0:playsound(SOUND_SCREAM1);break;
			case 1:playsound(SOUND_SCREAM2);break;
			case 2:playsound(SOUND_SCREAM3);break;
			case 3:playsound(SOUND_SCREAM4);break;
			}

		switch(u.action)
			{
			case ACTION_CRAWL_LEFT:
			case ACTION_LIE_LEFT:
				switch(random(3))
					{
					case 0:
						u.action=ACTION_WOUNDED;
						u.phase=0;
						u.timer=500;
						u.dir=1;
						break;
					case 1:
						u.action=ACTION_HIT_FACE_UP;
						u.phase=2;
						u.dead=1;
						u.dir=0;
						break;
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						u.phase=2;
						u.dead=1;
						u.dir=1;
						break;
					}
				break;
			case ACTION_LIE_RIGHT:
			case ACTION_CRAWL_RIGHT:
			case ACTION_BANDAGE:
				switch(random(3))
					{
					case 0:
						u.action=ACTION_WOUNDED;
						u.phase=0;
						u.timer=500;
						u.dir=0;
						break;
					case 1:
						u.action=ACTION_HIT_FACE_UP;
						u.phase=2;
						u.dead=1;
						u.dir=1;
						break;
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						u.phase=2;
						u.dead=1;
						u.dir=0;
						break;
					}
				break;
			case ACTION_LIE_UP:
			case ACTION_LIE_DOWN:
			case ACTION_CRAWL_DOWN:
			case ACTION_CRAWL_UP:
				switch(random(3))
					{
					case 0:
						u.action=ACTION_WOUNDED;
						u.phase=0;
						u.timer=500;
						u.dir=random(2);
						break;
					case 1:
						u.action=ACTION_HIT_FACE_UP;
						u.phase=2;
						u.dead=1;
						u.dir=random(2);
						break;
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						u.phase=2;
						u.dead=1;
						u.dir=random(2);
						break;
					}
				break;
			case ACTION_HIT_DEAD_UP:
			case ACTION_HIT_FACE_UP:
				switch(random(3))
					{
					case 0:
						u.action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						break;
					}
				u.phase=0;
				break;
			case ACTION_HIT_LIVE_UP:
				switch(random(6))
					{
					case 0:
						u.action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						break;
					default:
						u.action=ACTION_HIT_LIVE_UP;
						break;
					}
				u.phase=0;
				break;
			case ACTION_HIT_DEAD_DOWN:
			case ACTION_HIT_FACE_DOWN:
				switch(random(3))
					{
					case 0:
						u.action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_DOWN;
						break;
					}
				u.phase=0;
				break;
			case ACTION_HIT_LIVE_DOWN:
				switch(random(6))
					{
					case 0:
						u.action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_DOWN;
						break;
					default:
						u.action=ACTION_HIT_LIVE_DOWN;
						break;
					}
				u.phase=0;
				break;
			case ACTION_WALK_UP:
			case ACTION_STAND_UP:
			case ACTION_SHOOT_UP:
			case ACTION_CLIMB_UP:
			case ACTION_CHUCK_UP:
			case ACTION_MACHINEGUNNER_UP:
			case ACTION_MACHINEGUNNER_SHOOT_UP:
				switch(random(6))
					{
					case 0:
						u.action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_UP;
						break;
					default:
						u.action=ACTION_HIT_LIVE_UP;
						break;
					}
				u.phase=0;
				break;
			case ACTION_WALK_DOWN:
			case ACTION_SHOOT_DOWN:
			case ACTION_CLIMB_DOWN:
			case ACTION_CHUCK_DOWN:
			case ACTION_STAND_DOWN:
			case ACTION_MACHINEGUNNER_DOWN:
			case ACTION_MACHINEGUNNER_SHOOT_DOWN:
				switch(random(6))
					{
					case 0:
						u.action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_DOWN;
						break;
					default:
						u.action=ACTION_HIT_LIVE_DOWN;
						break;
					}
				u.phase=0;
				break;
			case ACTION_CHOKE:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_LEFT:
			case ACTION_WALK_RIGHT:
			case ACTION_WALK_LEFT:
			case ACTION_SHOVEL_RIGHT1:
			case ACTION_SHOVEL_LEFT1:
			case ACTION_SHOVEL_RIGHT2:
			case ACTION_SHOVEL_LEFT2:
			case ACTION_DODGE_RIGHT:
			case ACTION_DODGE_LEFT:
				switch(random(12))
					{
					case 0:
						u.action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						u.action=ACTION_HIT_DEAD_DOWN;
						break;
					case 3:
					case 4:
					case 5:
						u.action=ACTION_HIT_LIVE_DOWN;
						break;
					case 6:
						u.action=ACTION_HIT_FACE_UP;
						break;
					case 7:
					case 8:
						u.action=ACTION_HIT_DEAD_UP;
						break;
					case 9:
					case 10:
					case 11:
						u.action=ACTION_HIT_LIVE_UP;
						break;
					}
				u.phase=0;
				break;
			}

		if(&u==you&&curscore.death==-1)
			{
			if(p.side==0)
				{
				if(p.strafe)
					{
					if(u.action==ACTION_WOUNDED||
						u.action==ACTION_HIT_LIVE_UP||
						u.action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_MGSHOT_W;
						}
					if(u.action==ACTION_HIT_FACE_UP||
						u.action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_MGSHOT_F;
						}
					if(u.action==ACTION_HIT_DEAD_UP||
						u.action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_MGSHOT_D;
						}
					}
				else
					{
					if(u.action==ACTION_WOUNDED||
						u.action==ACTION_HIT_LIVE_UP||
						u.action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_SHOT_W;
						}
					if(u.action==ACTION_HIT_FACE_UP||
						u.action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_SHOT_F;
						}
					if(u.action==ACTION_HIT_DEAD_UP||
						u.action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_SHOT_D;
						}
					}
				}
			else
				{
				if(p.strafe)
					{
					if(u.action==ACTION_WOUNDED||
						u.action==ACTION_HIT_LIVE_UP||
						u.action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_MGSHOT_W_F;
						}
					if(u.action==ACTION_HIT_FACE_UP||
						u.action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_MGSHOT_F_F;
						}
					if(u.action==ACTION_HIT_DEAD_UP||
						u.action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_MGSHOT_D_F;
						}
					}
				else
					{
					if(u.action==ACTION_WOUNDED||
						u.action==ACTION_HIT_LIVE_UP||
						u.action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_SHOT_W_F;
						}
					if(u.action==ACTION_HIT_FACE_UP||
						u.action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_SHOT_F_F;
						}
					if(u.action==ACTION_HIT_DEAD_UP||
						u.action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_SHOT_D_F;
						}
					}
				}
			}

		if(u.burdened>0&&
			(u.type==UNIT_ALLY_MEDIC||
			u.type==UNIT_GERMAN_MEDIC))
			{
			unitst *newu=new unitst;
				if(u.type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
				else newu->type=UNIT_ALLY;
				newu->x=u.x+random(2)*10-5;
				newu->y=u.y;
				newu->action=u.burdenact;
				newu->timer=u.burden_timer;
				newu->burdened=u.burdened;
				newu->bandaged=1;
				newu->phase=0;
			unit.push_back(newu);

			u.burdened=0;
			}

		clearmgun(u);

		int pnum=random(23)+3;
		projst *newp;
		for(int r=0;r<pnum;r++)
			{
			newp=new projst;
				newp->type=PROJ_CHUNK;
				if(!random(60))
					{
					newp->color[0]=180;
					newp->color[1]=120;
					newp->color[2]=120;
					newp->stainer=1;
					if(!random(5))newp->stainer=2;
					newp->z=17;
					newp->vx=(float)(random(101)-50)/10.0f;
					newp->vy=(float)(random(101)-50)/10.0f;
					newp->vz=(float)(random(101)-50)/10.0f;
					}
				else
					{
					newp->color[0]=random(100)+100;
					newp->color[1]=0;
					newp->color[2]=0;
					newp->z=17;
					newp->vx=(float)(random(101)-50)/50.0f;
					newp->vy=(float)(random(101)-50)/50.0f;
					newp->vz=(float)(random(101)-50)/50.0f;
					}
				newp->x=u.x;
				newp->y=u.y+15;
			proj.push_back(newp);
			}

		return 1;
		}
	else u.shotattime=0;

	return 0;
}

void deathswath(int x,int y,char powerful,char side)
{
	y-=15;
	char conf;
	for(int u=unit.size()-1;u>=0;u--)
		{
		if(unit[u]->invincible)continue;
		conf=1;
		switch(unit[u]->action)
			{
			case ACTION_BLOWUP:
			case ACTION_BLOWAPART:
			case ACTION_BEHEADED:
				conf=0;
				break;
			}
		if(!conf)continue;

		if(abs(unit[u]->x-x)<10&&
			abs(unit[u]->y-y)<8&&powerful)
			{
			unit[u]->action=ACTION_BLOWUP;

			int pnum=random(23)+33;
			projst *newp;
			for(int r=0;r<pnum;r++)
				{
				newp=new projst;
					newp->type=PROJ_CHUNK;
					if(!random(4))
						{
						newp->color[0]=180;
						newp->color[1]=120;
						newp->color[2]=120;
						newp->stainer=1;
						if(!random(5))newp->stainer=2;
						newp->z=random(18);
						newp->vx=(float)(random(101)-50)/10.0f;
						newp->vy=(float)(random(101)-50)/10.0f;
						newp->vz=(float)(random(101)-50)/10.0f;
						}
					else
						{
						newp->color[0]=random(100)+100;
						newp->color[1]=0;
						newp->color[2]=0;
						newp->z=random(18);
						newp->vx=(float)(random(101)-50)/50.0f;
						newp->vy=(float)(random(101)-50)/50.0f;
						newp->vz=(float)(random(101)-50)/50.0f;
						}
					newp->x=unit[u]->x+random(9)-5;
					newp->y=unit[u]->y+15+random(9)-5;
				proj.push_back(newp);
				}

			if(unit[u]==you&&curscore.death==-1)
				{
				if(powerful==2)
					{
					curscore.death=DEATH_BOMB_BU;
					}
				else curscore.death=DEATH_MORTAR_BU;
				}

			unit[u]->burdened=0;

			clearmgun(*unit[u]);

			unit[u]->phase=0;
			}
		else if(abs(unit[u]->x-x)<20&&
			abs(unit[u]->y-y)<17)
			{
			unit[u]->action=ACTION_BLOWAPART;
			unit[u]->dir=random(2);

			int pnum=random(23)+23;
			projst *newp;
			for(int r=0;r<pnum;r++)
				{
				newp=new projst;
					newp->type=PROJ_CHUNK;
					if(!random(8))
						{
						newp->color[0]=180;
						newp->color[1]=120;
						newp->color[2]=120;
						newp->stainer=1;
						if(!random(5))newp->stainer=2;
						newp->z=random(18);
						newp->vx=(float)(random(101)-50)/10.0f;
						newp->vy=(float)(random(101)-50)/10.0f;
						newp->vz=(float)(random(101)-50)/10.0f;
						}
					else
						{
						newp->color[0]=random(100)+100;
						newp->color[1]=0;
						newp->color[2]=0;
						newp->z=random(18);
						newp->vx=(float)(random(101)-50)/50.0f;
						newp->vy=(float)(random(101)-50)/50.0f;
						newp->vz=(float)(random(101)-50)/50.0f;
						}
					newp->x=unit[u]->x+random(9)-5;
					newp->y=unit[u]->y+15+random(9)-5;
				proj.push_back(newp);
				}

			if(unit[u]==you&&curscore.death==-1)
				{
				if(powerful==2)
					{
					curscore.death=DEATH_BOMB_BA;
					}
				else if(powerful==1)curscore.death=DEATH_MORTAR_BA;
				else
					{
					if(side==1)curscore.death=DEATH_GRENADE_BA_F;
					else curscore.death=DEATH_GRENADE_BA;
					}
				}

			unit[u]->burdened=0;

			clearmgun(*unit[u]);

			unit[u]->phase=0;
			}
		else if(abs(unit[u]->x-x)<30&&
			abs(unit[u]->y-y)<25)
			{
			switch(random(4))
				{
				case 0:playsound(SOUND_SCREAM1);break;
				case 1:playsound(SOUND_SCREAM2);break;
				case 2:playsound(SOUND_SCREAM3);break;
				case 3:playsound(SOUND_SCREAM4);break;
				}

			switch(unit[u]->action)
				{
				case ACTION_CRAWL_LEFT:
				case ACTION_LIE_LEFT:
					switch(random(3))
						{
						case 0:
							unit[u]->action=ACTION_WOUNDED;
							unit[u]->phase=0;
							unit[u]->timer=500;
							unit[u]->dir=1;
							break;
						case 1:
							unit[u]->action=ACTION_HIT_FACE_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=0;
							break;
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=1;
							break;
						}
					break;
				case ACTION_LIE_RIGHT:
				case ACTION_CRAWL_RIGHT:
				case ACTION_BANDAGE:
					switch(random(3))
						{
						case 0:
							unit[u]->action=ACTION_WOUNDED;
							unit[u]->phase=0;
							unit[u]->timer=500;
							unit[u]->dir=0;
							break;
						case 1:
							unit[u]->action=ACTION_HIT_FACE_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=1;
							break;
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=0;
							break;
						}
					break;
				case ACTION_LIE_UP:
				case ACTION_LIE_DOWN:
				case ACTION_CRAWL_DOWN:
				case ACTION_CRAWL_UP:
					switch(random(3))
						{
						case 0:
							unit[u]->action=ACTION_WOUNDED;
							unit[u]->phase=0;
							unit[u]->timer=500;
							unit[u]->dir=random(2);
							break;
						case 1:
							unit[u]->action=ACTION_HIT_FACE_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=random(2);
							break;
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_UP;
							unit[u]->phase=2;
							unit[u]->dead=1;
							unit[u]->dir=random(2);
							break;
						}
					break;
				case ACTION_WALK_UP:
				case ACTION_STAND_UP:
				case ACTION_SHOOT_UP:
				case ACTION_CLIMB_UP:
				case ACTION_CHUCK_UP:
				case ACTION_MACHINEGUNNER_UP:
				case ACTION_MACHINEGUNNER_SHOOT_UP:
					switch(random(6))
						{
						case 0:
							unit[u]->action=ACTION_HIT_FACE_UP;
							break;
						case 1:
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_UP;
							break;
						default:
							unit[u]->action=ACTION_HIT_LIVE_UP;
							break;
						}
					unit[u]->phase=0;
					break;
				case ACTION_WALK_DOWN:
				case ACTION_SHOOT_DOWN:
				case ACTION_CLIMB_DOWN:
				case ACTION_CHUCK_DOWN:
				case ACTION_STAND_DOWN:
				case ACTION_MACHINEGUNNER_DOWN:
				case ACTION_MACHINEGUNNER_SHOOT_DOWN:
					switch(random(6))
						{
						case 0:
							unit[u]->action=ACTION_HIT_FACE_DOWN;
							break;
						case 1:
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_DOWN;
							break;
						default:
							unit[u]->action=ACTION_HIT_LIVE_DOWN;
							break;
						}
					unit[u]->phase=0;
					break;
				case ACTION_CHOKE:
				case ACTION_STAND_RIGHT:
				case ACTION_STAND_LEFT:
				case ACTION_WALK_RIGHT:
				case ACTION_WALK_LEFT:
				case ACTION_SHOVEL_RIGHT1:
				case ACTION_SHOVEL_LEFT1:
				case ACTION_SHOVEL_RIGHT2:
				case ACTION_SHOVEL_LEFT2:
				case ACTION_DODGE_RIGHT:
				case ACTION_DODGE_LEFT:
					switch(random(12))
						{
						case 0:
							unit[u]->action=ACTION_HIT_FACE_DOWN;
							break;
						case 1:
						case 2:
							unit[u]->action=ACTION_HIT_DEAD_DOWN;
							break;
						case 3:
						case 4:
						case 5:
							unit[u]->action=ACTION_HIT_LIVE_DOWN;
							break;
						case 6:
							unit[u]->action=ACTION_HIT_FACE_UP;
							break;
						case 7:
						case 8:
							unit[u]->action=ACTION_HIT_DEAD_UP;
							break;
						case 9:
						case 10:
						case 11:
							unit[u]->action=ACTION_HIT_LIVE_UP;
							break;
						}
					unit[u]->phase=0;
					break;
				}

			int pnum=random(23)+3;
			projst *newp;
			for(int r=0;r<pnum;r++)
				{
				newp=new projst;
					newp->type=PROJ_CHUNK;
					if(!random(60))
						{
						newp->color[0]=180;
						newp->color[1]=120;
						newp->color[2]=120;
						newp->stainer=1;
						if(!random(5))newp->stainer=2;
						newp->z=17;
						newp->vx=(float)(random(101)-50)/10.0f;
						newp->vy=(float)(random(101)-50)/10.0f;
						newp->vz=(float)(random(101)-50)/10.0f;
						}
					else
						{
						newp->color[0]=random(100)+100;
						newp->color[1]=0;
						newp->color[2]=0;
						newp->z=17;
						newp->vx=(float)(random(101)-50)/50.0f;
						newp->vy=(float)(random(101)-50)/50.0f;
						newp->vz=(float)(random(101)-50)/50.0f;
						}
					newp->x=unit[u]->x;
					newp->y=unit[u]->y+15;
				proj.push_back(newp);
				}

			if(unit[u]==you&&curscore.death==-1)
				{
				if(powerful==2)
					{
					if(unit[u]->action==ACTION_WOUNDED||
						unit[u]->action==ACTION_HIT_LIVE_UP||
						unit[u]->action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_BOMB_W;
						}
					if(unit[u]->action==ACTION_HIT_FACE_UP||
						unit[u]->action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_BOMB_F;
						}
					if(unit[u]->action==ACTION_HIT_DEAD_UP||
						unit[u]->action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_BOMB_D;
						}
					}
				else if(powerful==1)
					{
					if(unit[u]->action==ACTION_WOUNDED||
						unit[u]->action==ACTION_HIT_LIVE_UP||
						unit[u]->action==ACTION_HIT_LIVE_DOWN)
						{
						curscore.death=DEATH_MORTAR_W;
						}
					if(unit[u]->action==ACTION_HIT_FACE_UP||
						unit[u]->action==ACTION_HIT_FACE_DOWN)
						{
						curscore.death=DEATH_MORTAR_F;
						}
					if(unit[u]->action==ACTION_HIT_DEAD_UP||
						unit[u]->action==ACTION_HIT_DEAD_DOWN)
						{
						curscore.death=DEATH_MORTAR_D;
						}
					}
				else
					{
					if(unit[u]->action==ACTION_WOUNDED||
						unit[u]->action==ACTION_HIT_LIVE_UP||
						unit[u]->action==ACTION_HIT_LIVE_DOWN)
						{
						if(side==1)curscore.death=DEATH_GRENADE_W_F;
						else curscore.death=DEATH_GRENADE_W;
						}
					if(unit[u]->action==ACTION_HIT_FACE_UP||
						unit[u]->action==ACTION_HIT_FACE_DOWN)
						{
						if(side==1)curscore.death=DEATH_GRENADE_F_F;
						else curscore.death=DEATH_GRENADE_F;
						}
					if(unit[u]->action==ACTION_HIT_DEAD_UP||
						unit[u]->action==ACTION_HIT_DEAD_DOWN)
						{
						if(side==1)curscore.death=DEATH_GRENADE_D_F;
						else curscore.death=DEATH_GRENADE_D;
						}
					}
				}

			if(unit[u]->burdened>0&&
				(unit[u]->type==UNIT_ALLY_MEDIC||
				unit[u]->type==UNIT_GERMAN_MEDIC))
				{
				unitst *newu=new unitst;
					if(unit[u]->type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
					else newu->type=UNIT_ALLY;
					newu->x=unit[u]->x+random(2)*10-5;
					newu->y=unit[u]->y;
					newu->action=unit[u]->burdenact;
					newu->timer=unit[u]->burden_timer;
					newu->burdened=unit[u]->burdened;
					newu->bandaged=1;
					newu->phase=0;
				unit.push_back(newu);

				unit[u]->burdened=0;
				}

			clearmgun(*unit[u]);
			}
		}

	//DESTROY MACHINE GUNS
	y-=5;
	for(int s=0;s<2;s++)
		{
		for(int g=0;g<3;g++)
			{
			if((s==0&&y>=400)||
				(s==1&&y<40))
				{
				if(machinegun[s][g]!=3)
					{
					if(abs(x-machinegunx[s][g])<20)
						{
						machinegun[s][g]=3;
						machinegununit[s][g]=NULL;
						}
					}
				}
			}
		}
}

void strafe(int x,int y)
{
	switch(random(4))
		{
		case 0:playsound(SOUND_MGSHOT1);break;
		case 1:playsound(SOUND_MGSHOT2);break;
		case 2:playsound(SOUND_MGSHOT3);break;
		case 3:playsound(SOUND_MGSHOT4);break;
		}

	vector<int> goodu;
	char conf;
	for(int u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		conf=1;
		switch(unit[u]->action)
			{
			case ACTION_BLOWUP:
			case ACTION_BLOWAPART:
			case ACTION_BEHEADED:
				conf=0;
				break;
			case ACTION_HIT_DEAD_DOWN:
			case ACTION_HIT_FACE_DOWN:
			case ACTION_HIT_LIVE_DOWN:
			case ACTION_HIT_DEAD_UP:
			case ACTION_HIT_FACE_UP:
			case ACTION_HIT_LIVE_UP:
				if(unit[u]->phase>=2)conf=0;
				break;
			}
		if(!conf)continue;

		if(abs(unit[u]->x-x)<10&&
			abs(unit[u]->y-y)<10)goodu.push_back(u);
		}

	if(goodu.size()==0)
		{
		//STRAFE
		projst *newp=new projst;
			newp->type=PROJ_STRAFE;
			newp->x=x;
			newp->y=y;
			newp->duration=0;
		proj.push_back(newp);

		unsigned char color[3]={0,0,0};
		colorground(color,x,y);

		//DIRT
		int pnum=random(10)+10;
		for(int r=0;r<pnum;r++)
			{
			newp=new projst;
				newp->type=PROJ_CHUNK;
				char conf=0;
				if(x>0&&x<640&&y>=0&&y<480)
					{
					if(groundflag[x][y] & GROUNDFLAG_CHUNKY)conf=1;
					}
				if(conf)
					{
					if(!random(20))
						{
						newp->color[0]=180;
						newp->color[1]=120;
						newp->color[2]=120;
						newp->stainer=1;
						if(!random(5))newp->stainer=2;
						}
					else
						{
						newp->color[0]=100+random(100);
						newp->color[1]=0;
						newp->color[2]=0;
						}
					}
				else
					{
					newp->color[0]=20+random(10);
					newp->color[1]=10+random(5);
					newp->color[2]=5+random(2);
					}
				newp->x=x;
				newp->y=y;
				newp->z=0;
				newp->vx=(float)(random(50)-25)/50.0f;
				newp->vy=(float)(random(50)-25)/50.0f;
				newp->vz=(float)(random(101))/20.0f;
			proj.push_back(newp);
			}
		return;
		}

	u=goodu[random(goodu.size())];

	if(abs(unit[u]->x-x)<2&&
		abs(unit[u]->y-y)<2)
		{
		unit[u]->action=ACTION_BLOWAPART;

		int pnum=random(23)+23;
		projst *newp;
		for(int r=0;r<pnum;r++)
			{
			newp=new projst;
				newp->type=PROJ_CHUNK;
				if(!random(8))
					{
					newp->color[0]=180;
					newp->color[1]=120;
					newp->color[2]=120;
					newp->stainer=1;
					if(!random(5))newp->stainer=2;
					newp->z=random(18);
					newp->vx=(float)(random(101)-50)/10.0f;
					newp->vy=(float)(random(101)-50)/10.0f;
					newp->vz=(float)(random(101)-50)/10.0f;
					}
				else
					{
					newp->color[0]=random(100)+100;
					newp->color[1]=0;
					newp->color[2]=0;
					newp->z=random(18);
					newp->vx=(float)(random(101)-50)/50.0f;
					newp->vy=(float)(random(101)-50)/50.0f;
					newp->vz=(float)(random(101)-50)/50.0f;
					}
				newp->x=unit[u]->x+random(9)-5;
				newp->y=unit[u]->y+15+random(9)-5;
			proj.push_back(newp);
			}

		if(unit[u]==you&&curscore.death==-1)
			{
			curscore.death=DEATH_STRAFE_BA;
			}

		unit[u]->burdened=0;

		clearmgun(*unit[u]);

		unit[u]->phase=0;
		return;
		}
	else
		{
		switch(random(4))
			{
			case 0:playsound(SOUND_SCREAM1);break;
			case 1:playsound(SOUND_SCREAM2);break;
			case 2:playsound(SOUND_SCREAM3);break;
			case 3:playsound(SOUND_SCREAM4);break;
			}

		switch(unit[u]->action)
			{
			case ACTION_CRAWL_LEFT:
			case ACTION_LIE_LEFT:
				switch(random(3))
					{
					case 0:
						unit[u]->action=ACTION_WOUNDED;
						unit[u]->phase=0;
						unit[u]->timer=500;
						unit[u]->dir=1;
						break;
					case 1:
						unit[u]->action=ACTION_HIT_FACE_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=0;
						break;
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=1;
						break;
					}
				break;
			case ACTION_LIE_RIGHT:
			case ACTION_CRAWL_RIGHT:
			case ACTION_BANDAGE:
				switch(random(3))
					{
					case 0:
						unit[u]->action=ACTION_WOUNDED;
						unit[u]->phase=0;
						unit[u]->timer=500;
						unit[u]->dir=0;
						break;
					case 1:
						unit[u]->action=ACTION_HIT_FACE_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=1;
						break;
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=0;
						break;
					}
				break;
			case ACTION_LIE_UP:
			case ACTION_LIE_DOWN:
			case ACTION_CRAWL_DOWN:
			case ACTION_CRAWL_UP:
				switch(random(3))
					{
					case 0:
						unit[u]->action=ACTION_WOUNDED;
						unit[u]->phase=0;
						unit[u]->timer=500;
						unit[u]->dir=random(2);
						break;
					case 1:
						unit[u]->action=ACTION_HIT_FACE_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=random(2);
						break;
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						unit[u]->phase=2;
						unit[u]->dead=1;
						unit[u]->dir=random(2);
						break;
					}
				break;
			case ACTION_HIT_DEAD_UP:
			case ACTION_HIT_FACE_UP:
				switch(random(3))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_HIT_LIVE_UP:
				switch(random(6))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						break;
					default:
						unit[u]->action=ACTION_HIT_LIVE_UP;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_HIT_DEAD_DOWN:
			case ACTION_HIT_FACE_DOWN:
				switch(random(3))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_DOWN;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_HIT_LIVE_DOWN:
				switch(random(6))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_DOWN;
						break;
					default:
						unit[u]->action=ACTION_HIT_LIVE_DOWN;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_WALK_UP:
			case ACTION_STAND_UP:
			case ACTION_SHOOT_UP:
			case ACTION_CLIMB_UP:
			case ACTION_CHUCK_UP:
			case ACTION_MACHINEGUNNER_UP:
			case ACTION_MACHINEGUNNER_SHOOT_UP:
				switch(random(6))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_UP;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						break;
					default:
						unit[u]->action=ACTION_HIT_LIVE_UP;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_WALK_DOWN:
			case ACTION_SHOOT_DOWN:
			case ACTION_CLIMB_DOWN:
			case ACTION_CHUCK_DOWN:
			case ACTION_STAND_DOWN:
			case ACTION_MACHINEGUNNER_DOWN:
			case ACTION_MACHINEGUNNER_SHOOT_DOWN:
				switch(random(6))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_DOWN;
						break;
					default:
						unit[u]->action=ACTION_HIT_LIVE_DOWN;
						break;
					}
				unit[u]->phase=0;
				break;
			case ACTION_CHOKE:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_LEFT:
			case ACTION_WALK_RIGHT:
			case ACTION_WALK_LEFT:
			case ACTION_SHOVEL_RIGHT1:
			case ACTION_SHOVEL_LEFT1:
			case ACTION_SHOVEL_RIGHT2:
			case ACTION_SHOVEL_LEFT2:
			case ACTION_DODGE_RIGHT:
			case ACTION_DODGE_LEFT:
				switch(random(12))
					{
					case 0:
						unit[u]->action=ACTION_HIT_FACE_DOWN;
						break;
					case 1:
					case 2:
						unit[u]->action=ACTION_HIT_DEAD_DOWN;
						break;
					case 3:
					case 4:
					case 5:
						unit[u]->action=ACTION_HIT_LIVE_DOWN;
						break;
					case 6:
						unit[u]->action=ACTION_HIT_FACE_UP;
						break;
					case 7:
					case 8:
						unit[u]->action=ACTION_HIT_DEAD_UP;
						break;
					case 9:
					case 10:
					case 11:
						unit[u]->action=ACTION_HIT_LIVE_UP;
						break;
					}
				unit[u]->phase=0;
				break;
			}

		int pnum=random(23)+3;
		projst *newp;
		for(int r=0;r<pnum;r++)
			{
			newp=new projst;
				newp->type=PROJ_CHUNK;
				if(!random(60))
					{
					newp->color[0]=180;
					newp->color[1]=120;
					newp->color[2]=120;
					newp->stainer=1;
					if(!random(5))newp->stainer=2;
					newp->z=17;
					newp->vx=(float)(random(101)-50)/10.0f;
					newp->vy=(float)(random(101)-50)/10.0f;
					newp->vz=(float)(random(101)-50)/10.0f;
					}
				else
					{
					newp->color[0]=random(100)+100;
					newp->color[1]=0;
					newp->color[2]=0;
					newp->z=17;
					newp->vx=(float)(random(101)-50)/50.0f;
					newp->vy=(float)(random(101)-50)/50.0f;
					newp->vz=(float)(random(101)-50)/50.0f;
					}
				newp->x=unit[u]->x;
				newp->y=unit[u]->y+15;
			proj.push_back(newp);
			}

		if(unit[u]==you&&curscore.death==-1)
			{
			if(unit[u]->action==ACTION_WOUNDED||
				unit[u]->action==ACTION_HIT_LIVE_UP||
				unit[u]->action==ACTION_HIT_LIVE_DOWN)
				{
				curscore.death=DEATH_STRAFE_W;
				}
			if(unit[u]->action==ACTION_HIT_FACE_UP||
				unit[u]->action==ACTION_HIT_FACE_DOWN)
				{
				curscore.death=DEATH_STRAFE_F;
				}
			if(unit[u]->action==ACTION_HIT_DEAD_UP||
				unit[u]->action==ACTION_HIT_DEAD_DOWN)
				{
				curscore.death=DEATH_STRAFE_D;
				}
			}

		if(unit[u]->burdened>0&&
			(unit[u]->type==UNIT_ALLY_MEDIC||
			unit[u]->type==UNIT_GERMAN_MEDIC))
			{
			unitst *newu=new unitst;
				if(unit[u]->type==UNIT_GERMAN_MEDIC)newu->type=UNIT_GERMAN;
				else newu->type=UNIT_ALLY;
				newu->x=unit[u]->x+random(2)*10-5;
				newu->y=unit[u]->y;
				newu->action=unit[u]->burdenact;
				newu->timer=unit[u]->burden_timer;
				newu->burdened=unit[u]->burdened;
				newu->bandaged=1;
				newu->phase=0;
			unit.push_back(newu);

			unit[u]->burdened=0;
			}

		clearmgun(*unit[u]);
		return;
		}
}

void clearmgun(unitst &u)
{
	for(int s=0;s<2;s++)
		{
		for(int g=0;g<3;g++)
			{
			if(machinegun[s][g]!=3&&
				machinegununit[s][g]==&u)
				{
				machinegun[s][g]=0;
				machinegununit[s][g]=NULL;
				}
			}
		}
}

void commandmedic(WPARAM wParam)
{
	if(curscore.death!=-1)
		{
		if(deadtime==0&&wParam=='T')deadtime=1;
		return;
		}

	unitst *un=NULL;
	for(int u=0;u<unit.size();u++)
		{
		if(unit[u]->invincible)continue;
		if(unit[u]->type==UNIT_ALLY_MEDIC)
			{
			un=unit[u];
			}
		}
	if(un==NULL)return;

	if(un->y>429)return;

	switch(un->action)
		{
		case ACTION_BLOWUP:
		case ACTION_BLOWAPART:
		case ACTION_BEHEADED:
		case ACTION_HIT_DEAD_UP:
		case ACTION_HIT_DEAD_DOWN:
		case ACTION_HIT_FACE_UP:
		case ACTION_HIT_FACE_DOWN:
		case ACTION_HIT_LIVE_UP:
		case ACTION_HIT_LIVE_DOWN:
		case ACTION_CHOKE:
		case ACTION_WOUNDED:
		case ACTION_WOUNDED_CHOKE:
		case ACTION_CLIMB_UP:
		case ACTION_CLIMB_DOWN:
		case ACTION_DODGE_RIGHT:
		case ACTION_DODGE_LEFT:
			return;
		}

	if(wParam=='W'||wParam==VK_UP)
		{
		if(un->y<=21)return;
		switch(un->action)
			{
			case ACTION_WALK_UP:
				un->action=ACTION_STAND_UP;
				un->phase=0;
				break;
			case ACTION_WALK_RIGHT:
			case ACTION_WALK_DOWN:
			case ACTION_WALK_LEFT:
			case ACTION_STAND_UP:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_DOWN:
			case ACTION_STAND_LEFT:
				un->action=ACTION_WALK_UP;
				un->phase=0;
				break;
			case ACTION_CRAWL_UP:
				un->action=ACTION_LIE_UP;
				un->phase=0;
				break;
			case ACTION_CRAWL_RIGHT:
			case ACTION_CRAWL_DOWN:
			case ACTION_CRAWL_LEFT:
			case ACTION_LIE_UP:
			case ACTION_LIE_RIGHT:
			case ACTION_LIE_DOWN:
			case ACTION_LIE_LEFT:
			case ACTION_BANDAGE:
				un->action=ACTION_CRAWL_UP;
				un->phase=0;
				break;
			}
		}
	if(wParam=='X'||wParam==VK_DOWN)
		{
		if(un->y>=429)return;
		switch(un->action)
			{
			case ACTION_WALK_DOWN:
				un->action=ACTION_STAND_DOWN;
				un->phase=0;
				break;
			case ACTION_WALK_RIGHT:
			case ACTION_WALK_UP:
			case ACTION_WALK_LEFT:
			case ACTION_STAND_UP:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_DOWN:
			case ACTION_STAND_LEFT:
				un->action=ACTION_WALK_DOWN;
				un->phase=0;
				break;
			case ACTION_CRAWL_DOWN:
				un->action=ACTION_LIE_DOWN;
				un->phase=0;
				break;
			case ACTION_CRAWL_RIGHT:
			case ACTION_CRAWL_UP:
			case ACTION_CRAWL_LEFT:
			case ACTION_LIE_UP:
			case ACTION_LIE_RIGHT:
			case ACTION_LIE_DOWN:
			case ACTION_LIE_LEFT:
			case ACTION_BANDAGE:
				un->action=ACTION_CRAWL_DOWN;
				un->phase=0;
				break;
			}
		}
	if(wParam=='D'||wParam==VK_RIGHT)
		{
		switch(un->action)
			{
			case ACTION_WALK_RIGHT:
				un->action=ACTION_STAND_RIGHT;
				un->phase=0;
				break;
			case ACTION_WALK_DOWN:
			case ACTION_WALK_UP:
			case ACTION_WALK_LEFT:
			case ACTION_STAND_UP:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_DOWN:
			case ACTION_STAND_LEFT:
				un->action=ACTION_WALK_RIGHT;
				un->phase=0;
				break;
			case ACTION_CRAWL_RIGHT:
				un->action=ACTION_LIE_RIGHT;
				un->phase=0;
				break;
			case ACTION_CRAWL_DOWN:
			case ACTION_CRAWL_UP:
			case ACTION_CRAWL_LEFT:
			case ACTION_LIE_UP:
			case ACTION_LIE_RIGHT:
			case ACTION_LIE_DOWN:
			case ACTION_LIE_LEFT:
			case ACTION_BANDAGE:
				un->action=ACTION_CRAWL_RIGHT;
				un->phase=0;
				break;
			}
		}
	if(wParam=='A'||wParam==VK_LEFT)
		{
		switch(un->action)
			{
			case ACTION_WALK_LEFT:
				un->action=ACTION_STAND_LEFT;
				un->phase=0;
				break;
			case ACTION_WALK_DOWN:
			case ACTION_WALK_UP:
			case ACTION_WALK_RIGHT:
			case ACTION_STAND_UP:
			case ACTION_STAND_RIGHT:
			case ACTION_STAND_DOWN:
			case ACTION_STAND_LEFT:
				un->action=ACTION_WALK_LEFT;
				un->phase=0;
				break;
			case ACTION_CRAWL_LEFT:
				un->action=ACTION_LIE_LEFT;
				un->phase=0;
				break;
			case ACTION_CRAWL_DOWN:
			case ACTION_CRAWL_UP:
			case ACTION_CRAWL_RIGHT:
			case ACTION_LIE_UP:
			case ACTION_LIE_RIGHT:
			case ACTION_LIE_DOWN:
			case ACTION_LIE_LEFT:
			case ACTION_BANDAGE:
				un->action=ACTION_CRAWL_LEFT;
				un->phase=0;
				break;
			}
		}
	if(wParam=='S'||wParam==KEY_KPMID)
		{
		switch(un->action)
			{
			case ACTION_WALK_LEFT:
				un->action=ACTION_STAND_LEFT;
				un->phase=0;
				break;
			case ACTION_WALK_DOWN:
				un->action=ACTION_STAND_DOWN;
				un->phase=0;
				break;
			case ACTION_WALK_UP:
				un->action=ACTION_STAND_UP;
				un->phase=0;
				break;
			case ACTION_WALK_RIGHT:
				un->action=ACTION_STAND_RIGHT;
				un->phase=0;
				break;
			case ACTION_CRAWL_LEFT:
				un->action=ACTION_LIE_LEFT;
				un->phase=0;
				break;
			case ACTION_CRAWL_DOWN:
				un->action=ACTION_LIE_DOWN;
				un->phase=0;
				break;
			case ACTION_CRAWL_UP:
				un->action=ACTION_LIE_UP;
				un->phase=0;
				break;
			case ACTION_CRAWL_RIGHT:
				un->action=ACTION_LIE_RIGHT;
				un->phase=0;
				break;
			}
		}
	if(wParam==VK_SPACE)
		{
		switch(un->action)
			{
			case ACTION_WALK_LEFT:
				un->action=ACTION_CRAWL_LEFT;
				un->phase=0;
				break;
			case ACTION_WALK_DOWN:
				un->action=ACTION_CRAWL_DOWN;
				un->phase=0;
				break;
			case ACTION_WALK_UP:
				un->action=ACTION_CRAWL_UP;
				un->phase=0;
				break;
			case ACTION_WALK_RIGHT:
				un->action=ACTION_CRAWL_RIGHT;
				un->phase=0;
				break;
			case ACTION_STAND_UP:
				un->action=ACTION_LIE_UP;
				un->phase=0;
				break;
			case ACTION_STAND_RIGHT:
				un->action=ACTION_LIE_RIGHT;
				un->phase=0;
				break;
			case ACTION_STAND_DOWN:
				un->action=ACTION_LIE_DOWN;
				un->phase=0;
				break;
			case ACTION_STAND_LEFT:
				un->action=ACTION_LIE_LEFT;
				un->phase=0;
				break;
			case ACTION_CRAWL_LEFT:
				un->action=ACTION_WALK_LEFT;
				un->phase=0;
				break;
			case ACTION_CRAWL_DOWN:
				un->action=ACTION_WALK_DOWN;
				un->phase=0;
				break;
			case ACTION_CRAWL_UP:
				un->action=ACTION_WALK_UP;
				un->phase=0;
				break;
			case ACTION_CRAWL_RIGHT:
				un->action=ACTION_WALK_RIGHT;
				un->phase=0;
				break;
			case ACTION_LIE_UP:
				un->action=ACTION_STAND_UP;
				un->phase=0;
				break;
			case ACTION_LIE_RIGHT:
				un->action=ACTION_STAND_RIGHT;
				un->phase=0;
				break;
			case ACTION_LIE_DOWN:
				un->action=ACTION_STAND_DOWN;
				un->phase=0;
				break;
			case ACTION_LIE_LEFT:
				un->action=ACTION_STAND_LEFT;
				un->phase=0;
				break;
			}
		}
	//BANDAGE/HAUL/DROP
	if(wParam==VK_RETURN)
		{
		if(un->action==ACTION_BANDAGE)return;

		if(un->burdened!=0)
			{
			unitst *newu=new unitst;
				newu->type=UNIT_ALLY;
				newu->x=un->x;
				newu->y=un->y;
				newu->action=un->burdenact;
				newu->phase=0;
				newu->timer=un->burden_timer;
				newu->bandaged=1;
				newu->burdened=un->burdened;
			unit.push_back(newu);

			un->burdened=0;
			}
		else
			{
			//LOOK FOR NEARBY BANDAGEABLE
			long dist=301;
			int targ=-1;
			for(int u=0;u<unit.size();u++)
				{
				if(unit[u]->invincible)continue;
				if(unit[u]->y<429&&un->y>=429)continue;
				if(unit[u]->y>=429&&un->y<429)continue;
				if(unit[u]->y<=21)continue;
				if((unit[u]->action==ACTION_WOUNDED||
					unit[u]->action==ACTION_WOUNDED_CHOKE)&&
					!unit[u]->bandaged)
					{
					if((unit[u]->x-un->x)*(unit[u]->x-un->x)+
						(unit[u]->y-un->y)*(unit[u]->y-un->y)<dist)
						{
						targ=u;
						dist=(unit[u]->x-un->x)*(unit[u]->x-un->x)+
							(unit[u]->y-un->y)*(unit[u]->y-un->y);
						}
					}
				}

			//LOOK FOR NEARBY BANDAGED ALLY
			if(targ==-1)
				{
				dist=301;
				for(int u=0;u<unit.size();u++)
					{
					if(unit[u]->invincible)continue;
					if(unit[u]->y<=21)continue;
					if(unit[u]->y>=429)continue;
					if(unit[u]->type==UNIT_ALLY&&
						(unit[u]->action==ACTION_WOUNDED||
						unit[u]->action==ACTION_WOUNDED_CHOKE)&&
						unit[u]->bandaged)
						{
						if((unit[u]->x-un->x)*(unit[u]->x-un->x)+
							(unit[u]->y-un->y)*(unit[u]->y-un->y)<dist)
							{
							targ=u;
							dist=(unit[u]->x-un->x)*(unit[u]->x-un->x)+
								(unit[u]->y-un->y)*(unit[u]->y-un->y);
							}
						}
					}

				if(targ!=-1&&un->y<429)
					{
					un->burdened=unit[targ]->burdened;
					if(un->burdened==0)un->burdened=1500-unit[targ]->y*3;
					un->burden_timer=unit[targ]->timer;
					un->burdenact=unit[targ]->action;

					unit[targ]->action=ACTION_BLOWUP;
					unit[targ]->disappear=1;
					}
				}
			else
				{
				un->action=ACTION_BANDAGE;
				un->phase=0;
				un->targid=unit[targ]->id;
				}
			}
		}
}

void addscore(int sc,int x,int y)
{
	if(sc==0)return;
	if(curscore.death!=-1)return;

	curscore.score+=sc;

	tagst *newt=new tagst;
		newt->x=x;
		newt->y=y;
		newt->vx=0;
		newt->vy=-1;
		newt->duration=0;
		if(sc<0)
			{
			newt->color[0]=255;
			newt->color[1]=0;
			newt->color[2]=0;
			}
		else
			{
			newt->color[0]=0;
			newt->color[1]=255;
			newt->color[2]=0;
			}
		itoa(sc,newt->str,10);
	tag.push_back(newt);
}

void preparescreen_title(void)
{
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
	glLoadIdentity();					// reset projection matrix
	glOrtho(0.0f, 640, 479, -1, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);			// set modelview matrix
	glLoadIdentity();					// reset modelview matrix

	glColor3f(1,1,1);

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,bmp_title.gennum);
	glBegin(GL_QUADS);
		glTexCoord2f(0,1);
		glVertex2f(320-128,50-1+titley);
		glTexCoord2f(0,0);
		glVertex2f(320-128,113+titley);
		glTexCoord2f(1,0);
		glVertex2f(320+128,113+titley);
		glTexCoord2f(1,1);
		glVertex2f(320+128,50-1+titley);
	glEnd();

	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);

	printguyframe(UNIT_ALLY,GUY_DOWN_WALK1,75,200+titley,1);
	printguyframe(UNIT_ALLY,GUY_DOWN_WALK1,95,200+titley,1);
	printguyframe(UNIT_ALLY,GUY_DOWN_WALK1,115,200+titley,1);
	printguyframe(UNIT_ALLY_MEDIC,GUY_DOWN_WALK1,225,200+titley,1);
	printguyframe(UNIT_GERMAN_MEDIC,GUY_DOWN_WALK1,380,200+titley,1);
	printguyframe(UNIT_GERMAN,GUY_DOWN_WALK1,505,200+titley,1);
	printguyframe(UNIT_GERMAN,GUY_DOWN_WALK1,525,200+titley,1);
	printguyframe(UNIT_GERMAN,GUY_DOWN_WALK1,545,200+titley,1);

	glDisable(GL_TEXTURE_2D);
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);

	glRasterPos2i(230,130+titley);
	PrintString(fontlist3,"v1.03, Copyright (C) 2004 by Tarn Adams");

	glRasterPos2i(100,250+titley);
	PrintString(fontlist3,"Allies");

	glRasterPos2i(200,250+titley);
	PrintString(fontlist3,"Allied Medic (You)");

	glRasterPos2i(360,250+titley);
	PrintString(fontlist3,"German Medic");

	glRasterPos2i(520,250+titley);
	PrintString(fontlist3,"Germans");

	glRasterPos2i(90,290+titley);
	PrintString(fontlist3,"Number Pad/W,A,D,X,S:  Move");
	glRasterPos2i(90,310+titley);
	PrintString(fontlist3,"Enter:  Bandage, Haul, Drop");
	glRasterPos2i(90,330+titley);
	PrintString(fontlist3,"Space:  Crawl/Stand");

	glRasterPos2i(360,290+titley);
	PrintString(fontlist3,"Earn Points by Rescuing Wounded Allies");
	glRasterPos2i(360,310+titley);
	PrintString(fontlist3,"Earn Points by Bandaging Wounded Germans");
	glRasterPos2i(360,330+titley);
	PrintString(fontlist3,"Final Bonus for Outperforming German Medics");

	glColor3ub(random(256),random(256),random(256));
	glRasterPos2i(265,370+titley);
	PrintString(fontlist3,"Press any key to begin.");

	glColor3f(1,1,1);
	glRasterPos2i(225,400+titley);
	PrintString(fontlist2,"Programmed by Tarn Adams");
	glRasterPos2i(195,420+titley);
	PrintString(fontlist2,"Designed by Tarn and Zach Adams");
	glRasterPos2i(220,440+titley);
	PrintString(fontlist2,"A Bay 12 Games Production");
	glRasterPos2i(250,460+titley);
	PrintString(fontlist2,"www.bay12games.com");
}

void bonus(void)
{
	while(timer+30>GetTickCount()&&timer<=GetTickCount());

	if(ycount_cur<ycount||gcount_cur<gcount)
		{
		if(ycount_cur<ycount)ycount_cur++;
		if(gcount_cur<gcount)gcount_cur++;
		if(ycount_cur>gcount)bonusdrip+=100;
		bbeep=1;
		if(ycount_cur==ycount&&gcount_cur==gcount&&trenches==0&&
			bonusdrip==0)bbeep=3;
		}
	else if(trenches_cur<trenches)
		{
		trenches_cur++;
		bonusdrip+=1000;
		bbeep=4;
		}
	else if(bonusdrip>0)
		{
		curscore.score+=10;
		bonusdrip-=10;
		bbeep=2;
		}
	if(bonusdrip>0)havebonus=1;
}

void preparescreen_bonus(void)
{
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glColor3f(1,1,1);
	glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
	glLoadIdentity();					// reset projection matrix
	glOrtho(0.0f, 640, 479, -1, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);			// set modelview matrix
	glLoadIdentity();					// reset modelview matrix

	glColor3f(1,1,1);
	glRasterPos2i(20,20);
	PrintString(fontlist,"Score:");
	char num[20];
	glRasterPos2i(90,20);
	itoa(curscore.score,num,10);
	PrintString(fontlist,num);

	if((ycount_cur==ycount&&gcount_cur==gcount&&trenches==trenches_cur)||bonusdrip>0)
		{
		if(havebonus)
			{
			glColor3f(0,1,0);
			glRasterPos2i(200,20);
			PrintString(fontlist,"Bonus:");
			glRasterPos2i(270,20);
			itoa(bonusdrip,num,10);
			PrintString(fontlist,num);
			}
		else
			{
			glColor3ub(70,30,10);
			glRasterPos2i(200,20);
			PrintString(fontlist,"No Bonus");
			}
		}

	int py=ycount_cur%24;
	int pg=gcount_cur%24;
	int tr=trenches_cur%10;
	int trs=trenches_cur/10;
	int psy=ycount_cur/24;
	int psg=gcount_cur/24;
	if(py==0&&ycount_cur>0){py=24;psy--;}
	if(pg==0&&gcount_cur>0){pg=24;psg--;}
	if(tr==0&&trenches_cur>0){tr=10;trs--;}

	glColor3f(1,1,1);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);

	glBindTexture(GL_TEXTURE_2D,bmp_face[1].gennum);
	glBegin(GL_QUADS);
	int x,y;
	for(int u=0;u<py;u++)
		{
		x=(u%4)*70+30;
		y=(u/4)*70+60;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+63);
		glTexCoord2f(1,0);
		glVertex2f(x+64,y+63);
		glTexCoord2f(1,1);
		glVertex2f(x+64,y-1);
		}
	glEnd();

	glBindTexture(GL_TEXTURE_2D,bmp_faces[1].gennum);
	glBegin(GL_QUADS);
	for(u=0;u<psy;u++)
		{
		x=304;
		y=u*40+40;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+31);
		glTexCoord2f(1,0);
		glVertex2f(x+32,y+31);
		glTexCoord2f(1,1);
		glVertex2f(x+32,y-1);
		}
	glEnd();

	glBindTexture(GL_TEXTURE_2D,bmp_face[0].gennum);
	glBegin(GL_QUADS);
	for(u=0;u<pg;u++)
		{
		x=(u%4)*70+340;
		y=(u/4)*70+57;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+63);
		glTexCoord2f(1,0);
		glVertex2f(x+64,y+63);
		glTexCoord2f(1,1);
		glVertex2f(x+64,y-1);
		}
	glEnd();

	glBindTexture(GL_TEXTURE_2D,bmp_faces[0].gennum);
	glBegin(GL_QUADS);
	for(u=0;u<psg;u++)
		{
		x=304;
		y=440-u*40;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+31);
		glTexCoord2f(1,0);
		glVertex2f(x+32,y+31);
		glTexCoord2f(1,1);
		glVertex2f(x+32,y-1);
		}
	glEnd();

	glBindTexture(GL_TEXTURE_2D,bmp_trench[0].gennum);
	glBegin(GL_QUADS);
	for(u=0;u<tr;u++)
		{
		x=346+u*27;
		y=4;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+31);
		glTexCoord2f(1,0);
		glVertex2f(x+32,y+31);
		glTexCoord2f(1,1);
		glVertex2f(x+32,y-1);
		}
	glEnd();

	glBindTexture(GL_TEXTURE_2D,bmp_trench[1].gennum);
	glBegin(GL_QUADS);
	for(u=0;u<trs;u++)
		{
		x=361+u*27;
		y=25;

		glTexCoord2f(0,1);
		glVertex2f(x,y-1);
		glTexCoord2f(0,0);
		glVertex2f(x,y+31);
		glTexCoord2f(1,0);
		glVertex2f(x+32,y+31);
		glTexCoord2f(1,1);
		glVertex2f(x+32,y-1);
		}
	glEnd();
}

void preparescreen_highscores(void)
{
	glDisable(GL_ALPHA_TEST);
	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glColor3f(1,1,1);
	glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
	glLoadIdentity();					// reset projection matrix
	glOrtho(0.0f, 640, 479, -1, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);			// set modelview matrix
	glLoadIdentity();					// reset modelview matrix

	if(entering)
		{
		glColor3f(1,1,1);
		glRasterPos2i(250,20);
		PrintString(fontlist,"Congratulations!");
		if(yourscore==0)
			{
			glRasterPos2i(190,40);
			PrintString(fontlist,"YOU ARE THE BEST MEDIC EVER!");
			}
		else if(yourscore==SCORENUM-1)
			{
			glRasterPos2i(190,40);
			PrintString(fontlist,"You barely made the highscore list.");
			}
		else
			{
			glRasterPos2i(210,40);
			PrintString(fontlist,"You made the highscore list!");
			}
		glRasterPos2i(245,200);
		PrintString(fontlist,"Enter your 3 initials:");

		for(int e=0;e<3;e++)
			{
			char c[2];
			c[0]=score[yourscore].name[e];
			c[1]='\x0';
			if(enterslot==e)
				{
				unsigned char i=random(256);
				glColor3ub(i,i,0);
				}
			else glColor3f(1,1,1);
			glRasterPos2i(295+e*20,230);
			PrintString(fontlist,c);
			}
		}
	else
		{
		glColor3f(1,1,1);
		glRasterPos2i(225,20);
		PrintString(fontlist,"Best All-Time Medics");

		char num[20];

		for(int s=0;s<SCORENUM;s++)
			{
			if(s==yourscore&&s==0)glColor3ub(random(256),random(256),random(256));
			else if(s==yourscore)glColor3ub(random(128),random(128),random(128));
			else if(s==0)glColor3f(1,1,0);
			else if(s==SCORENUM-1)glColor3ub(70,30,10);
			else glColor3f(.5f,.5f,0);

			glRasterPos2i(120,50+s*20);
			itoa(s+1,num,10);
			strcat(num,".");
			PrintString(fontlist,num);

			char c[2];
			c[1]='\x0';
			glRasterPos2i(150,50+s*20);
			c[0]=score[s].name[0];
			PrintString(fontlist2,c);
			glRasterPos2i(160,50+s*20);
			c[0]=score[s].name[1];
			PrintString(fontlist2,c);
			glRasterPos2i(170,50+s*20);
			c[0]=score[s].name[2];
			PrintString(fontlist2,c);

			glRasterPos2i(240,50+s*20);
			itoa(score[s].score,num,10);
			PrintString(fontlist,num);

			glRasterPos2i(350,50+s*20);
			switch(score[s].death)
				{
				case -1:PrintString(fontlist,"KIA");break;
				case DEATH_POW:PrintString(fontlist,"Caught Behind Enemy Lines");break;
				case DEATH_SHOT_W:PrintString(fontlist,"Wounded by Gunfire");break;
				case DEATH_SHOT_F:PrintString(fontlist,"Shot in Face");break;
				case DEATH_SHOT_D:PrintString(fontlist,"Shot and Killed");break;
				case DEATH_MGSHOT_W:PrintString(fontlist,"Wounded by Machine Gunfire");break;
				case DEATH_MGSHOT_F:PrintString(fontlist,"Shot in Face by Machine Gun");break;
				case DEATH_MGSHOT_D:PrintString(fontlist,"Killed by Machine Gun");break;
				case DEATH_SHOVEL_BH:PrintString(fontlist,"Beheaded by Spade");break;
				case DEATH_SHOVEL_F:PrintString(fontlist,"Hit in Face by Spade");break;
				case DEATH_SHOVEL_D:PrintString(fontlist,"Killed by Spade");break;
				case DEATH_MORTAR_BU:PrintString(fontlist,"Vaporized by Mortar");break;
				case DEATH_MORTAR_BA:PrintString(fontlist,"Blown Apart by Mortar");break;
				case DEATH_MORTAR_W:PrintString(fontlist,"Wounded by Mortar");break;
				case DEATH_MORTAR_F:PrintString(fontlist,"Face Destroyed by Mortar");break;
				case DEATH_MORTAR_D:PrintString(fontlist,"Killed by Mortar");break;
				case DEATH_GRENADE_BA:PrintString(fontlist,"Blown Apart by Grenade");break;
				case DEATH_GRENADE_W:PrintString(fontlist,"Wounded by Grenade");break;
				case DEATH_GRENADE_F:PrintString(fontlist,"Face Blasted by Grenade");break;
				case DEATH_GRENADE_D:PrintString(fontlist,"Killed by Grenade");break;
				case DEATH_GAS:PrintString(fontlist,"Mustard Gas");break;
				case DEATH_BOMB_BU:PrintString(fontlist,"Vaporized by Bomb");break;
				case DEATH_BOMB_BA:PrintString(fontlist,"Blown Apart by Bomb");break;
				case DEATH_BOMB_W:PrintString(fontlist,"Wounded by Bomb");break;
				case DEATH_BOMB_F:PrintString(fontlist,"Face Ripped Off by Bomb");break;
				case DEATH_BOMB_D:PrintString(fontlist,"Killed by Bomb");break;
				case DEATH_STRAFE_BA:PrintString(fontlist,"Blown Apart by Biplane Fire");break;
				case DEATH_STRAFE_W:PrintString(fontlist,"Wounded during Biplane Strafe");break;
				case DEATH_STRAFE_F:PrintString(fontlist,"Shot in Face by Biplane");break;
				case DEATH_STRAFE_D:PrintString(fontlist,"Killed by Biplane Fire");break;
				case DEATH_GRENADE_BA_F:PrintString(fontlist,"Blown Apart by Friendly Grenade");break;
				case DEATH_GRENADE_W_F:PrintString(fontlist,"Wounded by Friendly Grenade");break;
				case DEATH_GRENADE_F_F:PrintString(fontlist,"Face Blasted by Friendly Grenade");break;
				case DEATH_GRENADE_D_F:PrintString(fontlist,"Killed by Friendly Grenade");break;
				case DEATH_SHOT_W_F:PrintString(fontlist,"Wounded by Friendly Fire");break;
				case DEATH_SHOT_F_F:PrintString(fontlist,"Shot in Face by Friendly");break;
				case DEATH_SHOT_D_F:PrintString(fontlist,"Shot and Killed by Friendly");break;
				case DEATH_MGSHOT_W_F:PrintString(fontlist,"Wounded by Friendly Machine Gunfire");break;
				case DEATH_MGSHOT_F_F:PrintString(fontlist,"Shot in Face by Friendly Machine Gun");break;
				case DEATH_MGSHOT_D_F:PrintString(fontlist,"Killed by Friendly Machine Gun");break;
				}
			}
		}
}

void loadhighscores(void)
{
	unsigned long loadversion;

	DWORD numbytes;
	HANDLE h=CreateFile("score.dat",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

	if(h!=INVALID_HANDLE_VALUE)
		{
		ReadFile(h,&loadversion,sizeof(unsigned long),&numbytes,NULL);

		if(loadversion<lowestloadscoreversion)
			{
			CloseHandle(h);
			return;
			}

		ReadFile(h,score,sizeof(scorest)*SCORENUM,&numbytes,NULL);

		CloseHandle(h);
		}
}

void savehighscores(void)
{
	loadhighscores();

	//PLACE THIS HIGH SCORE BY DATE IF NECESSARY
	yourscore=-1;

	for(int s=0;s<SCORENUM;s++)
		{
		if(curscore.score>score[s].score)
			{
			for(int s2=SCORENUM-1;s2>=s+1;s2--)
				{
				score[s2]=score[s2-1];
				}

			score[s]=curscore;
			score[s].name[0]='-';
			score[s].name[1]='-';
			score[s].name[2]='-';

			yourscore=s;
			entering=1;
			enterslot=0;
			break;
			}
		}
}

int compare(const void *a,const void *b)
{
	yorderst *u1=(yorderst *)a;
	yorderst *u2=(yorderst *)b;

	if(u1->y<u2->y)return -1;
	else return 1;
}